"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _AutoCompleteSuggestions = _interopRequireDefault(require("./AutoCompleteSuggestions"));

var _ListItem = _interopRequireDefault(require("../ListItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var AutoComplete =
/*#__PURE__*/
function (_Component) {
  _inherits(AutoComplete, _Component);

  function AutoComplete(_props) {
    var _this;

    _classCallCheck(this, AutoComplete);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AutoComplete).call(this, _props));

    _defineProperty(_assertThisInitialized(_this), "getDropDownList", function () {
      var listItems = [];
      var suggestions = _this.state.suggestions;

      if (!suggestions || suggestions.length === 0) {
        return null;
      }

      suggestions.forEach(function (suggestion, index) {
        if (suggestion) {
          listItems.push(_this.getListItemFromSourceSuggestion(suggestion, index));
        }
      });
      return _react["default"].createElement(_AutoCompleteSuggestions["default"], {
        refCallback: function refCallback(suggestionList) {
          _this.suggestionList = suggestionList;
        },
        style: {
          listStyleType: 'none',
          padding: '0px',
          margin: '0px'
        }
      }, listItems);
    });

    _defineProperty(_assertThisInitialized(_this), "getInputValue", function () {
      return _this.state.tempInputValue || _this.props.text;
    });

    _defineProperty(_assertThisInitialized(_this), "getListItemFromSourceSuggestion", function (suggestion, index) {
      return _react["default"].createElement(_ListItem["default"], {
        refCallback: function refCallback(listItem) {
          if (_this.state.selectedIndex === index) {
            _this.selectedListItem = listItem;
          }
        },
        additionalClasses: (0, _classnames["default"])('uifw-auto-complete__suggestion', {
          'uifw-auto-complete__suggestion--selected': _this.state.selectedIndex === index
        }),
        value: index,
        mouseDownCallback: _this.handleClickSuggestion,
        mouseOverCallback: _this.handleSuggestionMouseOver,
        key: suggestion.value + index
      }, suggestion.text);
    });

    _defineProperty(_assertThisInitialized(_this), "getOptionsForList", function (props) {
      if (typeof props.source === 'function') {
        return _this.executeSource(props);
      } else if (Array.isArray(props.source)) {
        return _this.defaultFilterSource(props);
      }

      return [];
    });

    _defineProperty(_assertThisInitialized(_this), "adjustItemForLowerBound", function (item, list) {
      var listHeight = list.getBoundingClientRect().height;
      var itemHeight = item.getBoundingClientRect().height;
      var itemOffsetTop = item.offsetTop;
      var itemOffestBottom = itemOffsetTop + itemHeight;
      var listScrollTop = list.scrollTop;

      if (itemOffestBottom > listHeight + listScrollTop) {
        list.scrollTop = itemOffestBottom - listHeight;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "adjustItemForUpperBound", function (item, list) {
      var itemOffsetTop = item.offsetTop;
      var listScrollTop = list.scrollTop;

      if (itemOffsetTop < listScrollTop) {
        list.scrollTop = itemOffsetTop;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "callChangeCallback", function (option) {
      if (_this.props.changeCallback) {
        _this.props.changeCallback(option);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "defaultFilter", function (props, item) {
      return item.text.toLowerCase().indexOf(props.text.toLowerCase().trim()) !== -1;
    });

    _defineProperty(_assertThisInitialized(_this), "defaultFilterSource", function (props) {
      var source = _this.extractSuggestions(props.source);

      return source.filter(_this.defaultFilter.bind(_assertThisInitialized(_this), props)).sort(_this.defaultSort.bind(_assertThisInitialized(_this), props));
    });

    _defineProperty(_assertThisInitialized(_this), "defaultSort", function (props, item1, item2) {
      var text = props.text.toLowerCase();
      var index1 = item1.text.toLowerCase().indexOf(text);
      var index2 = item2.text.toLowerCase().indexOf(text);
      return index1 - index2;
    });

    _defineProperty(_assertThisInitialized(_this), "executeSource", function (props) {
      var options = props.source(props.text);
      return _this.extractSuggestions(options);
    });

    _defineProperty(_assertThisInitialized(_this), "extractAutocompleteSource", function (item) {
      var hasValue = Object.prototype.hasOwnProperty.call(item, 'value');
      var hasText = Object.prototype.hasOwnProperty.call(item, 'text');

      if (hasValue && hasText) {
        return {
          value: item.value,
          text: _this.extractText(item.text)
        };
      }

      var text = hasText ? item.text : '';
      var value = hasValue ? item.value : text;
      return {
        value: value,
        text: value
      };
    });

    _defineProperty(_assertThisInitialized(_this), "extractSuggestions", function (array) {
      return array.map(function (item) {
        if (typeof item === 'string') {
          return {
            value: item,
            text: item
          };
        }

        if (_typeof(item) === 'object') {
          return _this.extractAutocompleteSource(item);
        }

        return null;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "extractText", function (text) {
      var zero = text === 0 ? '0' : '';
      return text ? text.toString() : zero;
    });

    _defineProperty(_assertThisInitialized(_this), "handleArrowDown", function (e) {
      e.preventDefault();
      var selectedIndex = _this.state.selectedIndex + 1;

      if (selectedIndex >= _this.state.suggestions.length) {
        selectedIndex = -1;
      }

      var tempInputValue = _this.state.suggestions[selectedIndex] ? _this.state.suggestions[selectedIndex].text : '';

      _this.setState({
        selectedIndex: selectedIndex,
        tempInputValue: tempInputValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleArrowLeft", function (e) {
      _this.selectCurrentSuggestionItem(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleArrowRight", function (e) {
      _this.selectCurrentSuggestionItem(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleArrowUp", function (e) {
      e.preventDefault();
      var selectedIndex = _this.state.selectedIndex - 1;

      if (selectedIndex === -2) {
        selectedIndex = _this.state.suggestions.length - 1;
      }

      var tempInputValue = _this.state.suggestions[selectedIndex] ? _this.state.suggestions[selectedIndex].text : '';

      _this.setState({
        selectedIndex: selectedIndex,
        tempInputValue: tempInputValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAutocompleteBlur", function (e) {
      _this.hideSuggestions();

      if (_this.props.blurCallback) {
        _this.props.blurCallback(e);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleAutocompleteChange", function (e) {
      _this.callChangeCallback({
        value: _this.props.value,
        text: e.target.value
      });

      _this.showSuggestions();
    });

    _defineProperty(_assertThisInitialized(_this), "handleAutocompleteKeyDown", function (e) {
      _this.handleFunctionKeyPress.call(_assertThisInitialized(_this), e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickSuggestion", function (e, index) {
      _this.hideSuggestions();

      _this.selectSuggestionItem(index);
    });

    _defineProperty(_assertThisInitialized(_this), "handleEnter", function (e) {
      _this.hideSuggestions();

      _this.selectCurrentSuggestionItem(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleEscape", function () {
      _this.hideSuggestions();
    });

    _defineProperty(_assertThisInitialized(_this), "handleFunctionKeyPress", function (e) {
      switch (e.key) {
        case 'ArrowDown':
          _this.handleArrowDown(e);

          break;

        case 'ArrowUp':
          _this.handleArrowUp(e);

          break;

        case 'ArrowLeft':
          _this.handleArrowLeft(e);

          break;

        case 'ArrowRight':
          _this.handleArrowRight(e);

          break;

        case 'Enter':
          _this.handleEnter(e);

          break;

        case 'Tab':
          _this.handleTab(e);

          break;

        case 'Escape':
          _this.handleEscape(e);

          break;

        default:
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleSuggestionMouseOver", function (e, index) {
      _this.setState({
        selectedIndex: index
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleTab", function (e) {
      _this.hideSuggestions();

      _this.selectCurrentSuggestionItem(e);
    });

    _defineProperty(_assertThisInitialized(_this), "hideSuggestions", function () {
      _this.setState({
        displaySuggestions: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "selectCurrentSuggestionItem", function () {
      var option = _this.state.suggestions[_this.state.selectedIndex] || {
        value: '',
        text: ''
      };

      if (_this.props.suggestionSelectedCallback) {
        _this.props.suggestionSelectedCallback(option);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "selectSuggestionItem", function (index) {
      var option = _this.state.suggestions[index] || {
        value: '',
        text: ''
      };

      if (_this.props.suggestionSelectedCallback) {
        _this.props.suggestionSelectedCallback(option);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "showSuggestions", function () {
      _this.setState({
        displaySuggestions: true
      });
    });

    _this.state = {
      displaySuggestions: false,
      selectedIndex: 0,
      suggestions: []
    };
    _this.handleSuggestionMouseOver = _this.handleSuggestionMouseOver.bind(_assertThisInitialized(_this));
    _this.handleClickSuggestion = _this.handleClickSuggestion.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(AutoComplete, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.suggestionList == null || this.selectedListItem == null) {
        return;
      }

      var item = this.selectedListItem;
      var list = this.suggestionList;
      this.adjustItemForLowerBound(item, list);
      this.adjustItemForUpperBound(item, list);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.text && nextProps.text !== this.props.text) {
        var filteredItems = this.getOptionsForList(nextProps);
        this.setState({
          suggestions: filteredItems,
          tempInputValue: '',
          selectedIndex: 0
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      this.selectedListItem = null;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-auto-complete', this.props.additionalClasses)
      }, _react["default"].createElement("input", {
        id: this.props.id,
        className: (0, _classnames["default"])('uifw-text-field uifw-auto-complete__field'),
        onChange: this.handleAutocompleteChange,
        onKeyDown: this.handleAutocompleteKeyDown,
        onBlur: this.handleAutocompleteBlur,
        placeholder: this.props.placeholder || '',
        type: "text",
        value: this.getInputValue()
      }), this.state.displaySuggestions && this.getDropDownList());
    }
  }]);

  return AutoComplete;
}(_react.Component);

AutoComplete.propTypes = {
  // Optional
  additionalClasses: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  blurCallback: _propTypes["default"].func,
  // Required
  id: _propTypes["default"].string.isRequired,
  text: _propTypes["default"].string.isRequired,
  value: _propTypes["default"].string.isRequired,
  changeCallback: _propTypes["default"].func.isRequired,
  suggestionSelectedCallback: _propTypes["default"].func.isRequired,
  source: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].func]).isRequired
};
AutoComplete.defaultProps = {
  additionalClasses: null,
  placeholder: null,
  blurCallback: function blurCallback() {}
};
var _default = AutoComplete;
exports["default"] = _default;