"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = require("lodash");

var _reactChartjs = require("react-chartjs-2");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BarChart =
/*#__PURE__*/
function (_Component) {
  _inherits(BarChart, _Component);

  function BarChart() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, BarChart);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(BarChart)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getCanvasDataUrl", function () {
      var canvas = _this.getCanvasElement();

      if (canvas != null) {
        return canvas.toDataURL();
      }

      return null;
    });

    _defineProperty(_assertThisInitialized(_this), "getCanvasElement", function () {
      var canvasElements = _this.wrapper.getElementsByTagName('canvas');

      var canvas = canvasElements[0];
      return canvas;
    });

    _defineProperty(_assertThisInitialized(_this), "getChart", function () {
      // We need to do this merge because chart.js mutates the data and causes errors in Redux.
      var data = (0, _lodash.merge)({}, _this.props.data);

      var options = _this.getOptions();

      switch (_this.props.type) {
        case 'horizontal':
          return _react["default"].createElement(_reactChartjs.HorizontalBar, {
            data: data,
            width: _this.props.width,
            height: _this.props.height,
            options: options
          });

        case 'vertical':
        default:
          return _react["default"].createElement(_reactChartjs.Bar, {
            data: data,
            width: _this.props.width,
            height: _this.props.height,
            options: options
          });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getHorizontalOptions", function () {
      return _objectSpread({
        animation: {
          onComplete: _this.generateCanvasImage
        },
        mantainAspectRatio: false,
        title: {
          display: _this.props.displayTitle
        },
        legend: {
          display: _this.props.displayLegend
        },
        tooltips: {
          callbacks: {
            label: function label(tooltipItem) {
              return _this.props.formatBarLabel ? _this.props.formatBarLabel(tooltipItem) : tooltipItem.xLabel;
            },
            title: function title(tooltipItem) {
              return _this.props.formatLineTitle ? _this.props.formatLineTitle(tooltipItem) : tooltipItem.yLabel;
            }
          }
        },
        scales: {
          display: false,
          yAxes: [{
            gridLines: {
              display: true
            }
          }],
          xAxes: [{
            categoryPercentage: 0.9,
            barPercentage: 1.0,
            ticks: {
              padding: 10,
              beginAtZero: true,
              callback: function callback(value) {
                return _this.props.formatXAxesValue ? _this.props.formatXAxesValue(value) : value;
              }
            }
          }]
        }
      }, _this.props.options);
    });

    _defineProperty(_assertThisInitialized(_this), "getImageElement", function () {
      var imageElements = _this.wrapper.getElementsByTagName('img');

      var image = imageElements[0];
      return image;
    });

    _defineProperty(_assertThisInitialized(_this), "getOptions", function () {
      switch (_this.props.type) {
        case 'horizontal':
          return _this.getHorizontalOptions();

        case 'vertical':
        default:
          return _this.getVerticalOptions();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "getVerticalOptions", function () {
      return _objectSpread({
        animation: {
          onComplete: _this.generateCanvasImage
        },
        mantainAspectRatio: false,
        title: {
          display: _this.props.displayTitle
        },
        legend: {
          display: _this.props.displayLegend
        },
        tooltips: {
          callbacks: {
            label: function label(tooltipItem) {
              return _this.props.formatBarLabel ? _this.props.formatBarLabel(tooltipItem) : tooltipItem.yLabel;
            },
            title: function title(tooltipItem) {
              return _this.props.formatLineTitle ? _this.props.formatLineTitle(tooltipItem) : tooltipItem.xLabel;
            }
          }
        },
        scales: {
          xAxes: [{
            gridLines: {
              display: true
            },
            barPercentage: 1,
            categoryPercentage: 0.9
          }],
          yAxes: [{
            ticks: {
              beginAtZero: true,
              callback: function callback(value) {
                return _this.props.formatYAxesValue ? _this.props.formatYAxesValue(value) : value;
              }
            }
          }]
        }
      }, _this.props.options);
    });

    _defineProperty(_assertThisInitialized(_this), "generateCanvasImage", function () {
      var canvasUrl = _this.getCanvasDataUrl();

      if (canvasUrl == null) {
        return;
      }

      var image = _this.getImageElement();

      if (image == null) {
        var canvas = _this.getCanvasElement();

        var imageNode = document.createElement('img');
        imageNode.setAttribute('id', 'barChartImage');
        imageNode.setAttribute('class', 'uifw-img u-hide');
        imageNode.setAttribute('src', canvasUrl);
        canvas.parentNode.appendChild(imageNode);
      } else {
        image.src = canvasUrl;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleMediaChange", function (data) {
      if (data.matches === true) {
        _this.replaceCanvasWithImage();
      } else {
        _this.resetCanvasRemoveImage();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "replaceCanvasWithImage", function () {
      var canvas = _this.getCanvasElement();

      var image = _this.getImageElement();

      canvas.className += ' u-hide';
      image.className = image.className.replace(' u-hide', '');
    });

    _defineProperty(_assertThisInitialized(_this), "resetCanvasRemoveImage", function () {
      var canvas = _this.getCanvasElement();

      var image = _this.getImageElement();

      canvas.className = canvas.className.replace(' u-hide', '');
      image.className += ' u-hide';
    });

    return _this;
  }

  _createClass(BarChart, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (window.onbeforeprint !== undefined) {
        window.onbeforeprint = this.replaceCanvasWithImage;
        window.onafterprint = this.resetCanvasRemoveImage;
      } else {
        var mediaQueryList = window.matchMedia('print');
        mediaQueryList.addListener(this.handleMediaChange);
      }
    }
  }, {
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      _reactChartjs.defaults.global.elements.rectangle.backgroundColor = 'rgba(19,114,209,0.9)';
      _reactChartjs.defaults.global.elements.rectangle.hoverBackgroundColor = 'rgba(19,114,209,0.1)';
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        ref: function ref(element) {
          _this2.wrapper = element;
        },
        id: this.props.chartId
      }, this.getChart());
    }
  }]);

  return BarChart;
}(_react.Component);

BarChart.propTypes = {
  chartId: _propTypes["default"].string,
  formatLineTitle: _propTypes["default"].func,
  type: _propTypes["default"].oneOf(['horizontal', 'vertical']),
  data: _propTypes["default"].shape({
    labels: _propTypes["default"].array,
    datasets: _propTypes["default"].arrayOf(_propTypes["default"].shape({
      backgroundColor: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)]),
      borderWidth: _propTypes["default"].number,
      hoverBackgroundColor: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)]),
      data: _propTypes["default"].arrayOf(_propTypes["default"].number)
    }))
  }).isRequired,
  width: _propTypes["default"].number,
  height: _propTypes["default"].number,
  displayTitle: _propTypes["default"].bool,
  displayLegend: _propTypes["default"].bool,
  formatXAxesValue: _propTypes["default"].func,
  formatYAxesValue: _propTypes["default"].func,
  formatBarLabel: _propTypes["default"].func,
  options: _propTypes["default"].shape({})
};
BarChart.defaultProps = {
  chartId: null,
  type: 'vertical',
  width: 7,
  height: 3,
  displayTitle: false,
  displayLegend: false,
  formatXAxesValue: null,
  formatYAxesValue: null,
  formatBarLabel: null,
  formatLineTitle: null,
  options: {}
};
var _default = BarChart;
exports["default"] = _default;