"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The Button component is a wrapper for the uifw button element. See <a href="http://internal-uifw/elements.html#buttons-buttons" target="_blank">Buttons</a> for more information.<p>
 */
var Button =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Button);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Button)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "clickHandler", function (e) {
      var event = e;
      var clickCallback = _this.props.clickCallback;
      event.target = event.target.tagName === 'BUTTON' ? event.target : event.target.parentNode;

      if (clickCallback) {
        clickCallback(event);
      }
    });

    return _this;
  }

  _createClass(Button, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var inputId = this.props.inputId;

      if (inputId) {
        this.node.id = this.props.inputId;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var opts = {};
      var props = this.props;

      if (props.hint && !props.disabled) {
        // eslint-disable-next-line dot-notation
        opts['title'] = props.hint;
        opts['data-uifw-hint'] = props.hint;
      }

      if (props.gtmEvent) {
        opts['data-gtm-event'] = props.gtmEvent;
      }

      if (props.value) {
        // eslint-disable-next-line dot-notation
        opts['value'] = props.value;
      }

      return _react["default"].createElement("button", _extends({
        ref: function ref(node) {
          _this2.node = node;
        },
        type: "button",
        className: (0, _classnames["default"])('uifw-button', props.cssClass),
        onClick: this.clickHandler,
        disabled: props.disabled === true ? 'disabled' : ''
      }, opts), props.icon && (props.icon.indexOf(' right') === -1 || props.icon.indexOf(' right') === -1) ? _react["default"].createElement("i", {
        className: props.icon
      }) : null, props.buttonText, props.icon && (props.icon.indexOf(' right') > -1 || props.icon.indexOf(' right') > -1) ? _react["default"].createElement("i", {
        className: props.icon
      }) : null);
    }
  }]);

  return Button;
}(_react["default"].Component);

_defineProperty(Button, "defaultProps", {
  clickCallback: null,
  cssClass: '',
  icon: '',
  disabled: false,
  value: '',
  hint: '',
  inputId: '',
  gtmEvent: ''
});

_defineProperty(Button, "propTypes", {
  /**
   * The text value of the button
   <<example>> buttonText="string"
   */
  buttonText: _propTypes["default"].string.isRequired,

  /**
   * The callback function to execute on component click
   <<example>> clickCallback={self.handleButtonClick}
   */
  clickCallback: _propTypes["default"].func,

  /**
   * The CSS class names that the button should have
   <<example>> cssClass="string"
   */
  cssClass: _propTypes["default"].string,

  /**
   * The icon class name that will be prepended to the button
   <<example>> icon="uifw-icon-search"
   */
  icon: _propTypes["default"].string,

  /**
   * Sets the disabled attribute on a button
   <<example>> disabled={true}
   */
  disabled: _propTypes["default"].bool,

  /**
   * The hidden value of the button
   <<example>> value="string"
   */
  value: _propTypes["default"].string,

  /**
   * The value to be displayed when a user hovers over the component
   <<example>> hint="string"
   */
  hint: _propTypes["default"].string,

  /**
   * The optional id of the button
   <<example>> inputId="string"
   */
  inputId: _propTypes["default"].string,

  /**
   * The optional Google Analytics Tracking event
   */
  gtmEvent: _propTypes["default"].string
});

var _default = Button;
exports["default"] = _default;