"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _TextArea = _interopRequireDefault(require("../TextArea"));

var _jquery = _interopRequireDefault(require("jquery"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var buildInterval;
var buildAttemptCount;
var originalLC = window.lc;

var CKEditor =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CKEditor, _React$Component);

  function CKEditor() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CKEditor);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CKEditor)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_handleValidation", function () {
      if (document.getElementById('react-ckeditor').className.indexOf('invalid') > -1) {
        document.getElementById('cke_react-ckeditor').className += ' invalid';
        document.getElementById('cke_react-ckeditor').style.borderColor = '#f39c12';
      } else {
        document.getElementById('cke_react-ckeditor').className = document.getElementById('cke_react-ckeditor').className.replace('invalid', '');
        document.getElementById('cke_react-ckeditor').style.borderColor = '';
      }
    });

    return _this;
  }

  _createClass(CKEditor, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var self = this;
      document.getElementById('react-ckeditor').className += ' u-hide';

      function intervalTrigger() {
        return window.setInterval(function () {
          if (typeof window.CKEDITOR != 'undefined') {
            // clearing the interval if an instance of the editor already exists
            if (window.CKEDITOR.instances["react-ckeditor"]) {
              window.clearInterval(buildInterval);
            }

            var editor = window.CKEDITOR.replace('react-ckeditor', {
              extraPlugins: 'ekmdataprocessor',
              toolbar: self.props.toolbar || 'EkmToolbar',
              enterMode: CKEDITOR.ENTER_P,
              fillEmptyBlocks: false,
              entities_latin: false,
              allowedContent: true,
              entities: false,
              entities_additional: ''
            });
            window.nanospell.ckeditor('react-ckeditor', {
              dictionary: 'en',
              server: 'asp.net',
              ignore_block_caps: true
            });
            editor.on('instanceReady', function () {
              var sourceButton = document.getElementsByClassName('cke_button cke_button__source cke_button_off')[0];
              sourceButton.addEventListener('click', function () {
                if (document.getElementsByClassName('cke_button cke_button__source cke_button_off').length === 0) {
                  var sourceTextArea = document.getElementsByClassName('cke_source')[0];

                  if (sourceTextArea != null) {
                    sourceTextArea.addEventListener('change', function (e) {
                      if (self.props.onChange) {
                        self.props.onChange(e.target.value);
                      }

                      self.ckeditorTextarea._handleKeystroke({
                        target: {
                          value: e.target.value
                        }
                      });

                      self._handleValidation();
                    });
                  }
                }
              });
            });
            editor.on('change', function (e) {
              var editorValue = editor.getData();

              if (self.props.onChange) {
                self.props.onChange(editorValue);
              }

              self.ckeditorTextarea._handleKeystroke({
                target: {
                  value: editorValue
                }
              });

              self._handleValidation();
            });
            editor.on('blur', function (e) {
              if (self.ckeditorTextarea) {
                self.ckeditorTextarea._handleBlur({
                  target: {
                    value: self.props.value
                  }
                });

                self._handleValidation();
              }
            });
            _jquery["default"].ui.dialog.prototype._focusTabbable = _jquery["default"].noop;
            buildAttemptCount++;

            if (buildInterval != null || buildAttemptCount > 20) {
              if (buildAttemptCount > 20) {
                console.warn('failed to build React CKEditor');
              }

              window.clearInterval(buildInterval);
            } // this is to stop the ckeditor dropdown bugs when rendered in a dialog


            (0, _jquery["default"])('.ui-dialog.ui-widget.ui-widget-content.uifw-dialog-actions.ui-dialog-buttons').unbind('mousedown');
          }

          window.addEventListener('formValidationComplete', self._handleValidation);
        }, 250);
      }

      buildInterval = intervalTrigger();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('formValidationComplete', self._handleValidation);
      window.lc = originalLC;
    }
  }, {
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      window.lc = function (stirng) {
        return stirng;
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement(_TextArea["default"], {
        ref: function ref(ckeditorTextarea) {
          _this2.ckeditorTextarea = ckeditorTextarea;
        },
        inputId: "react-ckeditor",
        value: this.props.value,
        callback: function callback() {},
        validation: this.props.validation,
        validationCssClasses: "invalid bottom right"
      });
    }
  }]);

  return CKEditor;
}(_react["default"].Component);

_defineProperty(CKEditor, "propTypes", {
  value: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  toolbar: _propTypes["default"].string
});

var _default = CKEditor;
exports["default"] = _default;