"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _jquery = _interopRequireDefault(require("jquery"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// var $ = require('jquery');
var PropTypes = require('prop-types');

var React = require('react');

var ReactDOM = require('react-dom');

var getInputNode = function getInputNode(domNode) {
  return (0, _jquery["default"])((0, _jquery["default"])(domNode)[0]).children()[0];
};

var getCheckboxDiv = function getCheckboxDiv(domNode) {
  return (0, _jquery["default"])((0, _jquery["default"])(domNode)[0]).children()[1];
};

var setCheckedValue = function setCheckedValue(domNode, checked) {
  if (checked || parseInt(checked)) {
    getInputNode(domNode).setAttribute("checked", "checked");
    (0, _jquery["default"])(getCheckboxDiv(domNode)).addClass('checked');
  } else {
    getInputNode(domNode).removeAttribute("checked");
    (0, _jquery["default"])(getCheckboxDiv(domNode)).removeClass('checked');
  }
};
/**
 * <p>The Checkbox component is the uifw version of the checkbox div. See <a href="http://internal-uifw/elements.html#form-els-checkboxes" target="_blank">Checkboxes</a> for more information.</p>
 */


var Checkbox =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Checkbox, _React$Component);

  function Checkbox() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Checkbox);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Checkbox)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_onChange", function (event) {
      _this.props.callback(event);
    });

    return _this;
  }

  _createClass(Checkbox, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.checked !== undefined) {
        (0, _jquery["default"])(getInputNode(ReactDOM.findDOMNode(this))).uifwFrmCheckbox();
        (0, _jquery["default"])(getInputNode(ReactDOM.findDOMNode(this))).change(this._onChange);
        setCheckedValue(ReactDOM.findDOMNode(this), this.props.checked);
        this.setState({
          lastChange: this.props.checked
        });

        if (this.props.inputId) {
          getInputNode(ReactDOM.findDOMNode(this)).id = this.props.inputId + "Input";
          var checkBoxDiv = (0, _jquery["default"])('div.uifw-checkbox', ReactDOM.findDOMNode(this).parentNode)[0];
          checkBoxDiv.id = this.props.inputId + "Div";
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (!this.props.disabled) {
        setCheckedValue(ReactDOM.findDOMNode(this), this.props.checked);
      }

      ;
    }
  }, {
    key: "render",
    value: function render() {
      var labelCssClass = this.props.labelTextCss == null ? "u-pl--" : this.props.labelTextCss;
      var label = this.props.labelText ? React.createElement("label", {
        className: labelCssClass,
        htmlFor: this.props.id
      }, this.props.labelText) : null;
      return React.createElement("div", {
        className: this.props.containerClass,
        style: this.props.style
      }, React.createElement("input", {
        id: this.props.id,
        type: "checkbox",
        value: this.props.value,
        disabled: this.props.disabled
      }), label);
    }
  }]);

  return Checkbox;
}(React.Component);

_defineProperty(Checkbox, "defaultProps", {
  checked: false,
  value: ""
});

_defineProperty(Checkbox, "propTypes", {
  id: PropTypes.string,
  labelText: PropTypes.string,

  /**
     * The CSS Class of the wrapping DIV element
     <<example>> containerCssClass="testClass"
     */
  containerClass: PropTypes.string,

  /**
    * The callback function to execute on checkbox click
    <<example>> callback={self.handleCheckboxClick}
    */
  callback: PropTypes.func.isRequired,

  /**
    * The inline style passed to the wrapping div
    <<example>> style={
      {
        marginTop: "20px",
        padding: "5px",
        background-color: blue
      }
     }
    */
  style: PropTypes.object,

  /**
   * The value of the checkbox
   <<example>> checked={true}
   */
  checked: PropTypes.bool,

  /**
   * The string value of the actual checkbox
   <<example>> value="string"
   */
  value: PropTypes.string,

  /**
   * The id of the div that is displayed on screen
   <<example>> inputId="string"
   */
  inputId: PropTypes.string,

  /**
   * Sets the checkbox to disabled if set to true
   <<example>> disabled={true}
   */
  disabled: PropTypes.bool
});

var _default = Checkbox;
exports["default"] = _default;