"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var _ = require("underscore");

var brace = require("brace");

var AceEditor = require("react-ace"); // Brace syntax highlight themes.


require("brace/mode/html");

require("brace/mode/javascript");

require("brace/mode/css"); // Brace themes.


require("brace/theme/xcode");

require("brace/ext/searchbox");

var warnNotSet = function warnNotSet(val) {
  return console.warn("uifw.CodeEditor: " + val + " not set.");
};
/**
 * A wrapper around the Ace Editor, for editing code snippets.
  <example><uifw.CodeEditor
    mode="css"
    name="SOMETHING_UNIQUE"
    onChange={(val) => this.setState({ FileContent: val })}
    value={this.state.FileContent} />
 */


var CodeEditor =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CodeEditor, _React$Component);

  function CodeEditor() {
    _classCallCheck(this, CodeEditor);

    return _possibleConstructorReturn(this, _getPrototypeOf(CodeEditor).apply(this, arguments));
  }

  _createClass(CodeEditor, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._onChange = _.debounce(this.props.onChange, 500);
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(AceEditor, _extends({}, this.props, {
        onChange: this._onChange
      }));
    }
  }]);

  return CodeEditor;
}(React.Component);

_defineProperty(CodeEditor, "defaultProps", {
  onChange: _.once(function () {
    return warnNotSet("onChange");
  }),
  width: "100%",
  theme: "xcode"
});

_defineProperty(CodeEditor, "propTypes", {
  /**
   * The mode controls syntax highlighting of the code within the file.
   * Available options are css, javascript, or html.
   */
  mode: PropTypes.string,

  /**
   * The theme of the editor. This defaults to xcode.
   */
  theme: PropTypes.string,

  /**
   * A unique ID to assign to the editor.
   */
  name: PropTypes.string,

  /**
   * A height to assign to the editor. Defaults to 500px
   */
  height: PropTypes.string,

  /**
   * A width to assign to the editor. Defaults to 100%
   */
  width: PropTypes.string,

  /**
   * Controls the font size of the text within the editor.
   */
  fontSize: PropTypes.number,

  /**
   * Enables or disables the gutter down the left of the page.
   * Defaults to true.
   */
  showGutter: PropTypes.bool,

  /**
   * A function to be called when the text within the editor is changed.
   * Any passed in function will be debounced to prevent spam calls,
   * so the function will be called 500ms after the user stops typing.
   */
  onChange: PropTypes.func,

  /**
   * The default value to display.
   * Made available by the Ace Editor, but doesn't seem to work,
   *  use value instead.
   */
  defaultValue: PropTypes.string,

  /**
   * The current value to be displayed inside the editor.
   */
  value: PropTypes.string,

  /**
   * Called on ComponentDidMount, passing in the editor instance.
   */
  onLoad: PropTypes.func,

  /**
   * The maximum number of lines to allow the input to reach.
   * Defaults to having no maximum.
   */
  maxLines: PropTypes.number,

  /**
   * If set to true, the editor will be read only.
   * Defaults to false.
   */
  readOnly: PropTypes.bool,

  /**
   * Enables or disables highlighting the currently selected line.
   * Defaults to true.
   */
  highlightActiveLine: PropTypes.bool,

  /**
   * If enabled, the print margin will be shown in the editor.
   * Defaults to true.
   */
  showPrintMargin: PropTypes.bool,

  /**
   * If enabled the first line of the content will be selected.
   * Defaults to false.
   */
  selectFirstLine: PropTypes.bool,

  /**
   * Enable word wrapping.
   * Defaults to false.
   */
  wrapEnabled: PropTypes.bool
});

var _default = CodeEditor;
exports["default"] = _default;