"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var classNames = require('classnames');

var CollapsibleFormRowHeader =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CollapsibleFormRowHeader, _React$Component);

  function CollapsibleFormRowHeader() {
    _classCallCheck(this, CollapsibleFormRowHeader);

    return _possibleConstructorReturn(this, _getPrototypeOf(CollapsibleFormRowHeader).apply(this, arguments));
  }

  _createClass(CollapsibleFormRowHeader, [{
    key: "render",
    value: function render() {
      var icon = null;
      var children = this.props.children;

      if (this.props.hasIcon && React.Children.count(this.props.children) !== 1) {
        icon = React.createElement("div", {
          className: "uifw-collapsible-row-header-title-icon"
        }, children[0]);
        children = React.Children.map(this.props.children, function ExtractChildren(child, i) {
          if (i !== 0) return child;
        });
      }

      return React.createElement("div", {
        className: classNames("uifw-collapsible-row-header", this.props.additionalCss)
      }, React.createElement("div", {
        className: classNames("uifw-collapsible-row-header-title", {
          "with-icon": this.props.hasIcon
        })
      }, icon, React.createElement("div", {
        className: "uifw-collapsible-row-header-title-text"
      }, children)), React.createElement("div", {
        className: "uifw-collapsible-row-header-icon"
      }));
    }
  }]);

  return CollapsibleFormRowHeader;
}(React.Component);

_defineProperty(CollapsibleFormRowHeader, "propTypes", {
  //optional
  hasIcon: PropTypes.bool,
  additionalCss: PropTypes.string
});

var _default = CollapsibleFormRowHeader;
exports["default"] = _default;