"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var ReactDOM = require('react-dom');

var classNames = require('classnames');

var $ = require('jquery');
/**
 * <p>The Collapsible Row component is similar to the Form Row component but
 * this also has the functionality of being collapsible when the user clicks
 * on the header of the component. See <a href="http://internal-uifw/docs/sections.html#sections-collapsible" target="_blank">Collapsible Sections</a> for more information.</p>
 */


var CollapsibleRow =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CollapsibleRow, _React$Component);

  function CollapsibleRow() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CollapsibleRow);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CollapsibleRow)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_isDocumentReadyComplete", function () {
      return document.readyState === "complete";
    });

    return _this;
  }

  _createClass(CollapsibleRow, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this._isDocumentReadyComplete()) {
        $(ReactDOM.findDOMNode(this)).uifwCollapsibleRow();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          id = _this$props.id,
          label = _this$props.label,
          description = _this$props.description,
          iconCssClass = _this$props.iconCssClass,
          flagCountry = _this$props.flagCountry,
          children = _this$props.children;
      var descriptionOutput = description ? React.createElement("p", {
        className: "uifw-label-details"
      }, description) : null;
      var titleCss = 'uifw-collapsible-row-header-title';
      var icon = null;

      if (iconCssClass && iconCssClass.length > 0 || flagCountry && flagCountry.length > 0) {
        titleCss += ' with-icon';

        if (flagCountry && flagCountry.length > 0) {
          icon = React.createElement("i", {
            className: "uifw-icon-flags",
            "data-uifw-flags-country": flagCountry
          });
        } else {
          icon = React.createElement("i", {
            className: classNames('uifw-icon', iconCssClass)
          });
        }

        icon = React.createElement("div", {
          className: "uifw-collapsible-row-header-title-icon"
        }, icon);
      }

      return React.createElement("div", {
        className: "uifw-collapsible-row",
        ref: function ref(node) {
          _this2.node = node;
        },
        id: id
      }, React.createElement("div", {
        className: "uifw-collapsible-row-header"
      }, React.createElement("div", {
        className: titleCss
      }, icon, React.createElement("label", {
        className: "uifw-label"
      }, label), descriptionOutput), React.createElement("div", {
        className: "uifw-collapsible-row-header-icon"
      })), React.createElement("div", {
        className: "uifw-collapsible-row-content"
      }, children));
    }
  }]);

  return CollapsibleRow;
}(React.Component);

_defineProperty(CollapsibleRow, "propTypes", {
  /**
   * The id given to the collapsible row
  <<example>> label="string"
   */
  id: PropTypes.string,

  /**
   * The label header text of the collapsible row
  <<example>> label="string"
   */
  label: PropTypes.string.isRequired,

  /**
   * The collapsible row description that sits below the title
  <<example>> description="string"
   */
  description: PropTypes.string,

  /**
   * The icon class that is displayed before the title
  <<example>> iconCssClass="uifw-icon-search"
   */
  iconCssClass: PropTypes.string,

  /**
   * The flag country to display before the collapsible row title instead of
   * an icon
  <<example>> flagCountry="GB"
   */
  flagCountry: PropTypes.string,

  /**
   * All HTML content that is displayed within the collapsible row
  <<example>><uifw.SectionContent>
   *  <SectionItems>...</SectionItems>
   *</uifw.SectionContent>
   */
  children: PropTypes.any
});

_defineProperty(CollapsibleRow, "defaultProps", {
  id: null,
  description: null,
  iconCssClass: '',
  flagCountry: '',
  children: null
});

var _default = CollapsibleRow;
exports["default"] = _default;