"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _jquery = _interopRequireDefault(require("jquery"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The Colour Picker component displays a colour picker on screen and actions a
 * callback when the user selects a colour. See <a href="http://internal-uifw/elements.html#misc-colour-picker" target="_blank">Colour Picker</a> for more information.</p>
 */
var ColourPicker =
/*#__PURE__*/
function (_Component) {
  _inherits(ColourPicker, _Component);

  function ColourPicker(props) {
    var _this;

    _classCallCheck(this, ColourPicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ColourPicker).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onChange", function (event) {
      _this.props.callback(event);
    });

    _defineProperty(_assertThisInitialized(_this), "build", function () {
      if (_this.props.value !== undefined && _this.props.value.length > 0) {
        (0, _jquery["default"])(_this.mainInput).on('change', _this.onChange);
        (0, _jquery["default"])(_this.mainInput).uifwColorPicker('build');
        (0, _jquery["default"])(_this.wrapperDiv).find('input')[0].id = 'colourPickerHiddenValue';
        (0, _jquery["default"])(_this.wrapperDiv).find('span')[0].id = 'colourPickerSpan';
      }
    });

    _defineProperty(_assertThisInitialized(_this), "update", function () {
      if (_this.props.value !== undefined && _this.props.value.length > 0 && _this.state.isBuilt) {
        _this.mainInput.value = _this.props.value;
        (0, _jquery["default"])(_this.mainInput).uifwColorPicker('updateColor');
      }
    });

    _this.state = {
      isBuilt: false
    };
    return _this;
  }

  _createClass(ColourPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.build();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.update();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var $wrapper = (0, _jquery["default"])('.uifw-color-picker-wrapper');

      if ($wrapper != null && $wrapper.length > 0) {
        $wrapper.remove();
      }

      var $overlay = (0, _jquery["default"])('.uifw-color-picker-overlay');

      if ($overlay != null && $overlay.length > 0) {
        $overlay.remove();
      }

      this.setState({
        isBuilt: false
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      // Input does not have className="uifw-colour-picker" because we want to control
      // the colour picker events to hijack them for the react lifecycle.
      // The empty onChange is to prevent an error message from react. :mask:
      return _react["default"].createElement("div", {
        ref: function ref(wrapperDiv) {
          _this2.wrapperDiv = wrapperDiv;
        }
      }, _react["default"].createElement("input", {
        ref: function ref(mainInput) {
          _this2.mainInput = mainInput;
        },
        id: this.props.inputId,
        type: "text",
        value: this.props.value,
        onChange: function onChange() {}
      }));
    }
  }]);

  return ColourPicker;
}(_react.Component);

ColourPicker.propTypes = {
  /**
   * The string value of the selected colour
   <<example>> value="#FFF"
   */
  value: _propTypes["default"].string.isRequired,

  /**
   * The callback function that executes when a new colour is selected
   <<example>> callback={self.handleColourChange}
   */
  callback: _propTypes["default"].func.isRequired,

  /**
   * The input id given to the colour picker and the hidden input
   <<example>> inputId="string"
   */
  inputId: _propTypes["default"].string
};
ColourPicker.defaultProps = {
  inputId: ''
};
var _default = ColourPicker;
exports["default"] = _default;