"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var Countries = {
  AF: {
    alternativeSpellings: ['Afghanistan', 'افغانستان'],
    text: 'Afghanistan'
  },
  AL: {
    alternativeSpellings: ['Albania'],
    text: 'Albania'
  },
  DZ: {
    alternativeSpellings: ['Algeria', 'الجزائر'],
    text: 'Algeria'
  },
  AS: {
    alternativeSpellings: ['American Samoa'],
    relevancyBooster: '0.5',
    text: 'American Samoa'
  },
  AD: {
    alternativeSpellings: ['Andorra'],
    relevancyBooster: '0.5',
    text: 'Andorra'
  },
  AO: {
    alternativeSpellings: ['Angola'],
    text: 'Angola'
  },
  AI: {
    alternativeSpellings: ['Anguilla'],
    relevancyBooster: '0.5',
    text: 'Anguilla'
  },
  AQ: {
    alternativeSpellings: ['Antarctica'],
    relevancyBooster: '0.5',
    text: 'Antarctica'
  },
  AG: {
    alternativeSpellings: ['Antigua And Barbuda'],
    relevancyBooster: '0.5',
    text: 'Antigua And Barbuda'
  },
  AR: {
    alternativeSpellings: ['Argentina'],
    text: 'Argentina'
  },
  AM: {
    alternativeSpellings: ['Armenia Հայաստան'],
    text: 'Armenia'
  },
  AW: {
    alternativeSpellings: ['Aruba'],
    relevancyBooster: '0.5',
    text: 'Aruba'
  },
  AU: {
    alternativeSpellings: ['Australia'],
    relevancyBooster: '1.5',
    text: 'Australia'
  },
  AT: {
    alternativeSpellings: ['Austria', 'Österreich', 'Osterreich', 'Oesterreich'],
    text: 'Austria'
  },
  AZ: {
    alternativeSpellings: ['Azerbaijan'],
    text: 'Azerbaijan'
  },
  BS: {
    alternativeSpellings: ['Bahamas'],
    text: 'Bahamas'
  },
  BH: {
    alternativeSpellings: ['Bahrain', 'البحرين'],
    text: 'Bahrain'
  },
  BD: {
    alternativeSpellings: ['Bangladesh', 'বাংলাদেশ'],
    relevancyBooster: '2',
    text: 'Bangladesh'
  },
  BB: {
    alternativeSpellings: ['Barbados'],
    text: 'Barbados'
  },
  BY: {
    alternativeSpellings: ['Belarus', 'Беларусь'],
    text: 'Belarus'
  },
  BE: {
    alternativeSpellings: ['Belgium', 'België', 'Belgie', 'Belgien', 'Belgique'],
    relevancyBooster: '1.5',
    text: 'Belgium'
  },
  BZ: {
    alternativeSpellings: ['Belize'],
    text: 'Belize'
  },
  BJ: {
    alternativeSpellings: ['Benin'],
    text: 'Benin'
  },
  BM: {
    alternativeSpellings: ['Bermuda'],
    relevancyBooster: '0.5',
    text: 'Bermuda'
  },
  BT: {
    alternativeSpellings: ['Bhutan', 'भूटान'],
    text: 'Bhutan'
  },
  BO: {
    alternativeSpellings: ['Bolivia'],
    text: 'Bolivia'
  },
  BA: {
    alternativeSpellings: ['Bosnia and Herzegovina', 'BiH', 'Bosna i Hercegovina', 'Босна и Херцеговина'],
    text: 'Bosnia and Herzegowina'
  },
  BW: {
    alternativeSpellings: ['Botswana'],
    text: 'Botswana'
  },
  BV: {
    alternativeSpellings: ['Bouvet Island'],
    text: 'Bouvet Island'
  },
  BR: {
    alternativeSpellings: ['Brazil', 'Brasil'],
    relevancyBooster: '2',
    text: 'Brazil'
  },
  IO: {
    alternativeSpellings: ['British Indian Ocean Territory'],
    text: 'British Indian Ocean Territory'
  },
  BN: {
    alternativeSpellings: ['Brunei Darussalam'],
    text: 'Brunei Darussalam'
  },
  BG: {
    alternativeSpellings: ['Bulgaria', 'България'],
    text: 'Bulgaria'
  },
  BF: {
    alternativeSpellings: ['Burkina Faso'],
    text: 'Burkina Faso'
  },
  BI: {
    alternativeSpellings: ['Burundi'],
    text: 'Burundi'
  },
  KH: {
    alternativeSpellings: ['Cambodia', 'កម្ពុជា'],
    text: 'Cambodia'
  },
  CM: {
    alternativeSpellings: ['Cameroon'],
    text: 'Cameroon'
  },
  CA: {
    alternativeSpellings: ['Canada'],
    relevancyBooster: '2',
    text: 'Canada'
  },
  IC: {
    alternativeSpellings: ['Canary Islands (Spain)'],
    text: 'Canary Islands (Spain)'
  },
  CV: {
    alternativeSpellings: ['Cape Verde', 'Cabo Verde'],
    text: 'Cape Verde'
  },
  KY: {
    alternativeSpellings: ['Cayman Islands'],
    relevancyBooster: '0.5',
    text: 'Cayman Islands'
  },
  CF: {
    alternativeSpellings: ['Central African Republic'],
    text: 'Central African Republic'
  },
  EA: {
    alternativeSpellings: ['Ceuta and Melilla'],
    text: 'Ceuta and Melilla'
  },
  TD: {
    alternativeSpellings: ['Chad', 'تشاد&lrm', 'Tchad'],
    text: 'Chad'
  },
  CL: {
    alternativeSpellings: ['Chile'],
    text: 'Chile'
  },
  CN: {
    alternativeSpellings: ['China', 'Zhongguo', 'Zhonghua', 'Peoples Republic', '中国/中华'],
    relevancyBooster: '3',
    text: 'China'
  },
  CX: {
    alternativeSpellings: ['Christmas Island'],
    relevancyBooster: '0.5',
    text: 'Christmas Island'
  },
  CC: {
    alternativeSpellings: ['Cocos (Keeling) Islands'],
    relevancyBooster: '0.5',
    text: 'Cocos (Keeling) Islands'
  },
  CO: {
    alternativeSpellings: ['Colombia'],
    text: 'Colombia'
  },
  KM: {
    alternativeSpellings: ['Comoros', 'جزر القمر'],
    text: 'Comoros'
  },
  CG: {
    alternativeSpellings: ['Congo'],
    text: 'Congo'
  },
  CD: {
    alternativeSpellings: ['Congo, the Democratic Republic of the', 'Congo-Brazzaville', 'Repubilika ya Kongo'],
    text: 'Congo, the Democratic Republic of the'
  },
  CK: {
    alternativeSpellings: ['Cook Islands'],
    relevancyBooster: '0.5',
    text: 'Cook Islands'
  },
  CR: {
    alternativeSpellings: ['Costa Rica'],
    text: 'Costa Rica'
  },
  CI: {
    alternativeSpellings: ['Cote d\'Ivoire', 'Cote dIvoire'],
    text: 'Côte d\'Ivoire'
  },
  HR: {
    alternativeSpellings: ['Croatia Hrvatska'],
    text: 'Croatia'
  },
  CU: {
    alternativeSpellings: ['Cuba'],
    text: 'Cuba'
  },
  CY: {
    alternativeSpellings: ['Cyprus', 'Κύπρος', 'Kýpros', 'Kıbrıs'],
    text: 'Cyprus'
  },
  CZ: {
    alternativeSpellings: ['Czech Republic', 'Česká', 'Ceska'],
    text: 'Czech Republic'
  },
  DK: {
    alternativeSpellings: ['Denmark', 'Danmark'],
    relevancyBooster: '1.5',
    text: 'Denmark'
  },
  DJ: {
    alternativeSpellings: ['Djibouti', 'جيبوتي&lrm;', 'Jabuuti', 'Gabuuti'],
    text: 'Djibouti'
  },
  DM: {
    alternativeSpellings: ['Dominica', 'Dominique'],
    relevancyBooster: '0.5',
    text: 'Dominica'
  },
  DO: {
    alternativeSpellings: ['Dominican Republic'],
    text: 'Dominican Republic'
  },
  TP: {
    alternativeSpellings: ['East Timor'],
    text: 'East Timor'
  },
  EC: {
    alternativeSpellings: ['Ecuador'],
    text: 'Ecuador'
  },
  EG: {
    alternativeSpellings: ['Egypt'],
    relevancyBooster: '1.5',
    text: 'Egypt'
  },
  SV: {
    alternativeSpellings: ['El Salvador'],
    text: 'El Salvador'
  },
  EE: {
    alternativeSpellings: ['Estonia Eesti'],
    text: 'Estonia'
  },
  ET: {
    alternativeSpellings: ['Ethiopia', 'ኢትዮጵያ'],
    text: 'Ethiopia'
  },
  FK: {
    alternativeSpellings: ['Falkland Islands (Malvinas)'],
    relevancyBooster: '0.5',
    text: 'Falkland Islands (Malvinas)'
  },
  FO: {
    alternativeSpellings: ['Faroe Islands', 'Føroyar Færøerne'],
    relevancyBooster: '0.5',
    text: 'Faroe Islands'
  },
  FJ: {
    alternativeSpellings: ['Fiji', 'Viti', 'फ़िजी'],
    text: 'Fiji'
  },
  FI: {
    alternativeSpellings: ['Finland', 'Suomi'],
    text: 'Finland'
  },
  FR: {
    alternativeSpellings: ['France', 'République française'],
    relevancyBooster: '2.5',
    text: 'France'
  },
  GF: {
    alternativeSpellings: ['French Guiana'],
    text: 'French Guiana'
  },
  PF: {
    alternativeSpellings: ['French Polynesia', 'Polynésie française'],
    text: 'French Polynesia'
  },
  TF: {
    alternativeSpellings: ['French Southern Territories'],
    text: 'French Southern Territories'
  },
  GA: {
    alternativeSpellings: ['Gabon', 'République Gabonaise'],
    text: 'Gabon'
  },
  GM: {
    alternativeSpellings: ['Gambia'],
    text: 'Gambia'
  },
  GE: {
    alternativeSpellings: ['Georgia', 'საქართველო'],
    text: 'Georgia'
  },
  DE: {
    alternativeSpellings: ['Germany', 'Bundesrepublik Deutschland'],
    relevancyBooster: '3',
    text: 'Germany'
  },
  GH: {
    alternativeSpellings: ['Ghana'],
    text: 'Ghana'
  },
  GI: {
    alternativeSpellings: ['Gibraltar'],
    relevancyBooster: '0.5',
    text: 'Gibraltar'
  },
  GR: {
    alternativeSpellings: ['Greece', 'Ελλάδα'],
    relevancyBooster: '1.5',
    text: 'Greece'
  },
  GL: {
    alternativeSpellings: ['Greenland', 'grønland'],
    relevancyBooster: '0.5',
    text: 'Greenland'
  },
  GD: {
    alternativeSpellings: ['Grenada'],
    text: 'Grenada'
  },
  GP: {
    alternativeSpellings: ['Guadeloupe'],
    text: 'Guadeloupe'
  },
  GU: {
    alternativeSpellings: ['Guam'],
    text: 'Guam'
  },
  GT: {
    alternativeSpellings: ['Guatemala'],
    text: 'Guatemala'
  },
  GG: {
    alternativeSpellings: ['Guernsey'],
    relevancyBooster: '0.5',
    text: 'Guernsey'
  },
  GN: {
    alternativeSpellings: ['Guinea'],
    text: 'Guinea'
  },
  GW: {
    alternativeSpellings: ['Guinea-Bissau'],
    text: 'Guinea-Bissau'
  },
  GY: {
    alternativeSpellings: ['Guyana'],
    text: 'Guyana'
  },
  HT: {
    alternativeSpellings: ['Haiti'],
    text: 'Haiti'
  },
  HM: {
    alternativeSpellings: ['Heard and Mc Donald Islands'],
    text: 'Heard and Mc Donald Islands'
  },
  VA: {
    alternativeSpellings: ['Holy See (Vatican City State)', 'Vatican City State (Holy See)'],
    relevancyBooster: '0.5',
    text: 'Vatican City State (Holy See)'
  },
  HN: {
    alternativeSpellings: ['Honduras'],
    text: 'Honduras'
  },
  HK: {
    alternativeSpellings: ['Hong Kong', '香港'],
    text: 'Hong Kong'
  },
  HU: {
    alternativeSpellings: ['Hungary', 'Magyarország'],
    text: 'Hungary'
  },
  IS: {
    alternativeSpellings: ['Iceland', 'Island'],
    text: 'Iceland'
  },
  IN: {
    alternativeSpellings: ['India', 'भारत गणराज्य', 'Hindustan'],
    relevancyBooster: '3',
    text: 'India'
  },
  ID: {
    alternativeSpellings: ['Indonesia'],
    relevancyBooster: '2',
    text: 'Indonesia'
  },
  IR: {
    alternativeSpellings: ['Iran, Islamic Republic of', 'ایران'],
    text: 'Iran (Islamic Republic of)'
  },
  IQ: {
    alternativeSpellings: ['Iraq', 'العراق&lrm;'],
    text: 'Iraq'
  },
  IE: {
    alternativeSpellings: ['Ireland', 'Éire'],
    relevancyBooster: '1.2',
    text: 'Ireland'
  },
  IM: {
    alternativeSpellings: ['Isle of Man'],
    relevancyBooster: '0.5',
    text: 'Isle of Man'
  },
  IL: {
    alternativeSpellings: ['Israel', 'إسرائيل', 'ישראל'],
    text: 'Israel'
  },
  IT: {
    alternativeSpellings: ['Italy', 'Italia'],
    relevancyBooster: '2',
    text: 'Italy'
  },
  JM: {
    alternativeSpellings: ['Jamaica'],
    text: 'Jamaica'
  },
  JP: {
    alternativeSpellings: ['Japan', 'Nippon', 'Nihon', '日本'],
    relevancyBooster: '2.5',
    text: 'Japan'
  },
  JE: {
    alternativeSpellings: ['Jersey'],
    relevancyBooster: '0.5',
    text: 'Jersey'
  },
  JO: {
    alternativeSpellings: ['Jordan', 'الأردن'],
    text: 'Jordan'
  },
  KZ: {
    alternativeSpellings: ['Kazakhstan', 'Қазақстан', 'Казахстан'],
    text: 'Kazakhstan'
  },
  KE: {
    alternativeSpellings: ['Kenya'],
    text: 'Kenya'
  },
  KI: {
    alternativeSpellings: ['Kiribati'],
    text: 'Kiribati'
  },
  KP: {
    alternativeSpellings: ['Korea, Democratic People\'s Republic of North Korea'],
    text: 'North Korea'
  },
  KR: {
    alternativeSpellings: ['Korea, Republic of South Korea'],
    relevancyBooster: '1.5',
    text: 'Korea, Republic of'
  },
  KW: {
    alternativeSpellings: ['Kuwait', 'الكويت'],
    text: 'Kuwait'
  },
  KG: {
    alternativeSpellings: ['Kyrgyzstan', 'Кыргызстан'],
    text: 'Kyrgyzstan'
  },
  LA: {
    alternativeSpellings: ['Lao People\'s Democratic Republic'],
    text: 'Lao People\'s Democratic Republic'
  },
  LV: {
    alternativeSpellings: ['Latvia', 'Latvija'],
    text: 'Latvia'
  },
  LB: {
    alternativeSpellings: ['Lebanon', 'لبنان'],
    text: 'Lebanon'
  },
  LS: {
    alternativeSpellings: ['Lesotho'],
    text: 'Lesotho'
  },
  LR: {
    alternativeSpellings: ['Liberia'],
    text: 'Liberia'
  },
  LY: {
    alternativeSpellings: ['Libyan Arab Jamahiriya', 'ليبيا'],
    text: 'Libyan Arab Jamahiriya'
  },
  LI: {
    alternativeSpellings: ['Liechtenstein'],
    text: 'Liechtenstein'
  },
  LT: {
    alternativeSpellings: ['Lithuania', 'Lietuva'],
    text: 'Lithuania'
  },
  LU: {
    alternativeSpellings: ['Luxembourg'],
    text: 'Luxembourg'
  },
  MO: {
    alternativeSpellings: ['Macau'],
    text: 'Macau'
  },
  MK: {
    alternativeSpellings: ['Macedonia, The Former Yugoslav Republic Of', 'Македонија'],
    text: 'Macedonia'
  },
  MG: {
    alternativeSpellings: ['Madagascar', 'Madagasikara'],
    text: 'Madagascar'
  },
  MW: {
    alternativeSpellings: ['Malawi'],
    text: 'Malawi'
  },
  MY: {
    alternativeSpellings: ['Malaysia'],
    text: 'Malaysia'
  },
  MV: {
    alternativeSpellings: ['Maldives'],
    text: 'Maldives'
  },
  ML: {
    alternativeSpellings: ['Mali'],
    text: 'Mali'
  },
  MT: {
    alternativeSpellings: ['Malta'],
    text: 'Malta'
  },
  MH: {
    alternativeSpellings: ['Marshall Islands'],
    relevancyBooster: '0.5',
    text: 'Marshall Islands'
  },
  MQ: {
    alternativeSpellings: ['Martinique'],
    text: 'Martinique'
  },
  MR: {
    alternativeSpellings: ['Mauritania', 'الموريتانية'],
    text: 'Mauritania'
  },
  MU: {
    alternativeSpellings: ['Mauritius'],
    text: 'Mauritius'
  },
  YT: {
    alternativeSpellings: ['Mayotte'],
    text: 'Mayotte'
  },
  MX: {
    alternativeSpellings: ['Mexico', 'Mexicanos'],
    relevancyBooster: '1.5',
    text: 'Mexico'
  },
  FM: {
    alternativeSpellings: ['Micronesia, Federated States of'],
    text: 'Micronesia, Federated States of'
  },
  MD: {
    alternativeSpellings: ['Moldova, Republic of'],
    text: 'Moldova, Republic of'
  },
  MC: {
    alternativeSpellings: ['Monaco'],
    text: 'Monaco'
  },
  MN: {
    alternativeSpellings: ['Mongolia', 'Mongγol', 'ulus', 'Монгол улс'],
    text: 'Mongolia'
  },
  ME: {
    alternativeSpellings: ['Montenegro'],
    text: 'Montenegro'
  },
  MS: {
    alternativeSpellings: ['Montserrat'],
    relevancyBooster: '0.5',
    text: 'Montserrat'
  },
  MA: {
    alternativeSpellings: ['Morocco', 'المغرب'],
    text: 'Morocco'
  },
  MZ: {
    alternativeSpellings: ['Mozambique', 'Moçambique'],
    text: 'Mozambique'
  },
  MM: {
    alternativeSpellings: ['Myanmar'],
    text: 'Myanmar'
  },
  NA: {
    alternativeSpellings: ['Namibia', 'Namibië'],
    text: 'Namibia'
  },
  NR: {
    alternativeSpellings: ['Nauru', 'Naoero'],
    relevancyBooster: '0.5',
    text: 'Nauru'
  },
  NP: {
    alternativeSpellings: ['Nepal', 'नेपाल'],
    text: 'Nepal'
  },
  NL: {
    alternativeSpellings: ['Netherlands', 'Holland', 'Nederland'],
    relevancyBooster: '1.5',
    text: 'Netherlands'
  },
  AN: {
    alternativeSpellings: ['Netherlands Antilles'],
    text: 'Netherlands Antilles'
  },
  NC: {
    alternativeSpellings: ['New Caledonia'],
    relevancyBooster: '0.5',
    text: 'New Caledonia'
  },
  NZ: {
    alternativeSpellings: ['New Zealand', 'Aotearoa'],
    text: 'New Zealand'
  },
  NI: {
    alternativeSpellings: ['Nicaragua'],
    text: 'Nicaragua'
  },
  NE: {
    alternativeSpellings: ['Niger', 'Nijar'],
    text: 'Niger'
  },
  NG: {
    alternativeSpellings: ['Nigeria', 'Nijeriya', 'Naíjíríà'],
    relevancyBooster: '1.5',
    text: 'Nigeria'
  },
  NU: {
    alternativeSpellings: ['Niue'],
    relevancyBooster: '0.5',
    text: 'Niue'
  },
  NF: {
    alternativeSpellings: ['Norfolk Island'],
    relevancyBooster: '0.5',
    text: 'Norfolk Island'
  },
  MP: {
    alternativeSpellings: ['Northern Mariana Islands'],
    relevancyBooster: '0.5',
    text: 'Northern Mariana Islands'
  },
  NO: {
    alternativeSpellings: ['Norway', 'Norge', 'Noreg'],
    relevancyBooster: '1.5',
    text: 'Norway'
  },
  OM: {
    alternativeSpellings: ['Oman', 'عمان'],
    text: 'Oman'
  },
  PK: {
    alternativeSpellings: ['Pakistan', 'پاکستان'],
    relevancyBooster: '2',
    text: 'Pakistan'
  },
  PW: {
    alternativeSpellings: ['Palau'],
    relevancyBooster: '0.5',
    text: 'Palau'
  },
  PA: {
    alternativeSpellings: ['Panama'],
    text: 'Panama'
  },
  PG: {
    alternativeSpellings: ['Papua New Guinea'],
    text: 'Papua New Guinea'
  },
  PY: {
    alternativeSpellings: ['Paraguay'],
    text: 'Paraguay'
  },
  PE: {
    alternativeSpellings: ['Peru'],
    text: 'Peru'
  },
  PH: {
    alternativeSpellings: ['Philippines', 'Pilipinas'],
    relevancyBooster: '1.5',
    text: 'Philippines'
  },
  PN: {
    alternativeSpellings: ['Pitcairn'],
    relevancyBooster: '0.5',
    text: 'Pitcairn'
  },
  PL: {
    alternativeSpellings: ['Poland', 'Polska'],
    relevancyBooster: '1.25',
    text: 'Poland'
  },
  PT: {
    alternativeSpellings: ['Portugal', 'Portuguesa'],
    relevancyBooster: '1.5',
    text: 'Portugal'
  },
  PR: {
    alternativeSpellings: ['Puerto Rico'],
    text: 'Puerto Rico'
  },
  QA: {
    alternativeSpellings: ['Qatar', 'قطر'],
    text: 'Qatar'
  },
  RE: {
    alternativeSpellings: ['Réunion', 'Reunion'],
    text: 'Reunion'
  },
  RO: {
    alternativeSpellings: ['Romania', 'Rumania', 'Roumania', 'România'],
    text: 'Romania'
  },
  RU: {
    alternativeSpellings: ['Russian Federation', 'Rossiya', 'Российская', 'Россия'],
    relevancyBooster: '2.5',
    text: 'Russian Federation'
  },
  RW: {
    alternativeSpellings: ['Rwanda'],
    text: 'Rwanda'
  },
  BL: {
    alternativeSpellings: ['Saint Barthélemy', 'St. Barthelemy'],
    text: 'Saint Barthélemy'
  },
  KN: {
    alternativeSpellings: ['Saint Kitts and Nevis', 'St. Kitts and Nevis'],
    text: 'Saint Kitts and Nevis'
  },
  LC: {
    alternativeSpellings: ['Saint Lucia', 'St. Lucia'],
    text: 'Saint Lucia'
  },
  MF: {
    alternativeSpellings: ['Saint Martin (French Part)', 'St. Martin (French Part)'],
    text: 'Saint Martin (French Part)'
  },
  VC: {
    alternativeSpellings: ['Saint Vincent and the Grenadines', 'St. Vincent and the Grenadines'],
    text: 'Saint Vincent and the Grenadines'
  },
  WS: {
    alternativeSpellings: ['Samoa'],
    text: 'Samoa'
  },
  SM: {
    alternativeSpellings: ['San Marino', 'RSM', 'Repubblica San Marino'],
    text: 'San Marino'
  },
  ST: {
    alternativeSpellings: ['Sao Tome and Principe'],
    text: 'Sao Tome and Principe'
  },
  SA: {
    alternativeSpellings: ['Saudi Arabia', 'السعودية'],
    text: 'Saudi Arabia'
  },
  SN: {
    alternativeSpellings: ['Senegal', 'Sénégal'],
    text: 'Senegal'
  },
  RS: {
    alternativeSpellings: ['Serbia', 'Србија', 'Srbija'],
    text: 'Serbia'
  },
  SC: {
    alternativeSpellings: ['Seychelles'],
    relevancyBooster: '0.5',
    text: 'Seychelles'
  },
  SL: {
    alternativeSpellings: ['Sierra Leone'],
    text: 'Sierra Leone'
  },
  SG: {
    alternativeSpellings: ['Singapore', 'Singapura', 'சிங்கப்பூர்', 'குடியரசு', '新加坡共和国'],
    text: 'Singapore'
  },
  SK: {
    alternativeSpellings: ['Slovakia', 'Slovenská', 'Slovensko'],
    text: 'Slovakia'
  },
  SI: {
    alternativeSpellings: ['Slovenia', 'Slovenija'],
    text: 'Slovenia'
  },
  SB: {
    alternativeSpellings: ['Solomon Islands'],
    text: 'Solomon Islands'
  },
  SO: {
    alternativeSpellings: ['Somalia', 'الصومال'],
    text: 'Somalia'
  },
  ZA: {
    alternativeSpellings: ['South Africa', 'RSA', 'Suid-Afrika'],
    text: 'South Africa'
  },
  ES: {
    alternativeSpellings: ['Spain', 'España'],
    relevancyBooster: '2',
    text: 'Spain'
  },
  LK: {
    alternativeSpellings: ['Sri Lanka', 'ශ්&zwj;රී', 'ලංකා', 'இலங்கை', 'Ceylon'],
    text: 'Sri Lanka'
  },
  SD: {
    alternativeSpellings: ['Sudan', 'السودان'],
    text: 'Sudan'
  },
  SR: {
    alternativeSpellings: ['Suriname', 'शर्नम्', 'Sarnam', 'Sranangron'],
    text: 'Suriname'
  },
  SJ: {
    alternativeSpellings: ['Svalbard and Jan Mayen'],
    relevancyBooster: '0.5',
    text: 'Svalbard and Jan Mayen Islands'
  },
  SZ: {
    alternativeSpellings: ['Swaziland', 'weSwatini', 'Swatini', 'Ngwane'],
    text: 'Swaziland'
  },
  SE: {
    alternativeSpellings: ['Sweden', 'Sverige'],
    relevancyBooster: '1.5',
    text: 'Sweden'
  },
  CH: {
    alternativeSpellings: ['Switzerland', 'Swiss Confederation', 'Schweiz', 'Suisse', 'Svizzera', 'Svizra'],
    relevancyBooster: '1.5',
    text: 'Switzerland'
  },
  SY: {
    alternativeSpellings: ['Syrian Arab Republic', 'Syria', 'سورية'],
    text: 'Syrian Arab Republic'
  },
  TW: {
    alternativeSpellings: ['Taiwan, Province of China', '台灣 臺灣'],
    text: 'Taiwan'
  },
  TJ: {
    alternativeSpellings: ['Tajikistan', 'Тоҷикистон', 'Toçikiston'],
    text: 'Tajikistan'
  },
  TZ: {
    alternativeSpellings: ['Tanzania, United Republic of'],
    text: 'Tanzania, United Republic of'
  },
  TH: {
    alternativeSpellings: ['Thailand', 'ประเทศไทย', 'Prathet', 'Thai'],
    text: 'Thailand'
  },
  TG: {
    alternativeSpellings: ['Togo', 'Togolese'],
    text: 'Togo'
  },
  TK: {
    alternativeSpellings: ['Tokelau'],
    relevancyBooster: '0.5',
    text: 'Tokelau'
  },
  TO: {
    alternativeSpellings: ['Tonga'],
    text: 'Tonga'
  },
  TT: {
    alternativeSpellings: ['Trinidad and Tobago'],
    text: 'Trinidad and Tobago'
  },
  TN: {
    alternativeSpellings: ['Tunisia', 'تونس'],
    text: 'Tunisia'
  },
  TR: {
    alternativeSpellings: ['Turkey', 'Türkiye', 'Turkiye'],
    text: 'Turkey'
  },
  TM: {
    alternativeSpellings: ['Turkmenistan', 'Türkmenistan'],
    text: 'Turkmenistan'
  },
  TC: {
    alternativeSpellings: ['Turks and Caicos Islands'],
    relevancyBooster: '0.5',
    text: 'Turks and Caicos Islands'
  },
  TV: {
    alternativeSpellings: ['Tuvalu'],
    relevancyBooster: '0.5',
    text: 'Tuvalu'
  },
  UG: {
    alternativeSpellings: ['Uganda'],
    text: 'Uganda'
  },
  UA: {
    alternativeSpellings: ['Ukraine', 'Ukrayina', 'Україна'],
    text: 'Ukraine'
  },
  AE: {
    alternativeSpellings: ['United Arab Emirates', 'UAE', 'الإمارات'],
    text: 'United Arab Emirates'
  },
  GB: {
    alternativeSpellings: ['United Kingdom', 'Great Britain', 'England', 'UK', 'Wales', 'Scotland', 'Northern Ireland'],
    relevancyBooster: '4',
    text: 'United Kingdom'
  },
  US: {
    alternativeSpellings: ['United States', 'USA', 'United States of America', 'America'],
    relevancyBooster: '3.5',
    text: 'United States'
  },
  UM: {
    alternativeSpellings: ['United States Minor Outlying Islands'],
    text: 'United States Minor Outlying Islands'
  },
  UY: {
    alternativeSpellings: ['Uruguay'],
    text: 'Uruguay'
  },
  UZ: {
    alternativeSpellings: ['Uzbekistan', 'Ўзбекистон', 'O\'zbekstan', 'O‘zbekiston'],
    text: 'Uzbekistan'
  },
  VU: {
    alternativeSpellings: ['Vanuatu'],
    text: 'Vanuatu'
  },
  VE: {
    alternativeSpellings: ['Venezuela'],
    text: 'Venezuela'
  },
  VN: {
    alternativeSpellings: ['Vietnam', 'Việt', 'Nam'],
    relevancyBooster: '1.5',
    text: 'Vietnam'
  },
  VG: {
    alternativeSpellings: ['Virgin Islands (British)'],
    relevancyBooster: '0.5',
    text: 'Virgin Islands, British'
  },
  VI: {
    alternativeSpellings: ['Virgin Islands (U.S.)'],
    relevancyBooster: '0.5',
    text: 'Virgin Islands, U.S.'
  },
  WF: {
    alternativeSpellings: ['Wallis and Futuna Islands'],
    relevancyBooster: '0.5',
    text: 'Wallis and Futuna Islands'
  },
  EH: {
    alternativeSpellings: ['Western Sahara', 'لصحراء الغربية'],
    text: 'Western Sahara'
  },
  YE: {
    alternativeSpellings: ['Yemen', 'اليمن'],
    text: 'Yemen'
  },
  ZM: {
    alternativeSpellings: ['Zambia'],
    text: 'Zambia'
  },
  ZW: {
    alternativeSpellings: ['Zimbabwe'],
    text: 'Zimbabwe '
  }
};
var _default = Countries;
exports["default"] = _default;