"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AutoComplete = _interopRequireDefault(require("../AutoComplete"));

var _Countries = _interopRequireDefault(require("./Countries"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var defaultSettings = {
  partialMatchPoints: 1,
  fullMatchPoints: 5,
  defaultCountryCode: 'GB'
};

var generateSettings = function generateSettings(props) {
  if (!props.settings || _typeof(props.settings) !== 'object') {
    return defaultSettings;
  }

  var stateSettings = Object.assign({}, props.settings);
  Object.keys(defaultSettings).forEach(function (key) {
    stateSettings[key] = stateSettings[key] == null ? defaultSettings[key] : stateSettings[key];
  });
  return stateSettings;
};

var CountrySelect =
/*#__PURE__*/
function (_Component) {
  _inherits(CountrySelect, _Component);

  function CountrySelect(props) {
    var _this;

    _classCallCheck(this, CountrySelect);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CountrySelect).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "getCountryByCountryCode", function (countryCode) {
      return _Countries["default"][countryCode] || _Countries["default"][_this.state.settings.defaultCountryCode] || _Countries["default"].GB;
    });

    _defineProperty(_assertThisInitialized(_this), "getPartialMatchScore", function (word, country) {
      var count = 0;
      var matcher = new RegExp(word, 'i');
      country.alternativeSpellings.forEach(function (altSpelling) {
        if (matcher.test(altSpelling)) {
          count += 1;
        }
      });
      return count * _this.state.settings.partialMatchPoints;
    });

    _defineProperty(_assertThisInitialized(_this), "callSuggestionSelectedCallback", function (option) {
      _this.setState({
        text: option.text
      });

      if (_this.props.suggestionSelectedCallback) {
        _this.props.suggestionSelectedCallback(option.value, option.text);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "filterCountries", function (text) {
      if (!text) {
        return [];
      }

      var filteredOptions = [];
      Object.keys(_Countries["default"]).forEach(function (countryCode) {
        var country = _Countries["default"][countryCode];

        var partialMatchScore = _this.getPartialMatchScore(text, country);

        var fullMatchScore = _this.getFullMatchScore(text, country);

        var relevancyBooster = country.relevancyBooster || 1;
        var matchScore = (partialMatchScore + fullMatchScore) * relevancyBooster;

        if (matchScore > 0) {
          filteredOptions.push({
            value: countryCode,
            text: country.text,
            score: matchScore
          });
        }
      });
      return filteredOptions.sort(function (item1, item2) {
        return _this.sortFiliteredCountries(item1, item2);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAutocompleteChange", function (option) {
      _this.setState({
        text: option.text
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleInputBlur", function (e) {
      if (_this.getCountryByCountryCode(_this.props.countryCode).text !== e.target.value) {
        _this.handleSuggestionSelected({
          value: _this.props.countryCode,
          text: _this.getCountryByCountryCode(_this.props.countryCode).text
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleSuggestionSelected", function (option) {
      _this.callSuggestionSelectedCallback(option);
    });

    _defineProperty(_assertThisInitialized(_this), "sortFiliteredCountries", function (item1, item2) {
      if (item1.score === item2.score) {
        if (item1.text === item2.text) {
          return 0;
        }

        return item1.text > item2.text ? 1 : -1;
      }

      return item2.score - item1.score;
    });

    _this.state = {
      settings: generateSettings(props),
      selectedCountry: {}
    };
    return _this;
  }

  _createClass(CountrySelect, [{
    key: "getFullMatchScore",
    value: function getFullMatchScore(word, country) {
      var matchedWord = country.alternativeSpellings.find(function (altSpelling) {
        return altSpelling === word;
      });
      return matchedWord != null ? this.state.settings.fullMatchPoints : 0;
    }
  }, {
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      this.setState({
        text: this.getCountryByCountryCode(this.props.countryCode).text
      });
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.settings !== this.props.settings) {
        this.setState({
          settings: generateSettings(nextProps)
        });
      }

      if (nextProps.countryCode !== this.props.countryCode) {
        this.setState({
          text: this.getCountryByCountryCode(nextProps.countryCode).text
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement(_AutoComplete["default"], {
        id: this.props.id,
        suggestionSelectedCallback: this.handleSuggestionSelected,
        blurCallback: this.handleInputBlur,
        changeCallback: this.handleAutocompleteChange,
        value: this.props.countryCode,
        text: this.state.text,
        source: this.filterCountries,
        additionalClasses: this.props.additionalClasses
      });
    }
  }]);

  return CountrySelect;
}(_react.Component);

CountrySelect.propTypes = {
  // Optional
  settings: _propTypes["default"].shape({
    partialMatchPoints: _propTypes["default"].number,
    fullMatchPoints: _propTypes["default"].number,
    defaultCountryCode: _propTypes["default"].string
  }),
  countryCode: _propTypes["default"].string,
  additionalClasses: _propTypes["default"].string,
  // Required
  id: _propTypes["default"].string.isRequired,
  suggestionSelectedCallback: _propTypes["default"].func.isRequired
};
CountrySelect.defaultProps = {
  settings: null,
  countryCode: null,
  additionalClasses: null
};
var _default = CountrySelect;
exports["default"] = _default;