"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactTable = _interopRequireDefault(require("react-table"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Pagination = _interopRequireDefault(require("../Pagination"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DataTable =
/*#__PURE__*/
function (_Component) {
  _inherits(DataTable, _Component);

  function DataTable() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, DataTable);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DataTable)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "generateColumns", function () {
      var columns = _toConsumableArray(_this.props.columns);

      var footer = _toConsumableArray(_this.props.footer);

      var reactColumns = [];

      var _loop = function _loop(i) {
        var accessor = columns[i].DisplayName.toLowerCase().split(' ').join('');
        var sortIcon = _this.props.sort.direction === -1 ? _react["default"].createElement("i", {
          className: "uifw-icon uifw-icon-sort-asc u-ml--"
        }) : _react["default"].createElement("i", {
          className: "uifw-icon uifw-icon-sort-desc u-ml--"
        });
        reactColumns.push({
          Header: function Header() {
            return _react["default"].createElement("div", {
              id: "".concat(_this.props.tableId, "Header").concat(accessor),
              onClick: function onClick() {
                return _this.props.onColumnClick(columns[i].DisplayName);
              }
            }, columns[i].DisplayName, _this.props.sort.column === accessor ? sortIcon : null);
          },
          accessor: accessor,
          minWidth: columns[i].MinWidth,
          Footer: footer[i]
        });
      };

      for (var i = 0; i < columns.length; i += 1) {
        _loop(i);
      }

      return reactColumns;
    });

    _defineProperty(_assertThisInitialized(_this), "generateColumnsGrouped", function () {
      var columns = _toConsumableArray(_this.props.columns);

      var reactColumns = [];
      var minorCoulumns = [];
      var groupHeaderKeys = [];
      var columnsForGroup = '';
      var stickyColumnCount = 0;

      _lodash["default"].keys(columns).forEach(function (key, index) {
        groupHeaderKeys = _lodash["default"].keys(columns[index]);
        columnsForGroup = _toConsumableArray(columns[key][groupHeaderKeys[0]]);
        columnsForGroup.forEach(function (element, i) {
          var sortIcon = _this.props.sort.direction === -1 ? _react["default"].createElement("i", {
            className: "uifw-icon uifw-icon-sort-asc u-ml--"
          }) : _react["default"].createElement("i", {
            className: "uifw-icon uifw-icon-sort-desc u-ml--"
          });
          var header = groupHeaderKeys[0].toString().toLowerCase();
          var elements = element.toLowerCase();
          var sortingIdentifiers = "".concat(header).concat(elements);
          var marginLeftValue = columns[index].fixed === true || i === 0 && columns[index - 1].fixed === true ? stickyColumnCount * 120 : 0;
          minorCoulumns.push({
            Header: function Header() {
              return _react["default"].createElement("div", {
                id: "".concat(_this.props.tableId, "Header").concat(elements),
                onClick: function onClick() {
                  return _this.props.onColumnClick(sortingIdentifiers);
                }
              }, element, _this.props.sort.column === sortingIdentifiers ? sortIcon : null);
            },
            headerClassName: columns[index].fixed ? '-sticky' : '',
            headerStyle: {
              marginLeft: marginLeftValue
            },
            id: "".concat(header).concat(elements),
            accessor: function accessor(d) {
              return d[header][elements];
            },
            width: 120,
            className: columns[index].fixed ? '-sticky' : '',
            style: {
              marginLeft: marginLeftValue
            }
          });

          if (columns[index].fixed === true) {
            stickyColumnCount += 1;
          }
        });
        reactColumns.push({
          Header: groupHeaderKeys[0].toString(),
          accessor: groupHeaderKeys[0].toString().toLowerCase(),
          columns: [].concat(minorCoulumns)
        });
        minorCoulumns.length = 0;
      });

      return reactColumns;
    });

    return _this;
  }

  _createClass(DataTable, [{
    key: "render",
    value: function render() {
      var tableData = _toConsumableArray(this.props.data);

      var pagination = null;

      if (this.props.paginationObject && this.props.paginationObject.itemsPerPage < this.props.data.length) {
        var endIndex = this.props.paginationObject.currentPage * this.props.paginationObject.itemsPerPage;
        var startIndex = endIndex - this.props.paginationObject.itemsPerPage;

        if (endIndex > this.props.data.length) {
          endIndex = this.props.data.length;
        }

        tableData = tableData.slice(startIndex, endIndex);
        pagination = _react["default"].createElement(_Pagination["default"], {
          totalNumberOfItems: this.props.data.length,
          itemsPerPage: this.props.paginationObject.itemsPerPage,
          currentPage: this.props.paginationObject.currentPage,
          clickCallback: this.props.paginationObject.handlePaginationClick,
          additionalWrapperCSSClasses: "uifw-pagination--table-pagination"
        });
      }

      return _react["default"].createElement("div", null, _react["default"].createElement(_reactTable["default"], {
        data: tableData,
        columns: this.props.groupedHeaders ? this.generateColumnsGrouped() : this.generateColumns(),
        className: "uifw-data-table uifw-data-table--flush -highlight",
        sortable: false,
        resizable: false,
        pageSize: tableData.length,
        showPagination: false
      }), pagination);
    }
  }]);

  return DataTable;
}(_react.Component);

DataTable.propTypes = {
  tableId: _propTypes["default"].string,
  data: _propTypes["default"].arrayOf(_propTypes["default"].object.isRequired).isRequired,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].any).isRequired,
  footer: _propTypes["default"].arrayOf(_propTypes["default"].any),
  onColumnClick: _propTypes["default"].func.isRequired,
  sort: _propTypes["default"].shape({
    column: _propTypes["default"].string,
    direction: _propTypes["default"].number
  }),
  groupedHeaders: _propTypes["default"].bool,
  paginationObject: _propTypes["default"].shape({
    currentPage: _propTypes["default"].number,
    itemsPerPage: _propTypes["default"].number,
    handlePaginationClick: _propTypes["default"].func
  }),
  minColumnWidth: _propTypes["default"].number
};
DataTable.defaultProps = {
  tableId: null,
  footer: [],
  sort: {
    column: '',
    direction: -1
  },
  groupedHeaders: false,
  paginationObject: null,
  minColumnWidth: null
};
var _default = DataTable;
exports["default"] = _default;