"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _jquery = _interopRequireDefault(require("jquery"));

require("jquery-ui");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var DatePicker =
/*#__PURE__*/
function (_Component) {
  _inherits(DatePicker, _Component);

  function DatePicker(props) {
    _classCallCheck(this, DatePicker);

    return _possibleConstructorReturn(this, _getPrototypeOf(DatePicker).call(this, props));
  }

  _createClass(DatePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          changeMonth = _this$props.changeMonth,
          changeYear = _this$props.changeYear,
          changeCallback = _this$props.changeCallback;
      var component = this.node;
      (0, _jquery["default"])(component).datepicker({
        changeMonth: changeMonth,
        changeYear: changeYear,
        onClose: changeCallback
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props2 = this.props,
          inputId = _this$props2.inputId,
          value = _this$props2.value;
      return _react["default"].createElement("input", {
        type: "text",
        value: value,
        id: inputId,
        ref: function ref(node) {
          return _this.node = node;
        }
      });
    }
  }]);

  return DatePicker;
}(_react.Component);

DatePicker.propTypes = {
  /**
   * The id that is to be passed to the input within the component
   <<example>>inputId="string"
   */
  inputId: _propTypes["default"].string,

  /**
   * The function to execute on text box value change
     <<example>>changeCallback={self.handleTextboxValueChange}
   */
  changeCallback: _propTypes["default"].func,

  /**
   * The value of the input
     <<example>>value="string"
   */
  value: _propTypes["default"].string.isRequired,
  changeMonth: _propTypes["default"].bool,
  changeYear: _propTypes["default"].bool,

  /**
  * The additional CSS classes to be added to the input element
    <<example>>additionalClasses="string"
  */
  additionalClasses: _propTypes["default"].string,

  /**
  * The placeholder value of the input
  <<example>>placeholder="string"
  */
  placeholder: _propTypes["default"].string,
  validation: _propTypes["default"].array,

  /**
   * The additional CSS classes that are passed to the validation message div
     <<example>> validationCssClasses="string"
   */
  validationCssClasses: _propTypes["default"].string,

  /**
   * The inline style that is passed to the validation message div
     <<example>> validationStyleOverride={
       {
        paddingTop: "20px",
        color: "#000"
      }
     }
   */
  disableValidationWrapper: _propTypes["default"].bool,
  validationStyleOverride: _propTypes["default"].object,
  validationWrapperCssClasses: _propTypes["default"].string
};
DatePicker.defaultProps = {
  inputId: 'DatePicker',
  changeCallback: null,
  changeMonth: false,
  changeYear: true,
  additionalClasses: '',
  placeholder: '',
  validationCssClasses: '',
  disableValidationWrapper: false,
  validationWrapperCssClasses: ''
};
var _default = DatePicker;
exports["default"] = _default;