"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

require("react-dates/initialize");

var _reactDates = require("react-dates");

var _moment = _interopRequireDefault(require("moment"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactMomentProptypes = _interopRequireDefault(require("react-moment-proptypes"));

var _DatePickerDefaultPhrases = _interopRequireDefault(require("./DatePickerDefaultPhrases"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DateRangePicker =
/*#__PURE__*/
function (_Component) {
  _inherits(DateRangePicker, _Component);

  function DateRangePicker(props) {
    var _this;

    _classCallCheck(this, DateRangePicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DateRangePicker).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "getPhrases", function () {
      return _objectSpread({}, _DatePickerDefaultPhrases["default"], {}, _this.props.phrases);
    });

    _defineProperty(_assertThisInitialized(_this), "inputEndDate", function () {
      if (_this.props.endDate === null) {
        return null;
      }

      return _this.props.endDate;
    });

    _defineProperty(_assertThisInitialized(_this), "inputStartDate", function () {
      if (_this.props.startDate === null) {
        return null;
      }

      return _this.props.startDate;
    });

    _defineProperty(_assertThisInitialized(_this), "isOutsideRange", function (day) {
      return (0, _moment["default"])(day).isBefore((0, _moment["default"])(_this.props.startDateRange)) || (0, _moment["default"])(day).isAfter((0, _moment["default"])().endOf('year'));
    });

    _this.state = {
      focusedInput: 'startDate'
    };

    _moment["default"].updateLocale('en', {
      week: {
        dow: 1
      }
    });

    return _this;
  }

  _createClass(DateRangePicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        id: this.props.id,
        key: this.props.Key
      }, _react["default"].createElement(_reactDates.DayPickerRangeController, {
        startDate: this.props.startDate,
        endDate: this.props.endDate,
        onDatesChange: this.props.changeState,
        focusedInput: this.state.focusedInput,
        numberOfMonths: this.props.numberOfMonths,
        onFocusChange: function onFocusChange(focusedInput) {
          return _this2.setState({
            focusedInput: focusedInput || 'startDate'
          });
        },
        hideKeyboardShortcutsPanel: true,
        isOutsideRange: this.isOutsideRange,
        phrases: this.getPhrases()
      }));
    }
  }]);

  return DateRangePicker;
}(_react.Component);

DateRangePicker.propTypes = {
  id: _propTypes["default"].string,

  /* eslint-disable react/no-typos */
  startDate: _reactMomentProptypes["default"].momentObj,
  endDate: _reactMomentProptypes["default"].momentObj,

  /* eslint-enable react/no-typos */
  changeState: _propTypes["default"].func.isRequired,
  startDateRange: _propTypes["default"].string,
  numberOfMonths: _propTypes["default"].number,
  Key: _propTypes["default"].string,

  /* eslint-disable react/forbid-prop-types */
  phrases: _propTypes["default"].object // Prop validation of the phrases is handled by the react-dates package

  /* eslint-enable react/forbid-prop-types */

};
DateRangePicker.defaultProps = {
  id: 'DatePicker',
  startDate: null,
  endDate: null,
  startDateRange: '2000-01-01',
  numberOfMonths: 2,
  Key: '',
  phrases: {}
};
var _default = DateRangePicker;
exports["default"] = _default;