"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var $ = require('jquery');

require('jquery-ui');

var classNames = require('classnames');

var Validation = require('../../../Utils/Validation');

var ReactDOM = require('react-dom');
/**
 * <p>The Alert Dialog is used to display a functional dialog on screen when the selected item is not equal to <i>null</i></p>
 * <<warning>>This should no longer be used when developing any application.
 * Eventually all '<b>AlertDialog.js</b>' Components will be replaced by the '<b>Dialog.js</b>' Component.
 * Any form of the uifw/jQuery dialog can(and should) be created using the newer, more generic '<b>Dialog.js</b>' Component.
 */


var _default =
/*#__PURE__*/
function (_React$Component) {
  _inherits(_default, _React$Component);

  function _default() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(_default)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      selectedItem: _this.props.selectedItem,
      title: _this.props.title,
      confirmAction: _this.props.confirmAction,
      comonent: null,
      modal: null
    });

    _defineProperty(_assertThisInitialized(_this), "_generateId", function () {
      return _this.props.id !== undefined && _this.props.id.length > 0 ? "dialog-def-" + _this.props.id : "dialog-def";
    });

    _defineProperty(_assertThisInitialized(_this), "_createForm", function () {
      var id = _this._generateId();

      ReactDOM.render(React.createElement("div", {
        id: id
      }, _this.props.children), _this.state.component);
    });

    _defineProperty(_assertThisInitialized(_this), "_confirmAction", function (modalNode) {
      var formValid = Validation.validateForm(document.getElementById(_this._generateId()));

      _this.props.confirmAction(_this.state.selectedItem, formValid);

      if (formValid) {
        $(_this.state.modal).dialog("close");
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_cancelAction", function (modalNode) {
      $(_this.state.modal).dialog("close");
    });

    return _this;
  }

  _createClass(_default, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var component = ReactDOM.findDOMNode(this);
      var modal;
      if (this.props.id !== undefined && this.props.id.length > 0) component.id = this.props.id;
      var buttons = [];
      var confirmButtonIcon = this.props.confirmIcon ? '<i class="' + this.props.confirmIcon + '"></i>' : "";
      var confirmText = this.props.confirmText;
      var confirm = this._confirmAction;
      var cancelText = this.props.cancelText;
      var cancel = this._cancelAction;
      $(component).dialog({
        dialogClass: "uifw-dialog-actions",
        autoOpen: false,
        modal: true,
        draggable: false,
        resizable: false,
        width: 700,
        title: this.state.title,
        open: function open() {
          var firstTextbox = $('#dialog-def').find("input[type='text']").first();

          if (firstTextbox.length > 0) {
            firstTextbox.focus();
            var valueLength = firstTextbox.val().length;
            firstTextbox[0].setSelectionRange(valueLength, valueLength);
          }
        },
        buttons: [{
          id: "uifw-form-dialog-submit-button",
          html: confirmText ? confirmButtonIcon + confirmText : "Ok",
          "class": 'uifw-button primary',
          click: function click() {
            confirm(this);
          }
        }, {
          text: cancelText ? cancelText : "Cancel",
          priority: 'secondary',
          "class": 'uifw-button normal left',
          click: function click() {
            cancel(this);
          }
        }]
      });
      modal = $(component);
      this.setState({
        component: component,
        modal: modal
      });

      if (this.props.autoOpen === true) {
        this._createForm();

        modal.dialog("open");
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.props.selectedItem && Object.keys(this.props.selectedItem).length !== 0) {
        if (this.state.selectedItem !== this.props.selectedItem) this.setState({
          selectedItem: this.props.selectedItem
        });

        this._createForm();

        if (this.state.modal.dialog("isOpen") === false) {
          this.state.modal.dialog("open");
        }

        $(".ui-widget-overlay.ui-front").css("height", $('body').height() + 20);
        var confirmButtonIcon = this.props.confirmIcon ? '<i class="' + this.props.confirmIcon + '"></i>' : "";
        var confirmButtonText = this.props.confirmText ? this.props.confirmText : "Ok";
        var modal = $(this.state.modal).context.parentNode;
        $(modal).find(".ui-dialog-title")[0].innerHTML = this.props.title;
        $(modal).find("#uifw-form-dialog-submit-button")[0].innerHTML = confirmButtonIcon + confirmButtonText;
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", null);
    }
  }]);

  return _default;
}(React.Component);

exports["default"] = _default;

_defineProperty(_default, "propTypes", {
  /**
     * The title of the displayed modal
   <<example>> title="string"
     */
  title: PropTypes.string.isRequired,

  /**
     * The function to be executed when the confirm button is clicked
   <<example>> confirmAction={self.handleConfirmClick}
     */
  confirmAction: PropTypes.func.isRequired,

  /**
     * The id that is passed to the dialog
   <<example>> id="string"
     */
  id: PropTypes.string,

  /**
     * Bool to set whether or not the dialog should auto open
   <<example>> autoOpen={true}
     */
  autoOpen: PropTypes.bool,

  /**
     * The string that is displayed on the confirm button
   <<example>> confirmText="string"
     */
  confirmText: PropTypes.string,

  /**
     * The icon class that is on the confirm button
   <<example>> confirmIcon="uifw-icon-search"
     */
  confirmIcon: PropTypes.string,

  /**
     * The string that is displayed on the cancel button
   <<example>> cancelText="string"
     */
  cancelText: PropTypes.string,

  /**
     * The values of the selected object. When the value is set to anything other than null the dialog will be display
   <<example>> selectedItem={
   		{
  			itemId: 1,
  			itemDescription: "Selected Item"
  		}
  	}
     */
  selectedItem: PropTypes.object
});

;