"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PropTypes = require('prop-types');

var React = require('react');

var $ = require('jquery');

require('jquery-ui');

var ReactDOM = require('react-dom');

var DialogContent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DialogContent, _React$Component);

  function DialogContent() {
    _classCallCheck(this, DialogContent);

    return _possibleConstructorReturn(this, _getPrototypeOf(DialogContent).apply(this, arguments));
  }

  _createClass(DialogContent, [{
    key: "render",
    value: function render() {
      return React.createElement("div", null, this.props.children);
    }
  }]);

  return DialogContent;
}(React.Component);

var $dialog;
/**
 * <p>The Alert Dialog Confirmation Component is used as a confirmation box usually confirming a delete or save etc.</p>
 * <<warning>>This should no longer be used when developing any application.
 * Eventually all '<b>AlertDialogConfirmation.js</b>' Components will be replaced by the '<b>Dialog.js</b>' Component.
 * Any form of the uifw/jQuery dialog can(and should) be created using the newer, more generic '<b>Dialog.js</b>' Component.
 */

var _default =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(_default, _React$Component2);

  function _default() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(_default)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "openDialog", function () {
      var confirmText = _this.props.confirmText;
      var cancelText = _this.props.cancelText;
      var confirm = _this._confirmAction;
      var cancel = _this._cancelAction;
      var title = _this.props.title;
      var confirmButtonIcon = _this.props.confirmIcon ? '<i class="' + _this.props.confirmIcon + '"></i>' : "";
      $dialog = $('<div>').dialog({
        dialogClass: "uifw-dialog-confirmation",
        modal: true,
        draggable: false,
        resizable: false,
        title: title,
        width: 400,
        close: function close(e) {
          ReactDOM.unmountComponentAtNode(this);
          $(this).remove();
        },
        open: function open(e) {
          $('.ui-widget-overlay').height($('body').height() + 20);
        },
        buttons: [{
          text: confirmText ? confirmText : "Confirm",
          "class": 'uifw-button primary',
          click: function click() {
            confirm(this);
          }
        }, {
          text: cancelText ? cancelText : "Cancel",
          priority: 'secondary',
          "class": 'uifw-button normal left',
          click: function click() {
            cancel(this);
          }
        }]
      });

      var closeDialog = function closeDialog(e) {
        e.preventDefault();
        $dialog.dialog('close');
      };

      ReactDOM.render(React.createElement(DialogContent, {
        closeDialog: closeDialog
      }, React.createElement("p", null, _this.props.questionMessage), React.createElement("p", null, _this.props.informationMessage)), $dialog[0]);
      $dialog.attr("id", "delete-dialog");
    });

    _defineProperty(_assertThisInitialized(_this), "_confirmAction", function (modalNode) {
      _this.props.confirmCallback(_this.props.selectedItem);

      $(modalNode).dialog("close"); //this.props.selectedItem = null;
    });

    _defineProperty(_assertThisInitialized(_this), "_cancelAction", function (modalNode) {
      if (_this.props.cancelCallback) {
        _this.props.cancelCallback(_this.props.selectedItem);
      }

      $(modalNode).dialog("close");
    });

    return _this;
  }

  _createClass(_default, [{
    key: "UNSAFE_componentWillUpdate",
    value: function UNSAFE_componentWillUpdate(nextProps, nextState) {
      if (nextProps.selectedItem !== null) {
        this.openDialog();
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", null);
    }
  }]);

  return _default;
}(React.Component);

exports["default"] = _default;

_defineProperty(_default, "propTypes", {
  /**
   * The function to be executed when the confirm button is clicked
  <<example>> confirmCallback={self.handleConfirmClick}
   */
  confirmCallback: PropTypes.func.isRequired,

  /**
   * The title of the displayed modal
  <<example>> title="string"
   */
  title: PropTypes.string.isRequired,

  /**
   * The first line of text for the modal content
  <<example>> questionMessage="string"
   */
  questionMessage: PropTypes.string.isRequired,

  /**
   * Sets if the dialog should auto open on render
  <<example>> autoOpen={true}
   */
  autoOpen: PropTypes.bool,

  /**
   * The second line of text for the modal content
  <<example>> informationMessage="string"
   */
  informationMessage: PropTypes.string,

  /**
   * The id of the selected item, when this is anything greater than -1 the modal will be shown
  <<example>> selectedItem={2}
   */
  selectedItem: PropTypes.oneOfType([PropTypes.number, PropTypes.object]),

  /**
   * The string that is displayed on the confirm button
  <<example>> confirmText="string"
   */
  confirmText: PropTypes.string,

  /**
   * The string that is displayed on the cancel button
  <<example>> cancelText="string"
   */
  cancelText: PropTypes.string
});

;