"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _createReactClass = _interopRequireDefault(require("create-react-class"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _jquery = _interopRequireDefault(require("jquery"));

var _underscore = _interopRequireDefault(require("underscore"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var warnOnce = function warnOnce(msg) {
  return _underscore["default"].once(function () {
    return console.warn(msg);
  });
};

var closeWarning = "No 'close' option was passed to a Dialog component.";
var warnCloseNotSet = warnOnce(closeWarning);

var populateOptionsWithDefaults = function PopulateOptionsWithDefaults(options) {
  options.dialogClass = options.dialogClass || "uifw-dialog-actions";
  options.autoOpen = options.autoOpen || false;
  options.modal = options.modal === false ? false : true;
  options.draggable = options.draggable || false;
  options.resizable = options.resizable || false;
  options.width = options.width || options.width === 0 ? options.width : 700;

  options.close = options.close || function uifwDialogDefaultClose(e) {
    warnCloseNotSet();

    _reactDom["default"].unmountComponentAtNode(this);

    (0, _jquery["default"])(this).remove();
  };

  options.open = options.open || function uifwDialogDefaultOpen(e) {};

  options.buttons = options.buttons || [];
  return options;
};

var DialogContent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DialogContent, _React$Component);

  function DialogContent() {
    _classCallCheck(this, DialogContent);

    return _possibleConstructorReturn(this, _getPrototypeOf(DialogContent).apply(this, arguments));
  }

  _createClass(DialogContent, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", null, this.props.children);
    }
  }]);

  return DialogContent;
}(_react["default"].Component);
/**
 * <p>The Dialog component is now used for all variations of the uifw/jQuery dialog implementation.
 * The Component takes in one property that is the <b>options</b> property. This is an object that has the same structure
 * as the jQuery options object. The uifw version of the dialog works with a ternary operator.
 * The dialog will render as soon as the turnerary value is set to the correct conditions. See <a href="http://internal-uifw/elements.html#modal" target="_blank">Modal and Dialogs</a> for more information.
 */


var Dialog = (0, _createReactClass["default"])({
  displayName: 'Dialog',
  propTypes: {
    /**
       * The configuration options that are passed to the jQuery dialog component. The only Required
     * options property is the title as this has no default value.
     * More information about the dialog options object can be obtained from the
     * <a href="http://api.jqueryui.com/dialog/" target="_blank">jQuery api documentation</a>.
     <<example>> options={
     	{
    		dialogClass: "string", // default {"uifw-dialog-actions"},
    		autoOpen: true, // default {false}
    		modal: false, // default {true}
    		draggable: true, // default {false}
    		resizable: true, // default {false}
    		title: "string", // no default - Is Required
    		width: 400, // default {700}
    		close: self.onModalClose, // function to execute when closing the modal
    		open: self.onModalOpen, // function to execute when opening the modal
    		buttons: [ // buttons: default {[]}
    			{
    				text: "Ok",
    				class: 'uifw-button primary',
    				click: self.handleConfirmClick
    			},
    			{
    				text: "Cancel",
    				priority: 'secondary',
    				class: 'uifw-button normal left',
    				click: self.handleCancelClick
    			}
    		]
    	}
     }
       */
    options: _propTypes["default"].object.isRequired
  },
  componentDidUpdate: function componentDidUpdate() {
    _reactDom["default"].render(_react["default"].createElement(DialogContent, null, this.props.children), this.__theDialog[0]);
  },
  componentDidMount: function componentDidMount() {
    var component = _reactDom["default"].findDOMNode(this);

    var options = populateOptionsWithDefaults(this.props.options);
    this.__theDialog = (0, _jquery["default"])('<div>').dialog(options);

    _reactDom["default"].render(_react["default"].createElement(DialogContent, null, this.props.children), this.__theDialog[0]);

    this.__theDialog.attr("id", "uifw-dialog-content");

    this.__theDialog[0].parentNode.id = this.props.options.id || "uifw-dialog";

    this.__theDialog.dialog("open");
  },
  __closeDialog: function __closeDialog() {
    this.__theDialog.dialog('close');
  },
  componentWillUnmount: function componentWillUnmount() {
    this.__theDialog.dialog('destroy');

    _reactDom["default"].unmountComponentAtNode(this.__theDialog[0]);
  },
  __theDialog: {},
  render: function render() {
    return _react["default"].createElement("div", null);
  }
});
var _default = Dialog;
exports["default"] = _default;