"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var Dropzone = require("react-dropzone");

var _ = require("underscore");

var Grid = require("../Grid");

var GridDynamicRow = require("../Grid/GridDynamicRow");

var SelectableThumbnail = require("../ThumbnailCollection/SelectableThumbnail");

function cancelEvent(e) {
  e = e || event;
  e.preventDefault();
}

var defaultFileDropStyle = {
  position: "relative",
  overflow: "hidden",
  width: "940px",
  border: "4px dashed #d8d8d8",
  minHeight: "150px",
  marginBottom: "10px",
  textAlign: "center",
  background: "#f6f6f6"
};
var defaultFileDropMessageStyle = {
  "float": "left",
  marginTop: "55px",
  width: "100%",
  color: "#c0c0c0",
  fontSize: "28px"
};
var defaultFileDropSubMessageStyle = {
  color: "#c0c0c0",
  fontSize: "18px",
  marginTop: "10px"
};
var defaultFileDropSubSubMessageStyle = {
  "display": "block",
  "color": "#c0c0c0",
  "fontSize": "12px",
  "marginTop": "10px"
};
/**
 * A wrapper around react-dropzone.
 * https://github.com/paramaggarwal/react-dropzone
  <example><uifw.FileDropzone
	  message="Drop a file here to upload"
	  subMessage="Or click to select a file"
	  onDrop={(file) => this.setState({ File: file })}
	  accept={["text/javascript", "text/css"]} />
 */

var FileDropzone =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FileDropzone, _React$Component);

  function FileDropzone() {
    _classCallCheck(this, FileDropzone);

    return _possibleConstructorReturn(this, _getPrototypeOf(FileDropzone).apply(this, arguments));
  }

  _createClass(FileDropzone, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.disablePageDrop) {
        window.addEventListener("dragover", cancelEvent, false);
        window.addEventListener("drop", cancelEvent, false);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(Dropzone, this.props, React.createElement("span", {
        style: this.props.messageStyle
      }, this.props.message), React.createElement("span", {
        style: this.props.subMessageStyle
      }, this.props.subMessage), React.createElement("span", {
        style: this.props.subSubMessageStyle
      }, this.props.subSubMessage), this.props.children);
    }
  }]);

  return FileDropzone;
}(React.Component);

_defineProperty(FileDropzone, "defaultProps", {
  disablePageDrop: false,
  disableClick: false,
  multiple: true,
  style: defaultFileDropStyle,
  messageStyle: defaultFileDropMessageStyle,
  message: "Drag & Drop Images Here",
  subMessageStyle: defaultFileDropSubMessageStyle,
  subMessage: "Or click to select a file",
  subSubMessageStyle: defaultFileDropSubSubMessageStyle,
  subSubMessage: ""
});

_defineProperty(FileDropzone, "propTypes", {
  /**
   * The main message to be displayed with the FileDropzone
   */
  message: PropTypes.string,

  /**
   * A slightly smaller, secondary message to be displayed below the main one.
   */
  subMessage: PropTypes.string,

  /**
   * A tiny message to be displayed below the secondary message.
   */
  subSubMessage: PropTypes.string,

  /**
   * This is called when something is dropped on to the zone.
   * It passes in the file to the callback.
   */
  onDrop: PropTypes.func,

  /**
   * This is called when something is dropped on to the zone and it passes
   *  the criteria for being uploaded.
   */
  onDropAccepted: PropTypes.func,

  /**
  * This is called when something is dropped on to the zone and it fails
  *  the criteria for being uploaded.
   */
  onDropRejected: PropTypes.func,

  /**
   * Called when a file is dragged into the drop zone,
   *  but before being dropped.
   */
  onDragEnter: PropTypes.func,

  /**
   * Called when a file is dragged out of the drop zone.
   */
  onDragLeave: PropTypes.func,

  /**
   * An object for styling the component.
   */
  style: PropTypes.object,

  /**
   * An object for styling the main message.
   */
  messageStyle: PropTypes.object,

  /**
   * An object for styling the secondary message.
   */
  subMessageStyle: PropTypes.object,

  /**
   * An object for styling the sub message.
   */
  subSubMessageStyle: PropTypes.object,

  /**
   * A style object to style active dragging elements.
   */
  activeStyle: PropTypes.object,

  /**
   * Any classes to be applied to the dropzone.
   */
  className: PropTypes.string,

  /**
   * Classes to be applied to active dragging elements.
   */
  activeClassName: PropTypes.string,

  /**
   * Classes to be applied to files that are rejected.
   */
  rejectClassName: PropTypes.string,

  /**
   * If true, disables the browsers default drag and drop behavior.
   */
  disablePageDrop: PropTypes.bool,

  /**
   * Disable opening the file explorer on click.
   * Defaults to false.
   */
  disableClick: PropTypes.bool,

  /**
   * Enables dropping multiple files.
   * Defaults to true.
   */
  multiple: PropTypes.bool,

  /**
   * An array of FileType strings that the dropzone accepts.
   */
  accept: PropTypes.string,

  /**
   * Any child components to be displayed inside the dropzone.
   */
  children: PropTypes.oneOfType([PropTypes.array, PropTypes.object, PropTypes.string])
});

var _default = FileDropzone;
exports["default"] = _default;