"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = _interopRequireDefault(require("../Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FilePickerBreadcrumbPopout =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilePickerBreadcrumbPopout, _React$Component);

  function FilePickerBreadcrumbPopout() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FilePickerBreadcrumbPopout);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FilePickerBreadcrumbPopout)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "togglePopoutSection", function () {
      _this.props.togglePopoutSection();
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyPress", function (e) {
      if (e.KeyCode === 13) {
        _this.props.togglePopoutSection();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "selectFolderToView", function (uri) {
      _this.props.selectFolderToView({
        name: uri,
        type: 1
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (e, uri) {
      if (e.KeyCode === 13) {
        _this.props.selectFolderToView({
          Name: uri,
          type: 1
        });
      }
    });

    return _this;
  }

  _createClass(FilePickerBreadcrumbPopout, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", null, _react["default"].createElement("div", {
        className: "uifw-fm-breadcrumb__truncated",
        onClick: this.togglePopoutSection,
        onKeyPress: this.handleKeyPress
      }, _react["default"].createElement(_Icon["default"], {
        icon: "uifw-icon-ellipsis-h"
      })), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-fm-breadcrumb__popout', {
          'u-hide': !this.props.isPopoutViewable
        })
      }, this.props.breadcrumbHeaderOptions.map(function (breadcrumbHeaderOption) {
        return _react["default"].createElement("div", {
          className: "uifw-fm-folder uifw-fm-folder--clickable uifw-fm-folder--small",
          onClick: function onClick() {
            _this2.selectFolderToView(breadcrumbHeaderOption.uri);
          },
          onKeyDown: function onKeyDown(e) {
            _this2.handleKeyDown(e, breadcrumbHeaderOption.uri);
          }
        }, _react["default"].createElement("div", {
          className: "uifw-fm-folder__thumbnail"
        }, _react["default"].createElement("div", {
          className: "uifw-fm-icon uifw-fm-icon--".concat(breadcrumbHeaderOption.folderThumbnail, " uifw-fm-icon--small")
        })), _react["default"].createElement("div", {
          className: "uifw-fm-folder__details"
        }, breadcrumbHeaderOption.folderName));
      })));
    }
  }]);

  return FilePickerBreadcrumbPopout;
}(_react["default"].Component);

FilePickerBreadcrumbPopout.propTypes = {
  isPopoutViewable: _propTypes["default"].bool.isRequired,
  breadcrumbHeaderOptions: _propTypes["default"].oneOfType([_propTypes["default"].array]).isRequired,
  togglePopoutSection: _propTypes["default"].func.isRequired,
  selectFolderToView: _propTypes["default"].func.isRequired
};
var _default = FilePickerBreadcrumbPopout;
exports["default"] = _default;