"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ReactDialog = _interopRequireDefault(require("../ReactDialog"));

var _ButtonSection = _interopRequireDefault(require("../Section/ButtonSection"));

var _Button = _interopRequireDefault(require("../Button"));

var _FormRow = _interopRequireDefault(require("../FormRow"));

var _Label = _interopRequireDefault(require("../Label"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>
 *   FilePickerDeleteConfirmationModal is a component that confirms to remove an image from the file picker.
 * </p>
 */
var FilePickerDeleteConfirmationModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilePickerDeleteConfirmationModal, _React$Component);

  function FilePickerDeleteConfirmationModal(props) {
    var _this;

    _classCallCheck(this, FilePickerDeleteConfirmationModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FilePickerDeleteConfirmationModal).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "closeWarningModal", function () {
      _this.setState({
        overrideModalVisible: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelModal", function () {
      _this.props.cancelCallback();
    });

    _defineProperty(_assertThisInitialized(_this), "generateFooter", function () {
      return _react["default"].createElement(_ButtonSection["default"], null, _react["default"].createElement(_Button["default"], {
        buttonText: "Cancel",
        cssClass: "normal left",
        clickCallback: _this.cancelModal
      }), _react["default"].createElement(_Button["default"], {
        buttonText: "Delete Image",
        cssClass: "destructive right",
        clickCallback: _this.props.deleteImageCallback
      }));
    });

    _this.state = {
      modalFile: null,
      overrideModalVisible: false
    };
    return _this;
  }

  _createClass(FilePickerDeleteConfirmationModal, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", null, _react["default"].createElement(_ReactDialog["default"].Component, {
        displayDialog: this.props.isModalVisible,
        header: "Delete Image?",
        clickClose: this.props.cancelCallback,
        footer: this.generateFooter()
      }, _react["default"].createElement(_FormRow["default"], {
        id: "fileDeleteModalDescriptionFormRow",
        type: "sbs",
        additionalCssClasses: "flex"
      }, _react["default"].createElement(_Label["default"], {
        labelHeader: "",
        labelDescription: "Are you sure you want to delete this image? \r It will no longer be available in your File Manager once deleted."
      }))));
    }
  }]);

  return FilePickerDeleteConfirmationModal;
}(_react["default"].Component);

FilePickerDeleteConfirmationModal.propTypes = {
  /**
   * isModalVisible is a boolean value this is passed in dictate the visibilty of the modal
   * <<example>> isModalVisible={false}
   */
  isModalVisible: _propTypes["default"].bool.isRequired,

  /**
   * cancelCallback is a function that is applied to the closing functionality
   * <<example>> clickCallback={this.props.cancelCallback}
   */
  cancelCallback: _propTypes["default"].func.isRequired,

  /**
   * deleteImageCallback is a function that takes in the argument for the file that the user has selected
   * <<example>> deleteImageCallback={(file) => { this.deleteImageCallback(file); }}
   */
  deleteImageCallback: _propTypes["default"].func.isRequired
};
var _default = FilePickerDeleteConfirmationModal;
exports["default"] = _default;