"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The FilePickerFileFormRow is used to generate the form row in the filePicker which
 * is used for the file form row. <p>
 */
var FilePickerFileFormRow =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilePickerFileFormRow, _React$Component);

  function FilePickerFileFormRow() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FilePickerFileFormRow);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FilePickerFileFormRow)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "selectFile", function () {
      _this.props.selectFile({
        name: _this.props.uri,
        type: 0
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleOpenDeletionModal", function () {
      _this.props.onDeleteButtonClick(_this.props.uri);
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyPress", function (event) {
      if (event.KeyCode === 13) {
        _this.props.selectFile({
          name: _this.props.uri,
          type: 0
        });
      }
    });

    return _this;
  }

  _createClass(FilePickerFileFormRow, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: "uifw-fm-item uifw-fm-item--no-controls uifw-fm-item--clickable"
      }, _react["default"].createElement("div", {
        className: "uifw-fm-item__thumbnail",
        onClick: this.selectFile,
        onKeyPress: this.handleKeyPress
      }, _react["default"].createElement("img", {
        src: "".concat(this.props.imageSrc, "?").concat(new Date().getTime()),
        className: "uifw-img"
      })), _react["default"].createElement("div", {
        className: "uifw-fm-item__name",
        onClick: this.selectFile,
        onKeyPress: this.handleKeyPress
      }, this.props.fileName), _react["default"].createElement("div", {
        className: "uifw-fm-item__modified"
      }, this.props.lastModificationDate), this.props.showDeleteButton && _react["default"].createElement("div", {
        onClick: this.handleOpenDeletionModal
      }, _react["default"].createElement("i", {
        className: "far fa-trash-alt pl-2"
      })));
    }
  }]);

  return FilePickerFileFormRow;
}(_react["default"].Component);

FilePickerFileFormRow.propTypes = {
  /**
   * imageSrc is a string used to provide the filepath for the image element.
   */
  imageSrc: _propTypes["default"].string.isRequired,

  /**
   * fileName is a string used to display the entities name.
   */
  fileName: _propTypes["default"].string.isRequired,

  /**
   * lastModificationDate is a string used to display the last date the file was modified.
   */
  lastModificationDate: _propTypes["default"].string.isRequired,
  selectFile: _propTypes["default"].func.isRequired,
  uri: _propTypes["default"].string.isRequired,
  onDeleteButtonClick: _propTypes["default"].func.isRequired,
  showDeleteButton: _propTypes["default"].bool.isRequired
};
var _default = FilePickerFileFormRow;
exports["default"] = _default;