"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The FilePickerFolderFormRow is used to generate the form row in the filePicker which
 * is used for the folder form row. <p>
 */
var FilePickerFolderFormRow =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilePickerFolderFormRow, _React$Component);

  function FilePickerFolderFormRow() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FilePickerFolderFormRow);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FilePickerFolderFormRow)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "selectFolder", function () {
      _this.props.selectFolder({
        name: _this.props.uri,
        type: 1
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyPress", function (event) {
      if (event.KeyCode === 13) {
        _this.props.selectFolder({
          name: _this.props.uri,
          type: 1
        });
      }
    });

    return _this;
  }

  _createClass(FilePickerFolderFormRow, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: "uifw-fm-folder uifw-fm-folder--clickable",
        onClick: this.selectFolder,
        onKeyPress: this.handleKeyPress
      }, _react["default"].createElement("div", {
        className: "uifw-fm-folder__thumbnail"
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-fm-icon', this.props.folderIcon)
      })), _react["default"].createElement("div", {
        className: "uifw-fm-folder__details"
      }, this.props.folderName));
    }
  }]);

  return FilePickerFolderFormRow;
}(_react["default"].Component);

FilePickerFolderFormRow.propTypes = {
  /**
  *folderIcon is a string that is used to generate the icon from the following otherwise
  *it will use the default settings.
  *<<example>>
              1: uifw-fm-icon--folder-product-category-images
              2: uifw-fm-icon--folder-design-images
              3: uifw-fm-icon--folder-css
              4: uifw-fm-icon--folder-scripts
              5: uifw-fm-icon--folder-other
  */
  folderIcon: _propTypes["default"].string,

  /**
  * folderName is a string used to represent the name of the entity.
  */
  folderName: _propTypes["default"].string.isRequired,
  selectFolder: _propTypes["default"].func.isRequired,
  uri: _propTypes["default"].string.isRequired
};
FilePickerFolderFormRow.defaultProps = {
  folderIcon: 'uifw-fm-icon--folder-default'
};
var _default = FilePickerFolderFormRow;
exports["default"] = _default;