"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Text = _interopRequireDefault(require("../Text"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _Button = _interopRequireDefault(require("../Button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The FilePickerToolbar component is used alongside the FilePicker to allow the
    the user to input a search parameter.<p>
 */
var FilePickerToolbar =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilePickerToolbar, _React$Component);

  function FilePickerToolbar() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FilePickerToolbar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FilePickerToolbar)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "updateSearchQuery", function (e) {
      _this.props.updateSearchQuery(e);
    });

    return _this;
  }

  _createClass(FilePickerToolbar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        className: "uifw-file-manager__toolbar"
      }, _react["default"].createElement("div", {
        className: "uifw-file-manager__toolbar-buttons"
      }, _react["default"].createElement(_Button["default"], {
        buttonText: "Upload Image",
        icon: "uifw-icon uifw-icon-upload left",
        clickCallback: this.props.toggleDisplayModal
      })), _react["default"].createElement("div", {
        className: "uifw-file-manager__toolbar-search"
      }, _react["default"].createElement("span", {
        className: "uifw-text-field-with-icon icon-left"
      }, _react["default"].createElement(_Icon["default"], {
        icon: "uifw-icon-search"
      }), _react["default"].createElement(_Text["default"], {
        inputId: "filePickerToolbarSearch",
        type: "text",
        value: this.props.searchQuery,
        changeCallback: function changeCallback(e) {
          _this2.updateSearchQuery(e);
        },
        placeholder: "Search your files..."
      }))));
    }
  }]);

  return FilePickerToolbar;
}(_react["default"].Component);

FilePickerToolbar.propTypes = {
  /**
  *The string that is displayed in the text area.
  */
  searchQuery: _propTypes["default"].string,

  /**
   * A function that is passed in that is to update the string.
   <<example>>updateSearchQuery={this.updateSearchQuery}
   */
  updateSearchQuery: _propTypes["default"].func.isRequired,

  /**
  * A function that is passed in to the button to attach functionality.
  * <<example>> toggleDisplayModal={this.toggleDisplayModal}
  */
  toggleDisplayModal: _propTypes["default"].func.isRequired
};
FilePickerToolbar.defaultProps = {
  searchQuery: ''
};
var _default = FilePickerToolbar;
exports["default"] = _default;