"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ReactDialog = _interopRequireDefault(require("../ReactDialog"));

var _ButtonSection = _interopRequireDefault(require("../Section/ButtonSection"));

var _Button = _interopRequireDefault(require("../Button"));

var _FormRow = _interopRequireDefault(require("../FormRow"));

var _Label = _interopRequireDefault(require("../Label"));

var _FileUpload = _interopRequireDefault(require("../FileUpload"));

var _ImagePreview = _interopRequireDefault(require("../ImagePreview"));

var _InlineMessage = _interopRequireDefault(require("../InlineMessage"));

var _FilePickerOverrideFileModal = _interopRequireDefault(require("./FilePickerOverrideFileModal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>
 *   FilePickerUploadFileModal is a component that provies the extra modal layer.
 * </p>
 */
var FilePickerUploadFileModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilePickerUploadFileModal, _React$Component);

  function FilePickerUploadFileModal(props) {
    var _this;

    _classCallCheck(this, FilePickerUploadFileModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FilePickerUploadFileModal).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "setNewFile", function (file) {
      if (file !== undefined) {
        if (/(jpe?g|png|gif|svg|bmp|webp)$/i.test(file[0].name.split('.').pop()) === false) {
          _this.setState({
            displayInlineWarningFileType: true
          });
        } else {
          _this.setState({
            modalFile: file[0],
            displayInlineWarning: false,
            displayInlineWarningFileType: false
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "uploadNewFile", function () {
      if (_this.state.modalFile != null) {
        var promise = _this.props.uploadNewFile(_this.state.modalFile);

        promise.then(function (response) {
          if (response.Result !== 2) {
            _this.setState({
              modalFile: null,
              displayInlineWarning: false,
              displayInlineWarningFileType: false
            });

            _this.props.toggleModal();
          } else {
            _this.setState({
              overrideModalVisible: true
            });
          }
        });
      } else {
        _this.setState({
          displayInlineWarning: true
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "closeWarningModal", function () {
      _this.setState({
        overrideModalVisible: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "overrideUpload", function () {
      var promise = _this.props.uploadNewFile(_this.state.modalFile, true);

      promise.then(function (response) {
        if (response.Result !== 2) {
          _this.setState({
            modalFile: null,
            displayInlineWarning: false,
            displayInlineWarningFileType: false
          });

          _this.props.toggleModal();

          _this.closeWarningModal();
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelModal", function () {
      _this.props.toggleModal();

      _this.setState({
        displayInlineWarningFileType: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "generateFooter", function () {
      return _react["default"].createElement(_ButtonSection["default"], null, _react["default"].createElement(_Button["default"], {
        buttonText: "Cancel",
        cssClass: "normal left",
        clickCallback: _this.cancelModal
      }), _react["default"].createElement(_Button["default"], {
        disabled: _this.props.buttonDisabled || _this.state.displayInlineWarning,
        buttonText: "Upload File",
        cssClass: "right primary",
        icon: "uifw-icon uifw-icon-upload left",
        clickCallback: _this.uploadNewFile
      }));
    });

    _this.state = {
      modalFile: null,
      displayInlineWarning: false,
      displayInlineWarningFileType: false,
      overrideModalVisible: false
    };
    return _this;
  }

  _createClass(FilePickerUploadFileModal, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", null, _react["default"].createElement(_ReactDialog["default"].Component, {
        displayDialog: this.props.isModalVisible,
        header: "Upload File",
        clickClose: this.props.toggleModal,
        footer: this.generateFooter()
      }, _react["default"].createElement(_FormRow["default"], {
        id: "fileUploadFormRow",
        type: "sbs",
        additionalCssClasses: "flex"
      }, _react["default"].createElement(_Label["default"], {
        labelHeader: "Select File",
        labelDescription: "Select a file from your device to upload."
      }), _react["default"].createElement(_FileUpload["default"], {
        name: "uploadImageFilePicker",
        buttonIcon: "uifw-icon-upload left",
        onChange: this.setNewFile,
        buttonText: "Select File",
        accept: ".png, .jpg, .jpeg, .gif, .bmp, .svg, .webp"
      })), this.state.modalFile != null ? _react["default"].createElement(_ImagePreview["default"], {
        previewImage: window.URL.createObjectURL(this.state.modalFile)
      }) : null, this.state.displayInlineWarning ? _react["default"].createElement(_InlineMessage["default"], {
        message: "Please select a file to be uploaded.",
        type: "warning",
        additionalClasses: "u-ta-c"
      }) : null, this.state.displayInlineWarningFileType ? _react["default"].createElement(_InlineMessage["default"], {
        message: "File type must be one of the following: png, jpg, jpeg, gif, bmp, svg or webp.",
        type: "warning",
        additionalClasses: "u-ta-c"
      }) : null), _react["default"].createElement(_FilePickerOverrideFileModal["default"], {
        isModalVisible: this.state.overrideModalVisible,
        fileName: this.state.modalFile != null ? this.state.modalFile.name : '',
        toggleModal: this.closeWarningModal,
        overrideUpload: this.overrideUpload
      }));
    }
  }]);

  return FilePickerUploadFileModal;
}(_react["default"].Component);

FilePickerUploadFileModal.propTypes = {
  /**
   * isModalVisible is a boolean value this is passed in dictate the visibilty of the modal
   * <<example>> isModalVisible={false}
   */
  isModalVisible: _propTypes["default"].bool.isRequired,

  /**
   * toggleModal is a function that is applied to the opening and clossing functionality
   * <<example>> clickCallback={this.props.toggleModal}
   */
  toggleModal: _propTypes["default"].func.isRequired,

  /**
   * uploadNewFile is a function that takes in the argument for the file that the user has selected
   * <<example>> uploadNewFile={(file) => { this.uploadNewFile(file); }}
   */
  uploadNewFile: _propTypes["default"].func.isRequired,

  /**
   * buttonDisabled is a bool value to determine whether to disabled the upload button or not.
   */
  buttonDisabled: _propTypes["default"].bool.isRequired
};
var _default = FilePickerUploadFileModal;
exports["default"] = _default;