"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FilePickerToolbar = _interopRequireDefault(require("./FilePickerToolbar"));

var _FilePickerBreadcrumbHeader = _interopRequireDefault(require("./FilePickerBreadcrumbHeader"));

var _FilePickerFolderFormRow = _interopRequireDefault(require("./FilePickerFolderFormRow"));

var _FilePickerFileFormRow = _interopRequireDefault(require("./FilePickerFileFormRow"));

var _FilePickerUploadFileModal = _interopRequireDefault(require("./FilePickerUploadFileModal"));

var _FilePickerNBUIRow = _interopRequireDefault(require("./FilePickerNBUIRow"));

var _FilePickerEmptyFolderView = _interopRequireDefault(require("./FilePickerEmptyFolderView"));

var _FilePickerNoFilteredContent = _interopRequireDefault(require("./FilePickerNoFilteredContent"));

var _FilePickerDeleteConfirmationModal = _interopRequireDefault(require("./FilePickerDeleteConfirmationModal"));

var _ReactDialog = _interopRequireDefault(require("../ReactDialog"));

var _Button = _interopRequireDefault(require("../Button"));

var _Pagination = _interopRequireDefault(require("../Pagination"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>
 *  The FilePicker component is used to access a file structer and allow the selection
 *  of either sun-folders or files that are associated with the current file.
 * <p>
 */
var FilePicker =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilePicker, _React$Component);

  function FilePicker(props) {
    var _this;

    _classCallCheck(this, FilePicker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FilePicker).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "toggleDisplayUploadModal", function () {
      _this.setState({
        displayUploadModal: !_this.state.displayUploadModal
      });
    });

    _defineProperty(_assertThisInitialized(_this), "toggleDeleteConfirmationModal", function (imageUri) {
      if (imageUri !== null && imageUri !== undefined) {
        _this.setState(_objectSpread({}, _this.state, {
          fileToDelete: imageUri
        }));
      }

      _this.setState({
        displayDeleteConfirmationModal: !_this.state.displayDeleteConfirmationModal
      });

      _this.props.deleteImageCallback(_this.state.fileToDelete);
    });

    _defineProperty(_assertThisInitialized(_this), "generateNBUIRows", function () {
      var options = [];

      for (var i = 0; i < 5; i += 1) {
        options.push(_react["default"].createElement(_FilePickerNBUIRow["default"], {
          key: 'nbuiRow' + i
        }));
      }

      return options;
    });

    _defineProperty(_assertThisInitialized(_this), "paginationClickCallback", function (pageNumber) {
      _this.props.paginationClickCallback(pageNumber);
    });

    _defineProperty(_assertThisInitialized(_this), "footerButton", function () {
      return _react["default"].createElement(_Button["default"], {
        buttonText: "Close",
        cssClass: "normal left",
        clickCallback: _this.props.closeFileManager
      });
    });

    _defineProperty(_assertThisInitialized(_this), "generatePagination", function () {
      return _this.props.data.enablePagination != null ? _react["default"].createElement(_Pagination["default"], {
        totalNumberOfItems: _this.props.data.enablePagination.totalItems,
        itemsPerPage: _this.props.data.enablePagination.pageLimit,
        currentPage: _this.props.data.enablePagination.pageNumber,
        clickCallback: _this.paginationClickCallback
      }) : null;
    });

    _defineProperty(_assertThisInitialized(_this), "generateMainView", function () {
      if (_this.props.data.options.length === 0 && _this.props.data.searchQuery.length > 0) {
        return _react["default"].createElement(_FilePickerNoFilteredContent["default"], {
          query: _this.props.data.searchQuery
        });
      } else if (_this.props.data.options.length === 0 && _this.props.data.searchQuery.length === 0) {
        return _react["default"].createElement(_FilePickerEmptyFolderView["default"], null);
      }

      var returnRows = _this.props.data.options.map(function (option) {
        switch (option.type) {
          case 0:
            return _react["default"].createElement(_FilePickerFileFormRow["default"], {
              imageSrc: option.imageSource,
              fileName: option.name,
              lastModificationDate: option.lastModificationDate,
              selectFile: _this.props.onContentClick,
              uri: option.uri,
              key: option.name,
              showDeleteButton: Boolean(_this.props.deleteImageCallback),
              onDeleteButtonClick: function onDeleteButtonClick(imageUri) {
                _this.toggleDeleteConfirmationModal(imageUri);
              }
            });

          case 1:
            return _react["default"].createElement(_FilePickerFolderFormRow["default"], {
              folderName: option.name,
              folderIcon: option.folderIcon,
              selectFolder: _this.props.onContentClick,
              uri: option.uri,
              key: option.name
            });

          default:
            return null;
        }
      });

      return returnRows;
    });

    _this.state = {
      displayUploadModal: false,
      displayDeleteConfirmationModal: false,
      fileToDelete: ''
    };
    return _this;
  }

  _createClass(FilePicker, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", null, _react["default"].createElement(_ReactDialog["default"].Component, {
        displayDialog: this.props.isFilePickerVisible,
        header: "Select File",
        clickClose: this.props.closeFileManager,
        extraCssClass: "uifw-dialog--file-picker uifw-dialog--no-padding",
        footer: this.footerButton()
      }, _react["default"].createElement("section", {
        className: "uifw-file-manager uifw-file-manager--file-picker"
      }, _react["default"].createElement(_FilePickerToolbar["default"], {
        searchQuery: this.props.data.searchQuery,
        updateSearchQuery: this.props.updateSearchQuery,
        toggleDisplayModal: this.toggleDisplayUploadModal
      }), this.props.data.breadcrumbHeaderOptions.length > 0 ? _react["default"].createElement(_FilePickerBreadcrumbHeader["default"], {
        togglePopoutSection: this.props.togglePopoutSection,
        breadcrumbHeaderOptions: this.props.data.breadcrumbHeaderOptions,
        isPopoutViewable: this.props.data.isPopoutViewable,
        selectFolderToView: this.props.onContentClick
      }) : null, this.props.isLoaded ? _react["default"].createElement("div", {
        id: "contentView",
        className: "uifw-file-manager__content"
      }, this.generateMainView(), this.generatePagination()) : this.generateNBUIRows())), _react["default"].createElement(_FilePickerUploadFileModal["default"], {
        isModalVisible: this.state.displayUploadModal,
        toggleModal: this.toggleDisplayUploadModal,
        uploadNewFile: this.props.uploadNewFile,
        buttonDisabled: this.props.buttonDisabled
      }), _react["default"].createElement(_FilePickerDeleteConfirmationModal["default"], {
        isModalVisible: this.state.displayDeleteConfirmationModal,
        cancelCallback: this.toggleDeleteConfirmationModal,
        deleteImageCallback: function deleteImageCallback() {
          _this2.toggleDeleteConfirmationModal();
        }
      }));
    }
  }]);

  return FilePicker;
}(_react["default"].Component);

FilePicker.propTypes = {
  isFilePickerVisible: _propTypes["default"].bool.isRequired,

  /**
   * A function that is passed in that is associated with the closing for the dialog.
   <<example>>closeFileManager={this.closeFilePickerDialog}
   */
  closeFileManager: _propTypes["default"].func.isRequired,

  /**
  * A function that is used to update the string for the search query
  <<example>>updateSearchQuery={this.updateSearchQuery}
  */
  updateSearchQuery: _propTypes["default"].func.isRequired,

  /**
  * A function that is used to retrive the folder/filename and what type it is
  <<example>>onContentClick={this.onContentClick({
    type: 0,
    name: 'example'
  })}
  */
  onContentClick: _propTypes["default"].func.isRequired,

  /**
  * A function that is used to update the visibilty of the popout section
  <<example>>togglePopoutSection={this.togglePopoutSection}
  */
  togglePopoutSection: _propTypes["default"].func.isRequired,

  /**
  * data is the object that is passed in to determine what is rendered and how
  *it should be rendered.
  *<<example>> data={{
              options: [{
                type: 0,
                name: 'Test Folder',
              }, {
                type: 1,
                name: 'Test File',
                lastModificationDate: '21-20-26',
              }],
              breadcrumbHeaderOptions: [{
                folderName: 'Test',
                folderThumbnail: 'folder-product-category-images',
              }, {
                folderName: 'Test 2',
              }],
              isPopoutViewable: false,
              searchQuery: 'Test String Inside Data Object',
            }}
  */
  data: _propTypes["default"].shape({
    searchQuery: _propTypes["default"].string,
    isPopoutViewable: _propTypes["default"].bool,
    options: _propTypes["default"].oneOfType([_propTypes["default"].array]),
    breadcrumbHeaderOptions: _propTypes["default"].oneOfType([_propTypes["default"].array]),
    enablePagination: _propTypes["default"].shape({
      pageLimit: _propTypes["default"].number,
      pageNumber: _propTypes["default"].number
    })
  }),

  /**
   * paginationClickCallback is a function that will return the page number
   * that was clicked.
   * <<example>> paginationClickCallback={(21) => {}}
   */
  paginationClickCallback: _propTypes["default"].func,

  /**
   * uploadNewFile is a function that will return the file that the user has
   * selected otherwise it will return null
   * <<example>> uploadNewFile={(file || null) => {
   *     this.customFunction()
   *  }}
   */
  uploadNewFile: _propTypes["default"].func.isRequired,
  isLoaded: _propTypes["default"].bool.isRequired,

  /**
   * deleteImageCallback is a function that will return the file name that the user has
   * selected to delete
   * <<example>> deleteImageCallback={(imageUri || null) => {
   *     this.customDeleteFunction()
   *  }}
   */
  deleteImageCallback: _propTypes["default"].func,

  /**
   * buttonDisabled is a bool that will control whether the upload upload button is disbaled or not
   * to prevent the user from clicking the upload button multiple times.
   */
  buttonDisabled: _propTypes["default"].bool
};
FilePicker.defaultProps = {
  data: {
    searchQuery: '',
    isPopoutViewable: false,
    options: [],
    breadcrumbHeaderOptions: [],
    enablePagination: {
      pageLimit: 0,
      pageNumber: 1
    }
  },
  paginationClickCallback: null,
  deleteImageCallback: null,
  buttonDisabled: false
};
var _default = FilePicker;
exports["default"] = _default;