"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _jquery = _interopRequireDefault(require("jquery"));

var _Validation = _interopRequireDefault(require("../../Utils/Validation"));

var _ValidationMessage = _interopRequireDefault(require("../../Utils/Validation/ValidationMessage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The File Upload Component renders an input component that a user can click
 * to open the file dialog. See <a href="http://internal-uifw/elements.html#buttons-file-upload" target="_blank">File Upload</a> for more information.</p>
 */
var FileUpload =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FileUpload, _React$Component);

  function FileUpload(props) {
    var _this;

    _classCallCheck(this, FileUpload);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FileUpload).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "onChange", function () {
      var fileData = _this.fileInput.files;

      _this.validate(fileData);

      if (_this.props.onChange) {
        _this.props.onChange(fileData);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "validate", function (value) {
      var result = _Validation["default"].validateText(value, _this.props.validation);

      var newClass = _this.state.cssClass.replace("error", "");

      if (!result.valid) {
        newClass = "".concat(newClass.trim(), " error");
      }

      _this.setState({
        cssClass: newClass,
        validationObject: result
      });

      return result;
    });

    _this.state = {
      validationObject: {
        valid: true
      },
      validationMsgInlineStyle: _this.props.validationStyleOverride,
      cssClass: "",
      formValidationMessage: ""
    };
    return _this;
  }

  _createClass(FileUpload, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      (0, _jquery["default"])(this.node).find("input").data("validation", this.props.validation);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      (0, _jquery["default"])(this.node).find("input").data("validation", this.props.validation);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var icon = this.props.buttonIcon == null ? null : _react["default"].createElement("i", {
        className: (0, _classnames["default"])("uifw-icon", this.props.buttonIcon)
      });
      var validationComponent = null;

      if (this.props.validation && !this.state.validationObject.valid || this.state.formValidationMessage && this.state.formValidationMessage !== "") {
        if (this.state.formValidationMessage && this.state.formValidationMessage !== "") {
          this.state.validationObject.errorMsg = this.state.formValidationMessage;

          if (this.state.cssClass.indexOf("error") < 0) {
            this.state.cssClass += " error";
          }
        }

        validationComponent = _react["default"].createElement(_ValidationMessage["default"], {
          message: this.state.validationObject.errorMsg,
          additionalClasses: (0, _classnames["default"])("uifw-validation-message", this.props.validationCssClasses),
          styleOverride: this.state.validationMsgInlineStyle
        });
      }

      var isTopValidation = this.props.validationCssClasses && this.props.validationCssClasses.indexOf("top") > -1;
      var topValidation = isTopValidation ? validationComponent : null;
      var bottomValidation = !isTopValidation ? validationComponent : null;
      return _react["default"].createElement("div", {
        ref: function ref(node) {
          _this2.node = node;
        },
        className: this.props.fileUploadCss
      }, topValidation, _react["default"].createElement("div", null, _react["default"].createElement("label", {
        htmlFor: this.props.name,
        className: (0, _classnames["default"])("uifw-button", this.state.cssClass, this.props.buttonClasses)
      }, icon, this.props.buttonText)), bottomValidation, _react["default"].createElement("input", {
        ref: function ref(fileInput) {
          _this2.fileInput = fileInput;
        },
        type: "file",
        id: this.props.name,
        accept: this.props.accept,
        multiple: this.props.multiple,
        name: this.props.name,
        className: "u-hide",
        validation: this.props.validation,
        onChange: this.onChange
      }));
    }
  }]);

  return FileUpload;
}(_react["default"].Component);

FileUpload.propTypes = {
  /**
   * The string name that is passed to the input id and name as well as the
   * htmlFor attribute on the label
   <<example>> name="string"
   */
  name: _propTypes["default"].string.isRequired,

  /**
   * The string of text to be displayed on the button
   <<example>> buttonText="string"
   */
  buttonText: _propTypes["default"].string.isRequired,

  /**
   * The function that is executed when the value of the upload component is changed
   <<example>> onChange={self.handleFileUploadChange}
   */
  onChange: _propTypes["default"].func.isRequired,

  /**
   * The icon class that is given to the button
   <<example>> buttonIcon="uifw-icon-search"
   */
  buttonIcon: _propTypes["default"].string,

  /**
   * The additional classes that are appended to the button class
   <<example>> buttonClasses="string"
   */
  buttonClasses: _propTypes["default"].string,

  /**
   * The accept attribute that is passed through to the input component
   <<example>> accept="string"
   */
  accept: _propTypes["default"].string,

  /**
   * The multiple attribute that is passed through to the input component - when set to true, more than one file can be selected
   <<example>> multiple={true}
   */
  multiple: _propTypes["default"].bool,

  /**
   * An array of validation rules
   <<example>> validation={
    [
      {
        action: "required",
        errorMsg: "File is required."
      }
    ]
   }
   */
  validation: _propTypes["default"].array,

  /**
   * The additional CSS classes that are passed to the validation message div
   <<example>> validationCssClasses="string"
   */
  validationCssClasses: _propTypes["default"].string,

  /**
   * The inline style that is passed to the validation message div
   <<example>> validationStyleOverride={
    {
      paddingTop: "20px",
      color: "#000"
    }
   }
   */
  validationStyleOverride: _propTypes["default"].object
};
var _default = FileUpload;
exports["default"] = _default;