"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var classnames = require("classnames");
/**
 * <p>The Form Row Section component is used to display an inner section within the '<b>Section.js</b>' component. See <a href="http://internal-uifw/elements.html#form-layouts" target="_blank">Form Layouts</a> for more information.</p>
 */


var FormRowSection =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FormRowSection, _React$Component);

  function FormRowSection() {
    _classCallCheck(this, FormRowSection);

    return _possibleConstructorReturn(this, _getPrototypeOf(FormRowSection).apply(this, arguments));
  }

  _createClass(FormRowSection, [{
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: classnames("uifw-form-row-section", this.props.additionalClasses)
      }, this.props.children);
    }
  }]);

  return FormRowSection;
}(React.Component);

_defineProperty(FormRowSection, "propTypes", {
  /**
     * The content of the for row section
   <<example>><uifw.FormRowSection>
   *  <SectionContent>...</SectionContent>
   *</uifw.FormRowSection>
     */
  children: PropTypes.any.isRequired,

  /**
     * The additional classes that are given to the form row section div
   <<example>>additionalClasses="string"
     */
  additionalClasses: PropTypes.string
});

var _default = FormRowSection;
exports["default"] = _default;