"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var classNames = require('classnames');
/**
 * <p>The Form Row component is used to layout the form row content. It can either be Side By Side, Stacked or Stacked No Styling.
 * It is used within the '<b>Section.js</b>' component. See <a href="http://internal-uifw/elements.html#form-layouts" target="_blank">Form Layouts</a> for more information.</p>
 */


var FormRow =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FormRow, _React$Component);

  function FormRow() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FormRow);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FormRow)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isLoaded: false
    });

    return _this;
  }

  _createClass(FormRow, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (!this.state.isLoaded && nextProps.visible !== this.props.visible) this.setState({
        isLoaded: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var cssClasses = classNames("uifw-form-row", this.props.type, {
        'flex': this.props.flex
      }, {
        "u-anim-fadeout": this.props.visible === false && this.state.isLoaded === true,
        "u-anim-fadein": this.props.visible === true && this.state.isLoaded === true,
        "u-hide": this.props.visible === false && this.state.isLoaded === false,
        "u-show": this.props.visible === true && this.state.isLoaded === false
      }, this.props.additionalCssClasses);
      var childElements,
          children = this.props.children;
      var label, field, otherChildren;

      if (Array.isArray(children) && children.length > 1 && this.props.type !== "buttons" && !this.props.excludeFields) {
        var labelElement = children.slice(0, 1);
        var fieldElement = children.slice(1, 2);
        var otherChildrens = children.slice(2);
        label = React.createElement("div", {
          className: "uifw-form-row-information"
        }, labelElement);
        field = React.createElement("div", {
          className: "uifw-form-row-field"
        }, fieldElement);

        if (otherChildrens.length > 0) {
          otherChildren = React.createElement("div", null, otherChildrens);
        }
      } else {
        label = this.props.children;
      }

      return React.createElement("div", {
        id: this.props.id,
        className: cssClasses,
        "data-uifw-field-type": this.props.fieldType,
        style: this.props.style,
        "data-additional-data": this.props.additionalData
      }, label, field, otherChildren);
    }
  }]);

  return FormRow;
}(React.Component);

_defineProperty(FormRow, "propTypes", {
  /**
   * The type of the form row
   <<example>>type="sbs" // Side By Side
     * type="stacked" // Stacked
     * type="" // Stacked No Styling
   */
  type: PropTypes.string,

  /**
   * The field type of the form row refers to the input that will be in the row
   <<example>>fieldType="text-field" // Text field
     * fieldType="checkbox" // Checkbox
   * fieldType="checkbox-list" // List of Checkboxes
     * fieldType="text-area" // Text area
     * fieldType="select" // Select
     * fieldType="toggle" // Toggle switch
   */
  fieldType: PropTypes.string,

  /**
   * The inline style object for the row
   * <<example>> style={
     {
      marginTop: "20px",
      colour: "#000"
    }
   }
   */
  style: PropTypes.object,

  /**
   * The id of the wrapping div if one is needed
   <<example>>id="string"
   */
  id: PropTypes.string,

  /**
   * Sets the visibility of the form row, the row is displayed when the value is true or undefined,
   * it is hidden when set to false
   <<example>>visible={false}
   */
  visible: PropTypes.bool,

  /**
   * The additional classes for the wrapping form div
   <<example>>additionalCssClasses="string"
   */
  additionalCssClasses: PropTypes.string,

  /**
   * The DOM elements that are to be displayed in the form row
   <<example>><uifw.FormRow>
   *	  <FormRowContent>...</FormRowContent>
   *</uifw.FormRow>
   */
  additionalData: PropTypes.string,
  flex: PropTypes.bool,
  excludeFields: PropTypes.bool,
  children: PropTypes.oneOfType([PropTypes.array, PropTypes.object])
});

var _default = FormRow;
exports["default"] = _default;