"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _GridRow = _interopRequireDefault(require("./GridRow"));

var _GridColumn = _interopRequireDefault(require("./GridColumn"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Helper function for splitting arrays into nested arrays,
// for easily creating the rows and columns.
function convertToColumns(input, columnsPerRow) {
  var maxColumns = 12;

  if (columnsPerRow == null || columnsPerRow === 0) {
    var length = input.length === 0 ? 1 : input.length;
    columnsPerRow = maxColumns / length;
  }

  if (columnsPerRow > maxColumns) {
    columnsPerRow = maxColumns;
  }

  var modifiedInput = input.slice(0);
  var rows = [];

  while (modifiedInput.length > 0) {
    rows.push(modifiedInput.splice(0, columnsPerRow));
  }

  return rows;
} // Can be used within a uifw.Grid to output an evenly spaced array of
// columns in grid rows.

/**
 * <p>Can be used within the '<b>Grid.js</b>' Component to output an evenly spaced array of columns in grid rows. See <a href="http://internal-uifw/docs/grid.html" target="_blank">Grids</a> for more information.</p>
 */


var GridDynamicRow =
/*#__PURE__*/
function (_React$Component) {
  _inherits(GridDynamicRow, _React$Component);

  function GridDynamicRow() {
    _classCallCheck(this, GridDynamicRow);

    return _possibleConstructorReturn(this, _getPrototypeOf(GridDynamicRow).apply(this, arguments));
  }

  _createClass(GridDynamicRow, [{
    key: "render",
    value: function render() {
      var rows = [[this.props.children]];

      if (_react["default"].Children.count(this.props.children) > 1) {
        rows = convertToColumns(this.props.children, this.props.columnsPerRow);
      }

      var colSize = Math.ceil(12 / this.props.columnsPerRow);
      var rowClasses = this.props.rowClasses;
      return _react["default"].createElement("span", null, rows.map(function (row, rowIndex) {
        return _react["default"].createElement(_GridRow["default"], {
          key: rowIndex,
          additionalClasses: rowClasses
        }, row.map(function (column, colIndex) {
          return _react["default"].createElement(_GridColumn["default"], {
            key: colIndex,
            ibtype: "mid",
            colsize: colSize + ""
          }, column);
        }));
      }));
    }
  }]);

  return GridDynamicRow;
}(_react["default"].Component);

_defineProperty(GridDynamicRow, "propTypes", {
  /**
     * The number of columns per row in the grid
   <<example>>columnsPerRow={4}
     */
  columnsPerRow: _propTypes["default"].number.isRequired,

  /**
     * The inline block type of each column
   <<example>>columnIbType="string"
     */
  columnIbType: _propTypes["default"].string,

  /**
     * The rows that will make up the grid
   <<example>><uifw.GridDynamicRow>
   *  <GridRow>...</GridRow>
   *  <GridRow>...</GridRow>
   *  <GridRow>...</GridRow>
   *</uifw.GridDynamicRow>
     */
  children: _propTypes["default"].any,
  rowClasses: _propTypes["default"].string
});

var _default = GridDynamicRow;
exports["default"] = _default;