"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _jquery = _interopRequireDefault(require("jquery"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The HUD Component is used to inform a user of some event on the page.
 * This is primarily used for displaying some form of loading message and then
 * whether that action has been completed successfully or not. See <a href='http://internal-uifw/elements.html#message-activity-hud' target='_blank'>Activity HUD</a> for more information.</p>
 */
var HUD =
/*#__PURE__*/
function (_Component) {
  _inherits(HUD, _Component);

  function HUD() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, HUD);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(HUD)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "updateHUD", function () {
      var mainColSelector = '.uifw-layout-maincol';
      var hudOptions = {
        relativeElement: mainColSelector
      };

      if (_this.props.dismissCallback) {
        hudOptions.dismissCallback = _this.props.dismissCallback;
      }

      _jquery["default"].uifwActivityHUD(hudOptions);

      _jquery["default"].uifwActivityHUD('setDismissCallback', _this.props.dismissCallback);

      if (_this.props.text && _this.props.type) {
        if (_this.props.type === 'success') {
          setTimeout(function () {
            _jquery["default"].uifwActivityHUD(_this.props.type);

            _jquery["default"].uifwActivityHUD('changeText', _this.props.text);
          }, 1000);
        } else {
          _jquery["default"].uifwActivityHUD(_this.props.type);

          _jquery["default"].uifwActivityHUD('changeText', _this.props.text);
        }
      } else if (_this.props.type === 'hide') {
        _jquery["default"].uifwActivityHUD('hide');
      }
    });

    return _this;
  }

  _createClass(HUD, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.updateHUD();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if ((document.readyState === 'interactive' || document.readyState === 'complete') && (prevProps.type !== this.props.type || prevProps.text !== this.props.text || prevProps.dismissCallback != this.props.dismissCallback)) {
        this.updateHUD();
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", null);
    }
  }]);

  return HUD;
}(_react.Component);

_defineProperty(HUD, "propTypes", {
  /**
   * The text that is displayed on the hud element
   <<example>>text='string'
   */
  text: _propTypes["default"].string.isRequired,

  /**
   * The type of the hud element, this can either be <code>loading</code>, <code>success</code> or <code>error</code>
   <<example>>type='loading'
   *type='success'
   *type='error'
   */
  type: _propTypes["default"].string.isRequired,

  /**
   * The callback function that will execute once the hud element has been dismissed
   <<example>>dismissCallback={self.handleHudClosed}
   */
  dismissCallback: _propTypes["default"].func
});

var _default = HUD;
exports["default"] = _default;