"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var ReactDOM = require('react-dom');

var $ = require("jquery");

var classnames = require('classnames');
/**
 * Displays a tooltip with some underlining of the child text.
 * See <a href='http://internal-uifw/elements.html#message-help-prompts'>here</a>.
 */


var HelpPrompt =
/*#__PURE__*/
function (_React$Component) {
  _inherits(HelpPrompt, _React$Component);

  function HelpPrompt() {
    _classCallCheck(this, HelpPrompt);

    return _possibleConstructorReturn(this, _getPrototypeOf(HelpPrompt).apply(this, arguments));
  }

  _createClass(HelpPrompt, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.tooltip == null) {
        this.tooltip = $(ReactDOM.findDOMNode(this)).uifwHelpPrompts();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.tooltip != null) {
        $(this.tooltip).remove();
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("span", {
        className: classnames('uifw-help-prompt', this.props.additionalClasses),
        title: this.props.title,
        "data-uifw-help-prompt-body": this.props.body
      }, this.props.children);
    }
  }]);

  return HelpPrompt;
}(React.Component);

_defineProperty(HelpPrompt, "propTypes", {
  /**
   * The title of the help prompt.
   */
  title: PropTypes.string,

  /**
   * The body of the help prompt.
   */
  body: PropTypes.string,

  /**
   * Additional Css Classes for the wrapper
   */
  additionalClasses: PropTypes.string,

  /**
   * The elements to put the help prompt around.
   */
  children: PropTypes.oneOfType([PropTypes.object, PropTypes.array])
});

var _default = HelpPrompt;
exports["default"] = _default;