"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function Icon(props) {
  var icon = null;

  switch (props.type) {
    case 'standard':
      icon = _react["default"].createElement("i", {
        className: (0, _classnames["default"])('uifw-icon-standard', props.icon, props.position, props.size, props.additionalClasses)
      });
      break;

    case 'fontAwesome':
      icon = _react["default"].createElement("i", {
        className: (0, _classnames["default"])('uifw-icon', props.icon, props.position, props.colour, props.additionalClasses)
      });
      break;

    case 'flagCountry':
      icon = _react["default"].createElement("i", {
        className: "uifw-icon-flags",
        "data-uifw-flags-country": props.data
      });
      break;

    case 'flagCurrency':
      icon = _react["default"].createElement("i", {
        className: "uifw-icon-flags",
        "data-uifw-flags-currency": props.data
      });
      break;

    case 'creditCard':
      icon = _react["default"].createElement("i", {
        className: "uifw-icon-cards",
        "data-uifw-cards-type": props.data
      });
      break;

    case 'badge':
      icon = _react["default"].createElement("span", {
        className: (0, _classnames["default"])('uifw-icon-badge', props.position, props.size ? "uifw-icon-badge--".concat(props.size) : '', props.badgeType ? "uifw-icon-badge--".concat(props.badgeType) : 'uifw-icon-badge--icon-expand')
      }, _react["default"].createElement("i", {
        className: (0, _classnames["default"])('uifw-icon', props.icon)
      }));
      break;

    case 'static':
      icon = _react["default"].createElement("i", {
        className: (0, _classnames["default"])('uifw-static-icon', props.icon)
      });
      break;

    default:
      icon = _react["default"].createElement("i", {
        className: (0, _classnames["default"])('uifw-icon', props.icon, props.position, props.colour, props.additionalClasses)
      });
  }

  return icon;
}

Icon.propTypes = {
  // optional
  icon: _propTypes["default"].string,
  position: _propTypes["default"].string,
  type: _propTypes["default"].oneOf(['standard', 'fontAwesome', 'flagCountry', 'flagCurrency', 'creditCard', 'badge', 'static']),
  data: _propTypes["default"].string,
  size: _propTypes["default"].oneOf(['tiny', 'xsmall', 'small', 'medium', 'large']),
  colour: _propTypes["default"].string,
  badgeType: _propTypes["default"].oneOf(['information', 'good', 'error', 'warning']),
  additionalClasses: _propTypes["default"].string
};
Icon.defaultProps = {
  icon: null,
  position: null,
  type: null,
  data: null,
  size: null,
  colour: null,
  badgeType: null,
  additionalClasses: null
};
var _default = Icon;
exports["default"] = _default;