"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var $ = require('jquery');

var _ = require('underscore');

function onScroll() {
  var props = this.props;
  var scrollAmount = $(document.body).scrollTop();
  var scrollHeight = document.body.scrollHeight;
  var clientHeight = document.body.clientHeight;
  var scrolledHeight = scrollAmount + clientHeight;
  var distanceToBottom = scrollHeight - scrolledHeight;

  if (distanceToBottom <= props.loadOffset) {
    this._onLoadData();
  }
}

var warnOnce = function warnOnce(msg) {
  return _.once(function () {
    return console.warn(msg);
  });
};
/**
 * <p>A simple infinite scroll component which uses the distance from the bottom of the pages content as the trigger to load more.</p>
 */


var SimpleInfiniteScroll =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SimpleInfiniteScroll, _React$Component);

  function SimpleInfiniteScroll() {
    _classCallCheck(this, SimpleInfiniteScroll);

    return _possibleConstructorReturn(this, _getPrototypeOf(SimpleInfiniteScroll).apply(this, arguments));
  }

  _createClass(SimpleInfiniteScroll, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener("scroll", this._onScroll);
    }
  }, {
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var boundOnScroll = onScroll.bind(this);
      this._onScroll = _.debounce(boundOnScroll, 200);
      this._onLoadData = _.debounce(this.props.onLoadData, 200);
      document.addEventListener("scroll", this._onScroll);
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("span", null, this.props.children);
    }
  }]);

  return SimpleInfiniteScroll;
}(React.Component);

_defineProperty(SimpleInfiniteScroll, "defaultProps", {
  loadOffset: 0,
  onLoadData: warnOnce("SimpleInfiniteScroll.onLoadData not set")
});

_defineProperty(SimpleInfiniteScroll, "propTypes", {
  /**
   * The distance from the bottom of the page before the load should be triggered.
   <<example>> loadOffset={50}
   */
  loadOffset: PropTypes.number.isRequired,

  /**
   * The callback function to execute when the loadOffset is passed.
   <<example>> onLoadData={self.handleLoadMoreData}
   */
  onLoadData: PropTypes.func.isRequired
});

var _default = SimpleInfiniteScroll;
exports["default"] = _default;