"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var classNames = require('classnames');

function createMarkup(string) {
  return {
    __html: string
  };
}
/**
 * <p>The inline message Component is used to display information for a form row within the form row itself. See <a href="http://internal-uifw/elements.html#message-inline-message" target="_blank">Inline Message</a> for more information.</p>
 */


var InlineMessage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(InlineMessage, _React$Component);

  function InlineMessage() {
    _classCallCheck(this, InlineMessage);

    return _possibleConstructorReturn(this, _getPrototypeOf(InlineMessage).apply(this, arguments));
  }

  _createClass(InlineMessage, [{
    key: "render",
    value: function render() {
      var icon = this.props.icon == null ? "uifw-icon-exclamation-triangle" : this.props.icon;
      return React.createElement("div", {
        id: this.props.id,
        className: classNames({
          "uifw-form-row-section": !this.props.removeCss
        }, {
          "": this.props.removeCss === true,
          "u-anim-fadeout": this.props.visible !== true,
          "u-anim-fadein": this.props.visible === true
        }, this.props.additionalClasses),
        style: this.props.style
      }, React.createElement("div", {
        className: "uifw-inline-message " + this.props.type
      }, React.createElement("i", {
        className: "uifw-icon " + icon
      }), React.createElement("div", {
        className: "uifw-inline-message-body"
      }, this.props.message ? React.createElement("p", {
        dangerouslySetInnerHTML: createMarkup(this.props.message)
      }) : this.props.children)));
    }
  }]);

  return InlineMessage;
}(React.Component);

_defineProperty(InlineMessage, "defaultProps", {
  visible: true
});

_defineProperty(InlineMessage, "propTypes", {
  /**
  * The string that is to be displayed in the inline message
   <<example>>message="string"
  */
  message: PropTypes.string,

  /**
  * The type of inline message to be displayed
   <<example>>type="warning"
   *type="error"
   *type="done"
   *type="information"
  */
  type: PropTypes.string.isRequired,

  /**
  * The visibility of the inline message
   <<example>>visible={true}
  */
  visible: PropTypes.bool,

  /**
  * Additonal CSS for the wrapping div
   <<example>>additionalClasses="string"
  */
  additionalClasses: PropTypes.string,

  /**
  * The id that is given to the wrapping div
   <<example>>id="string"
  */
  id: PropTypes.string,

  /**
  * The icon that is displayed before the inline message
   <<example>>icon="uifw-icon-standard-check" // default value {"uifw-icon-exclamation-triangle"}
  */
  icon: PropTypes.string,

  /**
  * The inline style object that is passed to the wrapper div
   <<example>>style={
     {
      marginTop: "10px",
      color: "#000"
    }
   }
  */
  style: PropTypes.object
});

var _default = InlineMessage;
exports["default"] = _default;