"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

function createMarkup(string) {
  return {
    __html: string
  };
}
/**
 * <p>The Label Component is used within a form row. It is usually the header and description of an input.  See <a href="http://internal-uifw/elements.html#form-els-labels" target="_blank">Label</a> for more information.</p>
 */


var Label =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Label, _React$Component);

  function Label() {
    _classCallCheck(this, Label);

    return _possibleConstructorReturn(this, _getPrototypeOf(Label).apply(this, arguments));
  }

  _createClass(Label, [{
    key: "render",
    value: function render() {
      var required = this.props.required ? React.createElement("span", {
        className: "uifw-required-mark",
        title: "This field is required"
      }, "*") : null;
      var optional = this.props.optional ? React.createElement("span", {
        className: "uifw-optional-mark",
        title: "This field is optional"
      }, "(Optional)") : null;
      return React.createElement("div", {
        style: this.props.style
      }, React.createElement("span", {
        className: "uifw-label"
      }, required, " ", React.createElement("span", {
        style: {
          color: this.props.headerColor
        }
      }, React.createElement("span", {
        dangerouslySetInnerHTML: createMarkup(this.props.labelHeader)
      })), " ", optional, " ", this.props.headerChildren), React.createElement("p", {
        className: "uifw-label-details"
      }, React.createElement("span", {
        dangerouslySetInnerHTML: createMarkup(this.props.labelDescription)
      }), this.props.children));
    }
  }]);

  return Label;
}(React.Component);

_defineProperty(Label, "defaultProps", {
  labelDescription: ""
});

_defineProperty(Label, "propTypes", {
  /**
   * The header of the label, this is usualy a description about the input eg. 'Name'
   <<example>>labelHeader="string"
   */
  labelHeader: PropTypes.string.isRequired,

  /**
   * The label description is where more information is given about the input on the row. This can be a string or an array of strings
   <<example>>labelDescription="string||[string, string, string]"
   */
  labelDescription: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),

  /**
   * The optional value adds the extra information by adding the phrase (Optional) to the label
   <<example>>optional={true}
   */
  optional: PropTypes.bool,

  /**
   * The required value adds extra information by adding a red asterix to the label
   <<example>>optional={true}
   */
  required: PropTypes.bool,

  /**
   * The inline style object that is passed to the wrapper div
   <<example>>style={
     {
      marginTop: "10px",
      color: "#000"
    }
   }
   */
  style: PropTypes.object,

  /**
   * The CSS color of the header text
   <<example>>headerColor="#000"
   */
  headerColor: PropTypes.string,

  /**
   * Any children to pass to the the header span
   <<example>>headerChildren={<Children />}
   */
  headerChildren: PropTypes.oneOfType([PropTypes.object, PropTypes.array])
});

var _default = Label;
exports["default"] = _default;