"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
* <p>The Layout component is used to wrap the main
* component for easy setup in the settings pages.</p>
 */
var Layout = function LayoutComponent(props) {
  var columnCssClass = "uifw-".concat(props.columns.toString(), "up");
  return _react["default"].createElement("div", {
    id: props.id,
    ref: props.refCallback,
    className: (0, _classnames["default"])('uifw-layout', columnCssClass, 'cf', {
      'uifw-nbui': !props.isLoaded
    })
  }, props.children);
};

Layout.defaultProps = {
  refCallback: function refCallback() {},
  id: null,
  isLoaded: true,
  columns: 1,
  children: []
};
Layout.propTypes = {
  /**
   * A callback function that will be passed the reference to the DIV element
   * generated by the component.
   * Default: () => {}
     <<example>> refCallback={(layout) => {this.layout = layout;}}
  */
  refCallback: _propTypes["default"].func,

  /**
   * The id of the layout div
   * Default: null
     <<example>> id="layoutId"
  */
  id: _propTypes["default"].string,

  /**
   * Set true when component has loaded to remove non-blocking UI.
   * Default: true
     <<example>> isLoaded=false
  */
  isLoaded: _propTypes["default"].bool,

  /**
   * The number of columns required.
   * Default: 1
     <<example>> columns=2
  */
  columns: _propTypes["default"].number,

  /**
   * The child components to be nested inside the row.
     <<example>> <uifw.Layout><ufiw.Section><uifw.FormRow /></uifw.Section></uifw.Layout>
  */
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].array])
};
var _default = Layout;
exports["default"] = _default;