"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactChartjs = require("react-chartjs-2");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var possibleColours = ['rgba(9, 132, 227, 1)', 'rgba(56, 173, 169, 1)', 'rgba(236, 204, 104, 1)', 'rgba(255, 107, 129, 1)', 'rgba(255, 127, 80, 1)'];

var LineChart =
/*#__PURE__*/
function (_React$Component) {
  _inherits(LineChart, _React$Component);

  function LineChart() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, LineChart);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(LineChart)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getCanvasDataUrl", function () {
      var canvas = _this.getCanvasElement();

      if (canvas != null) {
        return canvas.toDataURL();
      }

      return null;
    });

    _defineProperty(_assertThisInitialized(_this), "getCanvasElement", function () {
      var canvasElements = _this.wrapper.getElementsByTagName('canvas');

      var canvas = canvasElements[0];
      return canvas;
    });

    _defineProperty(_assertThisInitialized(_this), "getImageElement", function () {
      var imageElements = _this.wrapper.getElementsByTagName('img');

      var image = imageElements[0];
      return image;
    });

    _defineProperty(_assertThisInitialized(_this), "generateCanvasImage", function () {
      var canvasUrl = _this.getCanvasDataUrl();

      if (canvasUrl == null) {
        return;
      }

      var image = _this.getImageElement();

      if (image == null) {
        var canvas = _this.getCanvasElement();

        var imageNode = document.createElement('img');
        imageNode.setAttribute('id', 'lineChartImage');
        imageNode.setAttribute('class', 'uifw-img u-hide');
        imageNode.setAttribute('src', canvasUrl);
        canvas.parentNode.appendChild(imageNode);
      } else {
        image.src = canvasUrl;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleMediaChange", function (data) {
      if (data.matches === true) {
        _this.replaceCanvasWithImage();
      } else {
        _this.resetCanvasRemoveImage();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "replaceCanvasWithImage", function () {
      var canvas = _this.getCanvasElement();

      var image = _this.getImageElement();

      canvas.className += ' u-hide';
      image.className = image.className.replace(' u-hide', '');
    });

    _defineProperty(_assertThisInitialized(_this), "resetCanvasRemoveImage", function () {
      var canvas = _this.getCanvasElement();

      var image = _this.getImageElement();

      canvas.className = canvas.className.replace(' u-hide', '');
      image.className += ' u-hide';
    });

    return _this;
  }

  _createClass(LineChart, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (window.onbeforeprint !== undefined) {
        window.onbeforeprint = this.replaceCanvasWithImage;
        window.onafterprint = this.resetCanvasRemoveImage;
      } else {
        var mediaQueryList = window.matchMedia('print');
        mediaQueryList.addListener(this.handleMediaChange);
      }
    }
  }, {
    key: "generateDataStructure",
    // Above here is all the stuff required for printing from the BarChart component
    value: function generateDataStructure() {
      var data = {
        labels: _toConsumableArray(this.props.xAxiesLabels),
        datasets: []
      };

      for (var i = 0; i < this.props.dataSet.length; i += 1) {
        data.datasets.push({
          label: this.props.dataSet[i].label,
          lineTension: 0,
          fill: false,
          backgroundColor: possibleColours[i],
          borderColor: possibleColours[i],
          pointRadius: 5,
          pointHoverRadius: 7,
          borderWidth: i === 0 ? 4 : 2,
          data: this.props.dataSet[i].data
        });
      }

      return data;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        ref: function ref(element) {
          _this2.wrapper = element;
        },
        id: this.props.id
      }, _react["default"].createElement(_reactChartjs.Line, {
        data: this.generateDataStructure(),
        options: {
          animation: {
            onComplete: this.generateCanvasImage
          },
          responsive: true,
          tooltips: {
            mode: this.props.formatToolTip,
            position: 'nearest',
            callbacks: {
              label: function label(tooltipItem) {
                return _this2.props.formatLineLabel ? _this2.props.formatLineLabel(tooltipItem) : tooltipItem.yLabel;
              },
              title: function title(tooltipItem) {
                return _this2.props.formatLineTitle ? _this2.props.formatLineTitle(tooltipItem) : tooltipItem.xLabel;
              }
            }
          },
          scales: {
            display: false,
            xAxes: [{
              categoryPercentage: 0.9,
              barPercentage: 1.0,
              gridLines: false,
              ticks: {
                padding: 10
              }
            }],
            yAxes: [{
              ticks: {
                beginAtZero: true,
                callback: function callback(value) {
                  return _this2.props.formatYAxesValue ? _this2.props.formatYAxesValue(value) : value;
                }
              }
            }]
          },
          legend: {
            position: 'bottom',
            reverse: true
          }
        }
      }));
    }
  }]);

  return LineChart;
}(_react["default"].Component);

LineChart.propTypes = {
  id: _propTypes["default"].string.isRequired,
  xAxiesLabels: _propTypes["default"].arrayOf(_propTypes["default"].string).isRequired,
  dataSet: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].string,
    data: _propTypes["default"].arrayOf(_propTypes["default"].number)
  })).isRequired,
  formatYAxesValue: _propTypes["default"].func,
  formatLineLabel: _propTypes["default"].func,
  formatLineTitle: _propTypes["default"].func,
  formatToolTip: _propTypes["default"].string
};
LineChart.defaultProps = {
  formatYAxesValue: null,
  formatLineLabel: null,
  formatLineTitle: _propTypes["default"].func,
  formatToolTip: ''
};
var _default = LineChart;
exports["default"] = _default;