"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The ListItem Component should be used as children to the <b>OrderedList.js</b> or the <b>UnorderedList.js</b> components. Supports icons.
 * See <a href="http://internal-uifw/elements.html#misc-icon-list" target="_blank">Icon List</a> for more information.<p>
 */
var ListItem =
/*#__PURE__*/
function (_Component) {
  _inherits(ListItem, _Component);

  function ListItem() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ListItem);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ListItem)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e) {
      if (_this.props.clickCallback) {
        _this.props.clickCallback(e, _this.props.value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleMouseDown", function (e) {
      if (_this.props.mouseDownCallback) {
        _this.props.mouseDownCallback(e, _this.props.value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleMouseOver", function (e) {
      if (_this.props.mouseOverCallback) {
        _this.props.mouseOverCallback(e, _this.props.value);
      }
    });

    return _this;
  }

  _createClass(ListItem, [{
    key: "render",
    value: function render() {
      var icon = this.props.icon ? _react["default"].createElement("i", {
        className: this.props.icon
      }) : null;
      return _react["default"].createElement("li", {
        ref: this.props.refCallback,
        className: (0, _classnames["default"])(this.props.additionalClasses),
        onClick: this.handleClick,
        onMouseOver: this.handleMouseOver,
        onMouseDown: this.handleMouseDown
      }, icon, this.props.children);
    }
  }]);

  return ListItem;
}(_react.Component);

ListItem.propTypes = {
  /**
   * The icon class name that will be prepended to the button
  	<<example>> icon="uifw-icon-li uifw-icon uifw-icon-circle red"
   */
  icon: _propTypes["default"].string,

  /**
   * The additional CSS classes that are passed to the table row
  	<<example>>additionalClasses={'u-mb-'}
   */
  additionalClasses: _propTypes["default"].string,

  /**
   * A value that is to be stored into the component. This value is passed back to any callbacks provided
  	<<example>>value={{key: 'value'}}
   */
  value: _propTypes["default"].any,

  /**
   * A handler for the onClick event. Will be passed the event object and the value prop.
  	<<example>>clickCallback={(e, value) => {return value;}}
   */
  clickCallback: _propTypes["default"].func,

  /**
   * A handler for the mouseOver event. Will be passed the event object and the value prop.
  	<<example>>mouseOverCallback={(e, value) => {return value;}}
   */
  mouseOverCallback: _propTypes["default"].func,

  /**
   * A handler for the mouseDown event. Will be passed the event object and the value prop.
  	<<example>>mouseDownCallback={(e, value) => {return value;}}
   */
  mouseDownCallback: _propTypes["default"].func,

  /**
   * If provided, this function will be called with the listitem's reference
  	<<example>>refCallback={(ref) => {this.referencedComponent = ref;}}
   */
  refCallback: _propTypes["default"].func
};
var _default = ListItem;
exports["default"] = _default;