"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = _interopRequireDefault(require("../Button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var createMarkup = function createMarkup(string) {
  return {
    __html: string
  };
};
/**
 * <p>The Message Banner Component is used to display a uifw information message banner.  See <a href="http://internal-uifw/elements.html#message-banners" target="_blank">Message Banner</a> for more information.</p>
 */


var MessageBanner =
/*#__PURE__*/
function (_Component) {
  _inherits(MessageBanner, _Component);

  function MessageBanner() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MessageBanner);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MessageBanner)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getAction", function () {
      var action = null;

      switch (_this.props.action.type) {
        case 'button':
          action = _this.getActionButton(_this.props.action.options);
          break;

        case 'link':
          action = _this.getActionLink(_this.props.action.options);
          break;

        default:
          return null;
      }

      return _react["default"].createElement("div", {
        className: "uifw-message__action"
      }, action);
    });

    _defineProperty(_assertThisInitialized(_this), "getActionButton", function (options) {
      return _react["default"].createElement(_Button["default"], options);
    });

    _defineProperty(_assertThisInitialized(_this), "getActionLink", function (options) {
      var leftIcon = null;
      var rightIcon = null;

      if (options.icon) {
        leftIcon = options.icon.indexOf(' right') === -1 ? _react["default"].createElement("i", {
          className: options.icon
        }) : null;
        rightIcon = options.icon.indexOf(' right') > -1 ? _react["default"].createElement("i", {
          className: options.icon
        }) : null;
      }

      return _react["default"].createElement("a", {
        className: options.className,
        href: options.href,
        target: "_blank",
        rel: "noopener noreferrer"
      }, leftIcon, options.text, rightIcon);
    });

    _defineProperty(_assertThisInitialized(_this), "generateAction", function () {
      return _this.props.action ? _this.getAction() : null;
    });

    return _this;
  }

  _createClass(MessageBanner, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-message', this.props.type, {
          'uifw-message--with-action': this.props.action
        }, {
          inverted: this.props.inverted
        })
      }, this.props.messageIcon !== null ? _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-message__icon', this.props.messageIcon)
      }) : null, _react["default"].createElement("div", {
        className: "uifw-message__information"
      }, _react["default"].createElement("header", {
        className: "uifw-message-header"
      }, this.props.header), _react["default"].createElement("div", {
        className: "uifw-message-body"
      }, _react["default"].createElement("span", {
        dangerouslySetInnerHTML: createMarkup(this.props.message)
      }))), this.generateAction());
    }
  }]);

  return MessageBanner;
}(_react.Component);

MessageBanner.propTypes = {
  /**
   * The type of message banner to be displayed
   <<example>>type="warning"
   *type="done"
   *type="information"
   *type="error"
   *type="question"
   *type="locked"
   */
  type: _propTypes["default"].string.isRequired,

  /**
   * The header of the message banner
   <<example>>header="string"
   */
  header: _propTypes["default"].string.isRequired,

  /**
   * The message of the banner
   <<example>>message="string"
   */
  message: _propTypes["default"].string,

  /**
   * Sets whether or not the inverted CSS is applied to the banner
   <<example>>inverted={false}
   */
  inverted: _propTypes["default"].bool,

  /**
   * The options for the message box action. If ommitted, action will not be included.
   * If included, must be an object with at least a "type" property. The options should
   * be an object with key value pairs that match the props of the react-uifw component
   * used, e.g. uifw.Button
   <<example>>action={{ type: 'button', options: { text: 'buttonText' } }}
   */
  action: _propTypes["default"].shape({
    type: _propTypes["default"].string.isRequired,
    options: _propTypes["default"].object
  }),

  /**
  * An option to allows a custom messgae icon to be displayed rather than the
  * default.
  */
  messageIcon: _propTypes["default"].string
};
MessageBanner.defaultProps = {
  message: '',
  inverted: false,
  action: null,
  messageIcon: null
};
var _default = MessageBanner;
exports["default"] = _default;