"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");
/**
 * <p>The OverlayComponents Component renders an overlay over its child nodes,
 * which is displayed on mouse over. See <a href="http://internal-uifw/elements.html#navigation-overlay-controls" target="_blank">Overlay Controls</a> for more information.</p>
 */


var OverlayComponents =
/*#__PURE__*/
function (_React$Component) {
  _inherits(OverlayComponents, _React$Component);

  function OverlayComponents() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, OverlayComponents);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(OverlayComponents)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_onClick", function (e) {
      if (_this.props.onClick != null) {
        _this.props.onClick(e);
      }
    });

    return _this;
  }

  _createClass(OverlayComponents, [{
    key: "render",
    value: function render() {
      var nameStyle = {
        marginLeft: "30px",
        marginRight: "30px"
      };
      return React.createElement("span", {
        className: "uifw-cover-controls u-ta-c",
        onClick: this._onClick
      }, this.props.children, React.createElement("div", {
        className: "uifw-cover-controls-overlay",
        style: this.props.overlayStyle
      }), React.createElement("div", {
        className: "uifw-cover-controls-content"
      }, React.createElement("div", {
        className: "uifw-cover-controls-content-inner"
      }, React.createElement("h3", {
        style: nameStyle
      }, this.props.header), React.createElement("b", null, React.createElement("small", null, this.props.description)))));
    }
  }]);

  return OverlayComponents;
}(React.Component);

_defineProperty(OverlayComponents, "propTypes", {
  /**
   * The string that will be displayed as a header in the overlay.
   <<example>> header="string"
   */
  header: PropTypes.string,

  /**
   * The string that will be displayed as a description in the overlay.
   <<example>> description="string"
   */
  description: PropTypes.string,

  /**
   * The function that is executed when the overlay is clicked.
   * <<example>> onClick={self.handleClick}
   */
  onClick: PropTypes.func,

  /**
     * The inline style that is passed to the validation message div
   <<example>> overlayStyle={
   	{
  		paddingTop: "20px",
  		color: "#000"
  	}
  }
  */
  overlayStyle: PropTypes.object,

  /**
   * Any child components to be displayed under the overlay.
   */
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
});

var _default = OverlayComponents;
exports["default"] = _default;