"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var classNames = require('classnames');

var Pagination =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Pagination, _React$Component);

  function Pagination() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Pagination);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Pagination)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getTotalPages", function () {
      return Math.ceil(_this.props.totalNumberOfItems / _this.props.itemsPerPage);
    });

    _defineProperty(_assertThisInitialized(_this), "clickCallback", function (event, pageNumber) {
      _this.props.clickCallback(pageNumber);
    });

    _defineProperty(_assertThisInitialized(_this), "generatePageNumbers", function (totalPages) {
      var pages = [];
      var mustShowNumber = 5;

      if (totalPages <= mustShowNumber) {
        for (var i = 1; i <= totalPages; i += 1) {
          pages.push(i);
        }
      } else {
        var currentPage = _this.props.currentPage;

        if (currentPage < 4) {
          pages.push(1, 2, 3, 4, 'elip', totalPages);
        } else if (currentPage > totalPages - 3) {
          pages.push(1, 'elip', totalPages - 3, totalPages - 2, totalPages - 1, totalPages);
        } else {
          pages.push(1, 'elip', currentPage - 1, currentPage, currentPage + 1, 'elip', totalPages);
        }
      }

      return pages;
    });

    return _this;
  }

  _createClass(Pagination, [{
    key: "render",
    value: function render() {
      var totalPages = this.getTotalPages();
      var pages = this.generatePageNumbers(totalPages);
      var currentPage = this.props.currentPage;
      var previousClass = classNames('page-control page-previous', this.props.currentPage <= 1 ? 'disabled' : '');
      var nextClass = classNames('page-control page-next', this.props.currentPage >= totalPages ? 'disabled' : '');
      var clickCallback = this.clickCallback;

      function pageClick(pageNo) {
        return function (event) {
          if (pageNo < 1 || pageNo > totalPages) {
            return;
          }

          return clickCallback(event, pageNo);
        };
      }

      return _react["default"].createElement("nav", {
        className: classNames('uifw-pagination', this.props.additionalWrapperCSSClasses)
      }, _react["default"].createElement("ul", null, _react["default"].createElement("li", {
        className: previousClass
      }, _react["default"].createElement("a", {
        href: "javascript:void(0);",
        onClick: pageClick(this.props.currentPage - 1)
      }, _react["default"].createElement("i", {
        className: "uifw-icon uifw-icon-chevron-left"
      }))), pages.map(function (page, index) {
        if (page != null) {
          if (page === 'elip') {
            return _react["default"].createElement("li", {
              key: 'page-elip-' + index,
              className: "page-control page-ellipsis"
            }, "...");
          } else {
            var pageNumberClass = classNames('page-control page-number', currentPage === page ? 'active' : '');
            return _react["default"].createElement("li", {
              key: 'page-' + index,
              className: pageNumberClass
            }, _react["default"].createElement("a", {
              href: "javascript:void(0);",
              onClick: pageClick(page)
            }, page));
          }
        }
      }), _react["default"].createElement("li", {
        className: nextClass
      }, _react["default"].createElement("a", {
        href: "javascript:void(0);",
        onClick: pageClick(this.props.currentPage + 1)
      }, _react["default"].createElement("i", {
        className: "uifw-icon uifw-icon-chevron-right"
      })))));
    }
  }]);

  return Pagination;
}(_react["default"].Component);

_defineProperty(Pagination, "propTypes", {
  totalNumberOfItems: _propTypes["default"].number.isRequired,
  itemsPerPage: _propTypes["default"].number.isRequired,
  currentPage: _propTypes["default"].number.isRequired,
  clickCallback: _propTypes["default"].func.isRequired,
  additionalWrapperCSSClasses: _propTypes["default"].string
});

var _default = Pagination;
exports["default"] = _default;