"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _jquery = _interopRequireDefault(require("jquery"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Validation = _interopRequireDefault(require("../../Utils/Validation"));

var _ValidationMessage = _interopRequireDefault(require("../../Utils/Validation/ValidationMessage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The Password component is used as a password input and can show and hide the password value with the provided button. See <a href="http://internal-uifw/elements.html#form-els-password-fields" target="_blank">Password</a> for more information.</p>
 */
var Password =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Password, _React$Component);

  function Password(props) {
    var _this;

    _classCallCheck(this, Password);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Password).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "_clearValidation", function () {
      (0, _jquery["default"])(_this.node).find('input').removeAttr('data-formvalidationmessage');
      (0, _jquery["default"])(_this.node).find('input').removeData('validation');

      _this.setState({
        cssClass: _this.state.cssClass.replace('error', ''),
        validationObject: {
          valid: true
        },
        formValidationMessage: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_validate", function (value) {
      var result = _Validation["default"].validateText(value, _this.props.validation);

      var newClass = _this.state.cssClass.replace(' error', '');

      if (!result.valid) {
        newClass = "".concat(newClass.trim(), " error");
      }

      _this.setState({
        cssClass: newClass,
        validationObject: result
      });

      return result;
    });

    _defineProperty(_assertThisInitialized(_this), "changeValue", function (event) {
      if (_this.state.cssClass.indexOf('error') > -1 && _this.props.validation) _this.validate(event.target.value);
      if (_this.props.changeCallback) _this.props.changeCallback(event);
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function (event) {
      if (_this.props.validation && _this.props.validateOnBlur) _this.validate(event.target.value);
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyStroke", function (event) {
      if (event.keyCode === 13) {
        var inputValue = (0, _jquery["default"])(_this.node).find('input')[0].value;

        var validationResult = _this.validate(inputValue);

        if (!validationResult.valid) {
          event.preventDefault();
        }
      }

      _this.node.getElementsByTagName('input')[0].setAttribute('data-formvalidationmessage', '');

      _this.setState({
        formValidationMessage: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "isDocumentReadyComplete", function () {
      return document.readyState === 'complete';
    });

    _defineProperty(_assertThisInitialized(_this), "safeSetCssClass", function (cssClass, node) {
      if (node !== null) {
        var className = node.className;
        var regex = new RegExp("".concat(className.replace('u-hide', '').trim()), 'g');
        var value = className.replace(regex, '');
        return "".concat(value, " ").concat(cssClass);
      }

      return cssClass;
    });

    _defineProperty(_assertThisInitialized(_this), "validate", function (value) {
      return _this._validate(value);
    });

    var _cssClass = '';
    _this.state = {
      cssClass: _cssClass,
      validationObject: {
        valid: true
      },
      validationMsgInlineStyle: _this.props.validationStyleOverride,
      formValidationMessage: ''
    };
    return _this;
  }

  _createClass(Password, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      (0, _jquery["default"])(this.node).find('input').data('validation', this.props.validation);

      if (this.isDocumentReadyComplete()) {
        (0, _jquery["default"])(this.node).find('span.uifw-password-field').uifwPasswordReveal();
      }

      (0, _jquery["default"])(this.node).find('input').on('updateValidationAttribute', function () {
        _this2.forceUpdate();
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var formValidationMessage = this.node.getElementsByTagName('input')[0].getAttribute('data-formvalidationmessage');

      if (formValidationMessage !== this.state.formValidationMessage) {
        this.setState({
          formValidationMessage: formValidationMessage
        });
      }

      (0, _jquery["default"])(this.node).find('input').data('validation', this.props.validation);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var validationBottomMsg;
      var validationTopMsg;

      if (this.props.validation && !this.state.validationObject.valid || this.state.formValidationMessage && this.state.formValidationMessage !== '') {
        if (this.state.formValidationMessage && this.state.formValidationMessage !== '') {
          this.state.validationObject.errorMsg = this.state.formValidationMessage;

          if (this.state.cssClass.indexOf('error') < 0) {
            this.state.cssClass += ' error';
          }
        }

        var validationComponent = _react["default"].createElement(_ValidationMessage["default"], {
          message: this.state.validationObject.errorMsg,
          additionalClasses: this.props.validationCssClasses,
          styleOverride: this.state.validationMsgInlineStyle
        });

        if (this.props.validationCssClasses && this.props.validationCssClasses.indexOf('top') > -1) {
          validationTopMsg = validationComponent;
        } else {
          validationBottomMsg = validationComponent;
        }
      }

      var additionalClasses = this.props.additionalClasses ? this.props.additionalClasses.split(' ') : [];
      var fullWidth = additionalClasses.indexOf('fw') > -1;
      var disabled = this.props.disabled === true;
      var textClass = (0, _classnames["default"])(this.state.cssClass, 'uifw-text-field', disabled ? 'readonly' : '', this.props.additionalClasses);
      var toggleStyle = this.state.cssClass.indexOf('error') > -1 || !this.props.IsPasswordToggleVisible ? {
        display: 'none'
      } : {};
      var uifwValidationMessageWrapperCss = (0, _classnames["default"])('uifw-validation-message-wrapper', {
        fw: fullWidth
      }, this.props.validationWrapperCssClasses);
      var uifwPasswordFieldCss = (0, _classnames["default"])('uifw-password-field', {
        fw: fullWidth
      });
      return _react["default"].createElement("div", {
        ref: function ref(node) {
          _this3.node = node;
        }
      }, _react["default"].createElement("div", {
        className: uifwValidationMessageWrapperCss
      }, validationTopMsg, _react["default"].createElement("span", {
        className: uifwPasswordFieldCss
      }, _react["default"].createElement("input", {
        type: "password",
        id: this.props.inputId ? "".concat(this.props.inputId) : null,
        className: this.safeSetCssClass(textClass, document.querySelector("#".concat(this.props.inputId))),
        value: this.props.value,
        placeholder: this.props.placeholder,
        onKeyDown: this.handleKeyStroke,
        onChange: this.changeValue,
        onBlur: this.handleBlur,
        disabled: disabled
      }), _react["default"].createElement("input", {
        type: "text",
        id: this.props.inputId ? "".concat(this.props.inputId, "Show") : null,
        className: this.safeSetCssClass(textClass, document.querySelector("#".concat(this.props.inputId, "Show"))),
        value: this.props.value,
        placeholder: this.props.placeholder,
        onKeyDown: this.handleKeyStroke,
        onChange: this.changeValue,
        onBlur: this.handleBlur,
        disabled: disabled
      }), _react["default"].createElement("span", {
        className: "uifw-password-field__control",
        style: toggleStyle,
        "data-title-show": "Show Password",
        "data-title-hide": "Hide Password"
      })), _react["default"].createElement("div", null, validationBottomMsg)));
    }
  }]);

  return Password;
}(_react["default"].Component);

Password.propTypes = {
  /**
   * An array of validation rules
   <<example>> validation={
     [
      {
        action: "required",
        errorMsg: "File is required."
      }
    ]
   }
   */
  validation: _propTypes["default"].array,

  /**
   * The value of the password input boxes
   <<example>>value="string"
   */
  value: _propTypes["default"].string.isRequired,

  /**
   * The function to execute when the password input changes
   <<example>>changeCallback={self.handlePasswordChange}
   */
  changeCallback: _propTypes["default"].func,

  /**
   * The additional CSS classes that are added to the input boxes
   <<example>>additionalClasses="string"
   */
  additionalClasses: _propTypes["default"].string,

  /**
   * Sets the disabled attribute for the password input boxes
   <<example>>disabled={false}
   */
  disabled: _propTypes["default"].bool,

  /**
   * The placeholder text of the input boxes
   <<example>>placeholder="string"
   */
  placeholder: _propTypes["default"].string,

  /**
   * The additional CSS classes that are passed to the validation message div
   <<example>> validationCssClasses="string"
   */
  validationCssClasses: _propTypes["default"].string,

  /**
   * The inline style that is passed to the validation message div
   <<example>> validationStyleOverride={
     {
      paddingTop: "20px",
      color: "#000"
    }
   }
   */
  validationStyleOverride: _propTypes["default"].oneOf([_propTypes["default"].object]),

  /**
   * The id that is to be passed to the input within the component for the password field
   <<example>>inputId="string"
   */
  inputId: _propTypes["default"].string.isRequired,

  /**
  * The wrapper around the validation to allow for more powerful application when
  * required.
  */
  validationWrapperCssClasses: _propTypes["default"].string,

  /**
  * The wrapper around the validation to allow for more powerful application when
  * required.
  */
  validateOnBlur: _propTypes["default"].bool,
  IsPasswordToggleVisible: _propTypes["default"].bool
};
Password.defaultProps = {
  validateOnBlur: true,
  inputId: 'PasswordField',
  validationWrapperCssClasses: '',
  validationStyleOverride: null,
  validationCssClasses: '',
  placeholder: '',
  disabled: false,
  additionalClasses: '',
  changeCallback: null,
  IsPasswordToggleVisible: true
};
var _default = Password;
exports["default"] = _default;