"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PopoutSection =
/*#__PURE__*/
function (_Component) {
  _inherits(PopoutSection, _Component);

  function PopoutSection() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, PopoutSection);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(PopoutSection)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "setWrapperRef", function (node) {
      _this.wrapperRef = node;
    });

    _defineProperty(_assertThisInitialized(_this), "handleClick", function () {
      _this.props.clickCallback();
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickOutside", function (event) {
      if (_this.props.handleClickOutside) {
        if (_this.wrapperRef && !_this.wrapperRef.contains(event.target)) {
          _this.props.handleClickOutside();
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleEscapeClick", function (event) {
      if (_this.props.handleClickOutside) {
        if ('key' in event) {
          if (event.key === 'Escape' || event.key === 'Esc') {
            _this.props.handleClickOutside();
          }
        }
      }
    });

    return _this;
  }

  _createClass(PopoutSection, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.addEventListener('mousedown', this.handleClickOutside);
      document.addEventListener('keydown', this.handleEscapeClick);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener('mousedown', this.handleClickOutside);
      document.removeEventListener('keydown', this.handleEscapeClick);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        id: this.props.wrapperId,
        className: (0, _classnames["default"])('uifw-popout-section-wrapper', this.props.additionalWrapperClasses),
        ref: function ref(wrappingDiv) {
          _this2.wrapperRef = wrappingDiv;
        }
      }, _react["default"].createElement("a", {
        id: "".concat(this.props.wrapperId, "MainButton"),
        onClick: this.handleClick,
        className: "uifw-button js-popout-button"
      }, _react["default"].createElement("i", {
        className: (0, _classnames["default"])(this.props.icon)
      }), _react["default"].createElement("span", null, " ", this.props.title, " "), _react["default"].createElement("i", {
        className: "uifw-icon uifw-icon-angle-down right"
      })), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-popout-section uifw-popout-section--bottom-left', this.props.additionalContentClasses, {
          'u-hide': !this.props.displayDropDown
        })
      }, this.props.children));
    }
  }]);

  return PopoutSection;
}(_react.Component);

PopoutSection.propTypes = {
  wrapperId: _propTypes["default"].string,
  icon: _propTypes["default"].string,
  title: _propTypes["default"].string,
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].array]),
  displayDropDown: _propTypes["default"].bool,
  clickCallback: _propTypes["default"].func.isRequired,
  additionalWrapperClasses: _propTypes["default"].string,
  additionalContentClasses: _propTypes["default"].string,
  handleClickOutside: _propTypes["default"].func
};
PopoutSection.defaultProps = {
  icon: '',
  title: '',
  children: [],
  displayDropDown: false,
  wrapperId: null,
  additionalWrapperClasses: '',
  additionalContentClasses: '',
  handleClickOutside: null
};
var _default = PopoutSection;
exports["default"] = _default;