"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var ProgressBar = require("./index");
/**
 * A file space usage display using the ProgressBar.
  <example><uifw.FileUsage allocatedSpace={10} usedSpace={2} />
 */


var FileUsage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FileUsage, _React$Component);

  function FileUsage() {
    _classCallCheck(this, FileUsage);

    return _possibleConstructorReturn(this, _getPrototypeOf(FileUsage).apply(this, arguments));
  }

  _createClass(FileUsage, [{
    key: "render",
    value: function render() {
      var allocatedSpace = this.props.allocatedSpace;
      var usedSpace = this.props.usedSpace;
      var percentageUsed = Math.round(usedSpace / allocatedSpace * 100, 2);
      return React.createElement("div", {
        className: "u-ta-c"
      }, React.createElement(ProgressBar, {
        idClass: "filespace-progress",
        className: "fw u-mb--",
        options: {
          "delay": 1,
          "duration": 1,
          "value": percentageUsed
        }
      }), React.createElement("div", null, React.createElement("sub", {
        className: "u-fl"
      }, usedSpace, "MB of ", allocatedSpace, "MB"), React.createElement("sub", {
        className: "u-fr"
      }, percentageUsed, "% Used")));
    }
  }]);

  return FileUsage;
}(React.Component);

_defineProperty(FileUsage, "propTypes", {
  /**
   * The amount of space total allocated to the user in Mb.
   */
  allocatedSpace: PropTypes.number,

  /**
   * The amount of space used by the user so far in Mb.
   */
  usedSpace: PropTypes.number
});

var _default = FileUsage;
exports["default"] = _default;