"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var ReactDOM = require('react-dom');

var $ = require('jquery');

var getInputNode = function getInputNode(domNode) {
  return $($(domNode)[0]).children()[0];
};

var getRadioDiv = function getRadioDiv(domNode) {
  return $($(domNode)[0]).children()[1];
};

var setCheckedState = function setCheckedState(domNode, isChecked) {
  if (isChecked) {
    getInputNode(domNode).setAttribute("checked", "checked");
    $(getRadioDiv(domNode)).addClass("checked");
  } else {
    getInputNode(domNode).removeAttribute("checked");
    $(getRadioDiv(domNode)).removeClass("checked");
  }
};
/**
 * <p>The Radio Button is just a wrapper for the uifw Radio Button. See <a href="http://internal-uifw/elements.html#form-els-radio-buttons" target="_blank">Radio Button</a> for more information.</p>
 */


var RadioButton =
/*#__PURE__*/
function (_React$Component) {
  _inherits(RadioButton, _React$Component);

  function RadioButton() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, RadioButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(RadioButton)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      lastChange: null
    });

    _defineProperty(_assertThisInitialized(_this), "_onChange", function (event) {
      _this.props.callback(_this.props.value);
    });

    return _this;
  }

  _createClass(RadioButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      $(getInputNode(ReactDOM.findDOMNode(this))).uifwFrmRadio();
      $(getInputNode(ReactDOM.findDOMNode(this))).change(this._onChange);
      setCheckedState(ReactDOM.findDOMNode(this), this.props.isChecked);
      this.setState({
        lastChange: this.props.isChecked
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.state.lastChange !== this.props.isChecked) {
        if (this.props.isChecked) {
          getInputNode(ReactDOM.findDOMNode(this)).setAttribute("checked", "checked");
        } else {
          getInputNode(ReactDOM.findDOMNode(this)).removeAttribute("checked");
        }

        if (this.state.lastChange === null) {
          $(getInputNode(ReactDOM.findDOMNode(this))).uifwFrmRadio();
          $(getInputNode(ReactDOM.findDOMNode(this))).change(this._onChange);
        }

        this.setState({
          lastChange: this.props.isChecked
        });
      }
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps, nextContext) {
      if (nextProps.isChecked !== this.props.isChecked) {
        $(getInputNode(ReactDOM.findDOMNode(this))).change(this._onChange);
        setCheckedState(ReactDOM.findDOMNode(this), nextProps.isChecked);
        this.setState({
          lastChange: nextProps.isChecked
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", null, React.createElement("input", {
        id: this.props.id,
        type: "radio",
        className: "uifw-radio",
        value: this.props.value
      }));
    }
  }]);

  return RadioButton;
}(React.Component);

_defineProperty(RadioButton, "propTypes", {
  /**
     * The callback function to be executed on a radio button click
   <<example>>callback={self.handleRadioButtonCLick}
     */
  callback: PropTypes.func.isRequired,

  /**
     * Sets the is checked value of the radio button
   <<example>>isChecked={false}
     */
  isChecked: PropTypes.bool,

  /**
     * Sets the checked value of the radio button
   <<example>>value={false}
     */
  value: PropTypes.any,

  /**
     * Sets the id of the radio button
   <<example>>id="radioButton"
     */
  id: PropTypes.string
});

var _default = RadioButton;
exports["default"] = _default;