"use strict";

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _reactDom = _interopRequireDefault(require("react-dom"));

var _ReactDialog = _interopRequireDefault(require("../ReactDialog"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('ReactDialog Component', function () {
  it('Should render correct when all props are passed in and execute the basic close function', function () {
    var displayDialogBool = true;

    var onClick = function onClick() {
      displayDialogBool = !displayDialogBool;
    };

    var generateFooter = function generateFooter() {
      return _react["default"].createElement("div", {
        id: "footer"
      }, "Footer");
    };

    var wrapper = (0, _enzyme.mount)(_react["default"].createElement(_ReactDialog["default"], {
      header: "header",
      displayDialog: displayDialogBool,
      clickClose: onClick,
      footer: generateFooter()
    }, _react["default"].createElement("div", {
      id: "testChild"
    }, "Children")));
    expect(document.getElementById('testChild')).toBeDefined();
    expect(displayDialogBool).toBe(true);
    expect(document.getElementById('footer')).toBeDefined();
  });
});