"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactAppendToBody = require("react-append-to-body");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Core =
/*#__PURE__*/
function (_ReactComponent) {
  _inherits(Core, _ReactComponent);

  function Core() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Core);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Core)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "generateFooter", function () {
      if (_this.props.footer === null) {
        return null;
      }

      return _react["default"].createElement("div", {
        className: "uifw-dialog-window__footer"
      }, _this.props.footer);
    });

    return _this;
  }

  _createClass(Core, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        id: this.props.id,
        className: (0, _classnames["default"])('uifw-dialog', {
          'u-hide': !this.props.displayDialog
        }, this.props.extraCssClass)
      }, _react["default"].createElement("div", {
        className: this.props.hideOverlay ? '' : 'uifw-dialog-overlay'
      }), _react["default"].createElement("div", {
        className: "uifw-dialog-window"
      }, // This allows us to use a text header or an image header.
      this.props.useImageHeader != null ? _react["default"].createElement("div", null, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-dialog-window__close', this.props.useImageHeader.closeCss),
        onClick: this.props.useImageHeader.onClickClose
      }, "\u2715"), _react["default"].createElement("div", {
        className: this.props.useImageHeader.backgroundImageClass,
        style: {
          backgroundImage: this.props.useImageHeader.backgroundImage
        }
      }, _react["default"].createElement("img", {
        src: this.props.useImageHeader.imageSrc,
        srcSet: this.props.useImageHeader.imageSrcSet,
        alt: "cardImage"
      }))) : _react["default"].createElement("div", {
        className: (0, _classnames["default"])({
          'uifw-dialog-window__header': !this.props.hideHeader
        })
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])({
          'uifw-dialog-window__title': !this.props.hideHeader
        })
      }, this.props.header), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-dialog-window__close', {
          'u-hide': this.props.hideClose
        }, this.props.extraCloseCss),
        onClick: this.props.clickClose
      }, "\u2715"), this.props.displayBackIcon ? _react["default"].createElement("div", {
        className: "uifw-dialog-window__back",
        onClick: this.props.onBackClick
      }, _react["default"].createElement("i", {
        className: "uifw-icon ".concat(this.props.backIcon)
      })) : null), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-dialog-window__content', this.props.windowContentCss)
      }, this.props.children), this.generateFooter()));
    }
  }]);

  return Core;
}(_react.Component);

Core.propTypes = {
  header: _propTypes["default"].string,
  hideHeader: _propTypes["default"].bool,
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].array]),
  displayDialog: _propTypes["default"].bool.isRequired,
  footer: _propTypes["default"].element,
  hideClose: _propTypes["default"].bool,
  clickClose: _propTypes["default"].func.isRequired,
  extraCssClass: _propTypes["default"].string,
  extraCloseCss: _propTypes["default"].string,
  windowContentCss: _propTypes["default"].string,
  displayBackIcon: _propTypes["default"].bool,
  backIcon: _propTypes["default"].string,
  onBackClick: _propTypes["default"].func,
  id: _propTypes["default"].string,
  useImageHeader: _propTypes["default"].shape({
    closeCss: _propTypes["default"].string,
    backgroundImageClass: _propTypes["default"].string,
    backgroundImage: _propTypes["default"].string,
    imageSrc: _propTypes["default"].string,
    imageSrcSet: _propTypes["default"].string
  }),
  hideOverlay: _propTypes["default"].bool
};
Core.defaultProps = {
  header: '',
  hideHeader: false,
  children: [],
  footer: null,
  hideClose: false,
  extraCssClass: '',
  extraCloseCss: '',
  windowContentCss: '',
  backIcon: null,
  onBackClick: null,
  displayBackIcon: false,
  id: null,
  useImageHeader: null,
  hideOverlay: false
};
var Component = (0, _reactAppendToBody.componentWillAppendToBody)(Core);
var _default = {
  Component: Component,
  Core: Core
};
exports["default"] = _default;