"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * <p>The SectionBanner Component is a wrapper for the banner used in sections. See <a href="http://internal-uifw/elements.html#message-insection" target="_blank">In Section Messages</a> for more information.<p>
 */
var SectionBanner = function SectionBanner(props) {
  return _react["default"].createElement("div", {
    className: (0, _classnames["default"])('uifw-section-banner', props.type)
  }, props.children);
};

SectionBanner.propTypes = {
  /**
   * The type of section banner. Leave null for default.
   <<example>>type={'warning'}
   */
  type: _propTypes["default"].string,

  /**
   * The content of the Section Banner
   <<example>><uifw.TableCell>
   *  <TableCellContent>...</TableCellContent>
   *</uifw.TableCell>
   */
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].array, _propTypes["default"].string])
};
SectionBanner.defaultProps = {
  type: null,
  children: null
};
var _default = SectionBanner;
exports["default"] = _default;