"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var classnames = require('classnames');
/**
 * <p>The Section Content Empty Component is used to display a message on screen where content could be displayed if it had any data supplied.
 * See <a href="http://internal-uifw/elements.html#form-layouts-row-inner-sections" target="_blank">Sections</a> for more information.
 */


var SectionContentEmpty =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SectionContentEmpty, _React$Component);

  function SectionContentEmpty() {
    _classCallCheck(this, SectionContentEmpty);

    return _possibleConstructorReturn(this, _getPrototypeOf(SectionContentEmpty).apply(this, arguments));
  }

  _createClass(SectionContentEmpty, [{
    key: "render",
    value: function render() {
      var self = this;
      var icon = self.props.icon || "uifw-icon uifw-icon-frown-o";
      return React.createElement("div", {
        className: classnames("uifw-no-data", {
          "u-hide": this.props.hidden
        })
      }, React.createElement("div", {
        className: "uifw-no-data-content"
      }, React.createElement("div", {
        className: "uifw-no-data-icon"
      }, React.createElement("i", {
        className: icon
      })), React.createElement("div", {
        className: "uifw-no-data-message"
      }, React.createElement("header", {
        className: "uifw-no-data-message-title"
      }, self.props.title), React.createElement("div", {
        className: "uifw-no-data-message-description"
      }, React.createElement("p", null, self.props.message))), React.createElement("div", {
        className: "uifw-no-data-actions"
      }, this.props.children)));
    }
  }]);

  return SectionContentEmpty;
}(React.Component);

_defineProperty(SectionContentEmpty, "defaultProps", {
  hidden: false
});

_defineProperty(SectionContentEmpty, "propTypes", {
  /**
   * The title of the empty section content
  <<example>>title="string"
   */
  title: PropTypes.string.isRequired,

  /**
   * The message of the empty section content
  <<example>>message="string"
   */
  message: PropTypes.string.isRequired,

  /**
   * The icon of the empty section content
  <<example>>icon="uifw-icon-frown-o" // defaults to {"uifw-icon-frown-o"}
   */
  icon: PropTypes.string,

  /**
   * Sets the visibility of the section
  <<example>>hidden={true}
   */
  hidden: PropTypes.bool,

  /**
   * The added content of the Section
  <<example>><uifw.SectionContentEmpty>
   *  <AddedContent>...</AddedContent>
   *</uifw.SectionContentEmpty>
   */
  children: PropTypes.any
});

var _default = SectionContentEmpty;
exports["default"] = _default;