"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _jquery = _interopRequireDefault(require("jquery"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The Section component is the wrapper for a form and will hold a list of inputs. See <a href="http://internal-uifw/docs/sections.html" target="_blank">Sections</a> for more information.<p>
 */
var Section =
/*#__PURE__*/
function (_Component) {
  _inherits(Section, _Component);

  function Section() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Section);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Section)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getHeaderLeftIcon", function () {
      var headerLeftIcon = _this.props.headerLeftIcon;

      if (headerLeftIcon == null) {
        return null;
      }

      return _react["default"].createElement("i", {
        className: headerLeftIcon
      });
    });

    _defineProperty(_assertThisInitialized(_this), "collapse", function () {
      (0, _jquery["default"])(_this.section).uifwCollapse();
    });

    _defineProperty(_assertThisInitialized(_this), "isDocumentReadyComplete", function () {
      return document.readyState === 'complete';
    });

    _defineProperty(_assertThisInitialized(_this), "searchBoxFunction", function (e) {
      // Copying the event object, so we can debounce if needed.
      var evnt = _jquery["default"].extend({}, e);

      var searchfunction = _this.props.searchfunction;

      if (searchfunction != null) {
        searchfunction(evnt);
      }
    });

    return _this;
  }

  _createClass(Section, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var collapsible = this.props.collapsible;

      if (collapsible === true && this.isDocumentReadyComplete()) {
        this.collapse();
      }
    } // eslint-disable-next-line no-unused-vars

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this$props = this.props,
          hide = _this$props.hide,
          show = _this$props.show;

      if (prevProps != null && prevProps.collapsible === true && prevProps.show === false && show === true) {
        (0, _jquery["default"])(this.section).data('UIFWCollapse').undoCollapse();
      }

      if (prevProps != null && prevProps.collapsible === true && prevProps.hide === false && hide === true) {
        (0, _jquery["default"])(this.section).data('UIFWCollapse').doCollapse();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          blocked = _this$props2.blocked,
          blockedBody = _this$props2.blockedBody,
          blockedButton = _this$props2.blockedButton,
          blockedTitle = _this$props2.blockedTitle,
          children = _this$props2.children,
          collapsible = _this$props2.collapsible,
          contentClasses = _this$props2.contentClasses,
          id = _this$props2.id,
          initShow = _this$props2.initShow,
          refCallback = _this$props2.refCallback,
          searchable = _this$props2.searchable,
          searchboxtext = _this$props2.searchboxtext,
          style = _this$props2.style,
          visible = _this$props2.visible;
      var _this$props3 = this.props,
          additionalClasses = _this$props3.additionalClasses,
          additionalHeaderComponent = _this$props3.additionalHeaderComponent,
          header = _this$props3.header,
          headerClickCallback = _this$props3.headerClickCallback,
          headerDescription = _this$props3.headerDescription;
      additionalClasses = additionalClasses || '';

      if (collapsible && collapsible === true && additionalClasses.indexOf('collapsible') < 0) {
        additionalClasses += initShow && initShow === true && additionalClasses.indexOf('init-show') < 0 ? ' collapsible init-show' : ' collapsible';
      }

      var searchbox = !searchable ? null : _react["default"].createElement("span", {
        className: "uifw-text-field-with-icon uifw-gc-xs-12 icon-left u-ml u-xs-ml0 u-xs-mt+"
      }, _react["default"].createElement("span", {
        className: "uifw-text-field-with-icon icon-left"
      }, _react["default"].createElement("i", {
        className: "uifw-icon uifw-icon-search"
      }), _react["default"].createElement("input", {
        type: "text",
        onChange: this.searchBoxFunction,
        placeholder: searchboxtext,
        className: "uifw-text-field small"
      })));
      additionalHeaderComponent = !additionalHeaderComponent ? null : _react["default"].createElement("span", {
        className: "uifw-section-header-field"
      }, additionalHeaderComponent);

      if (header) {
        if (headerDescription != null) {
          headerDescription = _react["default"].createElement("div", {
            id: id ? "".concat(id, "HeaderDescriptionText") : null,
            className: "uifw-section-header__description"
          }, headerDescription);
        }

        headerClickCallback = headerClickCallback || function DefaultHeaderClickCallback() {};

        header = _react["default"].createElement("header", {
          className: (0, _classnames["default"])({
            'uifw-nbui': blocked
          }, 'uifw-section-header'),
          onClick: headerClickCallback,
          onKeyDown: function onKeyDown() {}
        }, additionalHeaderComponent, _react["default"].createElement("div", {
          id: id ? "".concat(id, "HeaderText") : null,
          className: "uifw-section-header__title"
        }, this.getHeaderLeftIcon(), header, searchbox), headerDescription);
      }

      var classObject = {};
      classObject[additionalClasses] = additionalClasses;
      classObject['u-hide'] = visible === false;
      classObject['uifw-blocked-section'] = blocked === true;
      var blockedContent = !blocked ? null : _react["default"].createElement("div", {
        className: "uifw-blocked-section__content"
      }, _react["default"].createElement("div", {
        className: "uifw-blocked-section__content-inner"
      }, _react["default"].createElement("div", {
        className: "uifw-blocked-section__title u-fs++"
      }, _react["default"].createElement("b", null, blockedTitle)), _react["default"].createElement("div", {
        className: "uifw-blocked-section__description u-fs- u-mt-- u-fade--"
      }, blockedBody), blockedButton));
      var sectionContentClasses = (0, _classnames["default"])('uifw-section-content', contentClasses, {
        'uifw-nbui': blocked
      });
      return _react["default"].createElement("section", {
        ref: function ref(reference) {
          _this2.section = reference;

          if (refCallback) {
            refCallback(reference);
          }
        },
        id: id,
        className: (0, _classnames["default"])('uifw-section', classObject),
        style: style
      }, header, _react["default"].createElement("div", {
        className: sectionContentClasses
      }, children), blockedContent);
    }
  }]);

  return Section;
}(_react.Component);

Section.propTypes = {
  /**
   * The string to be displayed as the section header
   <<example>>header="string"
   */
  header: _propTypes["default"].string,

  /**
   * The string to be displayed as the section header description
   <<example>>headerDescription="string"
   */
  headerDescription: _propTypes["default"].string,

  /**
   * The full string for the left hand icon in the header title
   <<example>>headerLeftIcon="uifw-icon uifw-icon-lightbulb-o u-mr--"
   */
  headerLeftIcon: _propTypes["default"].string,

  /**
   * The additional CSS classes to be passed onto the section wrapper
   <<example>>additionalClasses="string"
   */
  additionalClasses: _propTypes["default"].string,

  /**
   * The additional CSS classes to be passed onto content div wrapper
   <<example>>contentClasses="string"
   */
  contentClasses: _propTypes["default"].string,

  /**
   * The id that is given to the section wrapper
   <<example>>id="string"
   */
  id: _propTypes["default"].string,

  /**
   * The inline style that is passed to the section wrapper
   <<example>> style={
     {
      paddingTop: "20px",
      color: "#000"
    }
   }
   */

  /* eslint-disable react/forbid-prop-types */
  style: _propTypes["default"].object,

  /* eslint-enable react/forbid-prop-types */

  /**
   * Sets the visibility of the section
   <<example>>visible={true}
   */
  visible: _propTypes["default"].bool,

  /**
   * Sets collapsibility of a section
   <<example>>collapsible={true}
   */
  collapsible: _propTypes["default"].bool,

  /**
   * If true, section starts in expanded state
   <<example>>initShow={true}
   */
  initShow: _propTypes["default"].bool,

  /**
   * Callback for when the header is clicked
   <<example>>headerClickCallback={self.headerClickCallback}
   */
  headerClickCallback: _propTypes["default"].func,

  /**
   * If true, display a search box in the header.
   <<example>>searchable={true}
   */
  searchable: _propTypes["default"].bool,

  /**
   * The placeholder text to display in the search box.
   <<example>>searchboxtext="string"
   */
  searchboxtext: _propTypes["default"].string,

  /**
   * The function to execute on search box value change
   <<example>>searchfunction={self.handleSearchValueChange}
   */
  searchfunction: _propTypes["default"].func,

  /**
   * An additional component to display in the section header i.e a button
   <<example>>additionalHeaderComponent={<SomeComponent/>}
   */
  additionalHeaderComponent: _propTypes["default"].node,

  /**
   * Enables the overlay
   */
  blocked: _propTypes["default"].bool,

  /**
  * The title of the blocked overlay
  */
  blockedTitle: _propTypes["default"].string,

  /**
  * The body of the blocked overlay
  */
  blockedBody: _propTypes["default"].string,

  /**
  * The button of the blocked overlay
  */
  blockedButton: _propTypes["default"].node,

  /**
  * Allows to pass in a reference into section
  */
  refCallback: _propTypes["default"].func,

  /**
   * The content of the section
   <<example>><uifw.Section>
   *  <SectionContent>...</SectionContent>
   *</uifw.Section>
   */
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].array, _propTypes["default"].string]).isRequired,

  /**
  * Forces a collapsed section to display
  */
  show: _propTypes["default"].bool,

  /**
  * Forces a section to collapse
  */
  hide: _propTypes["default"].bool
};
Section.defaultProps = {
  header: null,
  headerDescription: null,
  headerLeftIcon: null,
  additionalClasses: null,
  contentClasses: null,
  id: null,
  style: null,
  visible: true,
  collapsible: false,
  initShow: true,
  headerClickCallback: null,
  searchable: false,
  searchboxtext: null,
  searchfunction: null,
  additionalHeaderComponent: null,
  blocked: false,
  blockedTitle: null,
  blockedBody: null,
  blockedButton: null,
  refCallback: null,
  show: null,
  hide: null
};
var _default = Section;
exports["default"] = _default;