"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _jquery = _interopRequireDefault(require("jquery"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ValidationMessage = _interopRequireDefault(require("../../Utils/Validation/ValidationMessage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The Select Component is a wrapper for the uifw Select input. See <a href="http://internal-uifw/elements.html#form-els-select-field" target="_blank">Select</a> for more information.<p>
 */
var Select =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Select)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_clearValidation", function () {
      (0, _jquery["default"])(_reactDom["default"].findDOMNode(_assertThisInitialized(_this))).find("select").removeAttr("data-formvalidationmessage");
      (0, _jquery["default"])(_reactDom["default"].findDOMNode(_assertThisInitialized(_this))).find("select").removeData("validation");

      _this.setState({
        formValidationMessage: ""
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_generatePresetOptions", function () {
      switch (_this.props.presetSelect) {
        case 'yesNo':
          return [{
            value: "true",
            displayText: "Yes"
          }, {
            value: "false",
            displayText: "No"
          }];

        case 'trueFalse':
          return [{
            value: "true",
            displayText: "True"
          }, {
            value: "false",
            displayText: "False"
          }];

        default:
          return [];
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_handleSelectChange", function (event) {
      _this._clearValidation();

      _this.props.callback(event);
    });

    return _this;
  }

  _createClass(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var component = this;
      (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).find('select').data('validation', this.props.validation);
      (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).find('select').on("updateValidationAttribute", function (validationMessage) {
        component.forceUpdate();
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).find('select').data('validation', this.props.validation);

      var formValidationMessage = _reactDom["default"].findDOMNode(this).getElementsByTagName('select')[0].getAttribute("data-formvalidationmessage");

      if (formValidationMessage !== this.state.formValidationMessage) {
        this.setState({
          formValidationMessage: formValidationMessage
        });
      }
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var options = this.props.options;

      if (!options) {
        options = this._generatePresetOptions();
      }

      ;
      this.setState({
        options: options
      });
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.state.options !== nextProps.options) {
        this.setState({
          options: nextProps.options
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var selectId = this.props.id;
      var options = this.state.options.map(function (option, i) {
        return _react["default"].createElement("option", {
          key: selectId + i,
          value: option.value,
          disabled: option.disabled,
          style: option.style
        }, option.displayText || option.value);
      });
      var errorClassName, validationMessageComponent;

      if (this.state.formValidationMessage && this.state.formValidationMessage !== "") {
        validationMessageComponent = _react["default"].createElement(_ValidationMessage["default"], {
          message: this.state.formValidationMessage,
          additionalClasses: this.props.validationCssClasses,
          styleOverride: this.state.validationMsgInlineStyle
        });
        errorClassName = 'invalid';
      }

      return _react["default"].createElement("div", null, _react["default"].createElement("div", {
        className: (0, _classnames["default"])("uifw-validation-message-wrapper", this.props.additionalClasses)
      }, _react["default"].createElement("span", {
        className: (0, _classnames["default"])("uifw-select-field", {
          "fw": this.props.additionalClasses && this.props.additionalClasses.includes('fw')
        }, errorClassName)
      }, _react["default"].createElement("select", {
        id: selectId,
        onChange: this._handleSelectChange,
        value: this.props.value,
        disabled: this.props.disabled
      }, options)), _react["default"].createElement("div", null, validationMessageComponent)));
    }
  }]);

  return Select;
}(_react["default"].Component);

_defineProperty(Select, "propTypes", {
  /**
     * The function to be executed when the value of the select has changed
   <<example>>callback={self.handleSelectChange}
     */
  callback: _propTypes["default"].func.isRequired,

  /**
     * The id that is given to the select input
   <<example>>id="stirng"
     */
  id: _propTypes["default"].string.isRequired,

  /**
     * The options that the user can select from
   <<example>>options={
   	[
  		{
  			value: "string", // Is Required
  			disabled: true, // Optional
  			displayText: "string" // Optional (displays value by default)
  		}
  	]
   }
     */
  options: _propTypes["default"].array,

  /**
     * The desired auto generated options list
   <<example>>presetSelect="yesNo" // Creates a select with Yes and No as the options
   *presetSelect="trueFalse" // Creates a select with True and False as the options
     */
  presetSelect: _propTypes["default"].string,

  /**
     * The selected item value of the select
   <<example>>value="string" // String
   *value={1} // Number
   *value={false} // Boolean
     */
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].bool]),

  /**
  * The additional css classes added to the wrapper
  <<example>>additionalClasses="string" // String
  */
  additionalClasses: _propTypes["default"].string,

  /**
     * An array of validation rules
   <<example>> validation={
  	[
  		{
  			action: "required",
  			errorMsg: "File is required."
  		}
  	]
   }
     */
  validation: _propTypes["default"].array,

  /**
     * The additional CSS classes that are passed to the validation message div
   <<example>> validationCssClasses="string"
     */
  validationCssClasses: _propTypes["default"].string,

  /**
     * Sets the interactivity of the Select
   <<example>> disabled={false}
     */
  disabled: _propTypes["default"].bool
});

var _default = Select;
exports["default"] = _default;