"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var $ = require('jquery');

var classNames = require('classnames');

var _ = require("underscore");

var selectIdText = function selectIdText(d) {
  return {
    id: d.id,
    text: d.text,
    selected: d.selected
  };
};
/**
 * <p>The Select2 Component is the uifw wrapper for the jQuery select2. You can pass an array of searchable select options that the user can filter with a textbox.
 * See <a href="http://internal-uifw/elements.html#form-els-select2" target="_blank">Select2</a> for more information.<p> Or view the <a href="https://select2.github.io/">Select2 docs</a>.
 */


var Select2 =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Select2, _React$Component);

  function Select2() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Select2);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Select2)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      data: []
    });

    _defineProperty(_assertThisInitialized(_this), "getElement", function () {
      return $('#' + _this.props.id);
    });

    _defineProperty(_assertThisInitialized(_this), "_handleChange", function (event) {
      var element = $(_this.getElement()).select2("val");
      var val = element === null ? null : element.toString();
      var e = {
        target: {
          value: val
        }
      };

      _this.props.callback(e);
    });

    return _this;
  }

  _createClass(Select2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var $selectItem = this.getElement();
      var options = {
        data: this.props.data
      };
      options = this.props.config ? _.extend(options, this.props.config) : options;
      options = this.props.placeholder ? _.extend(options, {
        placeholder: this.props.placeholder
      }) : options;
      $selectItem.select2(options);
      $selectItem.on("select2:select", this._handleChange);
      $selectItem.on("select2:unselect", this._handleChange);
      $selectItem.on("change", this._handleChange);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var propData = _.map(prevProps.data, selectIdText);

      var statData = _.map(this.state.data, selectIdText);

      if (!_.isEqual(propData, statData)) {
        var $selectItem = this.getElement();
        var options = {
          data: this.props.data
        };
        options = this.props.config ? _.extend(options, this.props.config) : options;
        options = this.props.placeholder ? _.extend(options, {
          placeholder: this.props.placeholder
        }) : options;
        $selectItem.select2("destroy");
        $selectItem.html('');
        $selectItem.select2(options);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var $selectItem = this.getElement();
      $selectItem.off("select2:select");
      $selectItem.off("select2:unselect");
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var propData = _.map(nextProps.data, selectIdText);

      var statData = _.map(this.state.data, selectIdText);

      if (!_.isEqual(propData, statData)) {
        this.setState({
          data: nextProps.data
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("span", {
        className: "uifw-select2-field"
      }, React.createElement("select", {
        id: this.props.id
      }));
    }
  }]);

  return Select2;
}(React.Component);

_defineProperty(Select2, "propTypes", {
  /**
   * The id that is given to the select input
  <<example>>id="string"
   */
  id: PropTypes.string.isRequired,

  /**
   * The function to be executed when the value of the select2 has changed
  <<example>>callback={self.handleSelectChange}
   */
  callback: PropTypes.func.isRequired,

  /**
   * The options data that populate the component options
  <<example>>data={
    [
      "Option 1",
      "Option 2",
      "Option 3"
    ]
   }
   */
  data: PropTypes.array.isRequired,

  /**
   * The config object that is passed to the jQuery Select2 component
  <<example>>config={
    {
      placeholder: "Select a state",
      allowClear: true
    }
   }
   */
  config: PropTypes.object
});

var _default = Select2;
exports["default"] = _default;