"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var classNames = require('classnames');

var $ = require('jquery');
/**
 * <p>The Selectable Block component is a wrapper for the uifw Selectable Block and allows a div to become selected.
 * See <a href="http://internal-uifw/elements.html#buttons-selectable-block" target="_blank">Selectable Block</a> for more information.<p>
 */


var SelectableBlock =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SelectableBlock, _React$Component);

  function SelectableBlock() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SelectableBlock);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SelectableBlock)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      selected: _this.props.selected === true,
      disabled: _this.props.disabled === true
    });

    _defineProperty(_assertThisInitialized(_this), "_handleClick", function (event) {
      if (_this.state.disabled === true) {
        event.preventDefault();
      } else {
        _this.props.changeCallback(!_this.state.selected);

        _this.setState({
          selected: !_this.state.selected
        });
      }
    });

    return _this;
  }

  _createClass(SelectableBlock, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      this.setState({
        selected: nextProps.selected
      });
    }
  }, {
    key: "render",
    value: function render() {
      var isActive = this.state.selected === true ? "selected" : "";
      isActive += this.props.disabled === true ? " disabled" : "";
      var iconSrc = "/admin/Content/images/" + this.props.icon;
      var iconSrcSet = iconSrc.replace('.png', '@2x.png 2x');
      return React.createElement("div", {
        className: classNames("uifw-selectable-block", isActive),
        onClick: this._handleClick
      }, React.createElement("div", {
        className: "uifw-selectable-block__icon"
      }, React.createElement("img", {
        src: iconSrc,
        srcSet: iconSrcSet
      })), React.createElement("div", {
        className: "uifw-selectable-block__information"
      }, React.createElement("div", {
        className: "uifw-selectable-block__information__title"
      }, this.props.title), React.createElement("div", {
        className: "uifw-selectable-block__information__description"
      }, React.createElement("p", null, this.props.description))));
    }
  }]);

  return SelectableBlock;
}(React.Component);

_defineProperty(SelectableBlock, "propTypes", {
  /**
   * The selected property of the block
   <<example>>selected={true}
   */
  selected: PropTypes.bool.isRequired,

  /**
   * The title of the block
   <<example>>title="string"
   */
  title: PropTypes.string.isRequired,

  /**
   * The description of the block
   <<example>>description="string"
   */
  description: PropTypes.string.isRequired,

  /**
   * The icon that prepends the details of the block
   <<example>>icon="uifw-selectable-block__icon"
   */
  icon: PropTypes.string.isRequired,

  /**
   * The function to execute on selectable block click
   <<example>>changeCallback={self.handleSelectableBlockClick}
   */
  changeCallback: PropTypes.func,

  /**
   * Sets the functionality of the selectable block
   <<example>>disabled={false}
   */
  disabled: PropTypes.bool
});

var _default = SelectableBlock;
exports["default"] = _default;