"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');
/**
 * <p>The Side Navigation is used to organise a set of links under one category
 * See <a href="http://internal-uifw/elements.html#navigation-side-navigation" target="_blank">Side Navigation</a> for more information.<p>
 */


var SideNavigation =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SideNavigation, _React$Component);

  function SideNavigation() {
    _classCallCheck(this, SideNavigation);

    return _possibleConstructorReturn(this, _getPrototypeOf(SideNavigation).apply(this, arguments));
  }

  _createClass(SideNavigation, [{
    key: "render",
    value: function render() {
      if (this.props.children) {
        return React.createElement("nav", {
          className: "uifw-navigation " + this.props.navCssClass,
          "data-uifw-truncate": "true"
        }, React.createElement("header", {
          className: "uifw-navigation-header " + this.props.headerCssClass
        }, this.props.header), React.createElement("ul", {
          className: "uifw-navigation-content " + this.props.contentCssClass
        }, this.props.children));
      } else {
        return null;
      }
    }
  }]);

  return SideNavigation;
}(React.Component);

_defineProperty(SideNavigation, "defaultProps", {
  navCssClass: '',
  headerCssClass: '',
  contentCssClass: ''
});

_defineProperty(SideNavigation, "propTypes", {
  /**
     * The header for the navigation group
   <<example>>header="string"
     */
  header: PropTypes.string.isRequired,

  /**
     * The CSS class for the navigation group wrapper div
   <<example>>header="string"
     */
  navCssClass: PropTypes.string,

  /**
     * The CSS class for the navigation header div
   <<example>>headerCssClass="string"
     */
  headerCssClass: PropTypes.string,

  /**
     * The CSS class for the navigation content div
   <<example>>contentCssClass="string"
     */
  contentCssClass: PropTypes.string,

  /**
     * The list of links that populate navigation group
   <<example>><uifw.SideNavigation>
   *  <Links>...</Links>
   *</uifw.SideNavigation>
     */
  children: PropTypes.any
});

var _default = SideNavigation;
exports["default"] = _default;