"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types'); // External Libraries


var React = require('react');

var classnames = require('classnames');
/**
 * <p>The Sort Icon Component is a wrapper for the uifw sort icon. It changes direction of the sort icon when it is clicked.
 */


var SortIcon =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SortIcon, _React$Component);

  function SortIcon() {
    _classCallCheck(this, SortIcon);

    return _possibleConstructorReturn(this, _getPrototypeOf(SortIcon).apply(this, arguments));
  }

  _createClass(SortIcon, [{
    key: "render",
    value: function render() {
      var sortClass = this.props.ascending ? "uifw-icon-sort-up" : "uifw-icon-sort-down";
      if (!this.props.selected) sortClass = "uifw-icon-sort";
      return React.createElement("i", {
        className: classnames("uifw-icon", sortClass, this.props.additionalClasses)
      });
    }
  }]);

  return SortIcon;
}(React.Component);

_defineProperty(SortIcon, "propTypes", {
  /**
     * The selected property set the icon to sort (neither ascending or descending)
   <<example>>selected={true}
     */
  selected: PropTypes.bool.isRequired,

  /**
     * The ascending property defines the direction of the sort
   <<example>>ascending={false}
     */
  ascending: PropTypes.bool.isRequired,

  /**
     * The additional CSS classes that are added to the wrapping <code>i</code> tag
   <<example>>ascending={false}
     */
  additionalClasses: PropTypes.string
});

var _default = SortIcon;
exports["default"] = _default;