"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var ReactDOM = require('react-dom');

var $ = require('jquery');
/** This wraps a JQuery Sortable around child elements; when a child is dragged
* and dropped, this simply cancels the JQuery action, calls the onDrop callback,
* and assumes that the parent will change state and trigger a re-render.
* This is a modified version of <a href="http://jsfiddle.net/AngieHinrichs/kog0ur0u/5/" target="_blank">http://jsfiddle.net/AngieHinrichs/kog0ur0u/5/</a>
* The reason for hijacking the jquery ui events and passing the results back for
* react to handle is that if jquery is allowed to modify the DOM react won't track
* the changes. <a href="https://groups.google.com/forum/#!topic/reactjs/mHfBGI3Qwz4" target="_blank">https://groups.google.com/forum/#!topic/reactjs/mHfBGI3Qwz4</a>
*/


var returnData = null;

var Sortable =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Sortable, _React$Component);

  function Sortable() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Sortable);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Sortable)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "handleDrag", function (e, ui) {
      $(_assertThisInitialized(_this)).attr('data-previndex', ui.item.index());
    });

    _defineProperty(_assertThisInitialized(_this), "handleDrop", function (e, ui) {
      // tell JQuery to cancel, and call onDrop with the indexes.
      var newIndex = ui.item.index();
      var oldIndex = $(_assertThisInitialized(_this)).attr('data-previndex');
      $(_assertThisInitialized(_this)).removeAttr('data-previndex');
      returnData = _this.props.beforeCancelDrop({
        "new": newIndex,
        old: oldIndex,
        e: e,
        ui: ui,
        returnData: returnData
      }); //Counters a feature of firefox setting the attributes incorrectly on cancel.

      if (_this.props.options.axis === 'y') ui.item.css('left', 'auto');
      if (_this.props.options.axis === 'x') ui.item.css('top', 'auto');

      _this.$jq.sortable('cancel');

      _this.props.afterCancelDrop(returnData);

      returnData = null;
    });

    _defineProperty(_assertThisInitialized(_this), "handleUpdate", function (e, ui) {
      returnData = _this.props.handleUpdate({
        e: e,
        ui: ui,
        returnData: returnData
      });
    });

    return _this;
  }

  _createClass(Sortable, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var config = $.extend({}, this.props.options);
      config.start = this.handleDrag;
      config.update = this.handleUpdate;
      config.stop = this.handleDrop;
      this.$jq = $(ReactDOM.findDOMNode(this));
      this.$jq.sortable(config);
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: this.props.containerCss,
        "data-sortable-data": this.props.containerData,
        style: this.props.containerStyle
      }, this.props.children);
    }
  }]);

  return Sortable;
}(React.Component);

_defineProperty(Sortable, "defaultProps", {
  options: {},
  beforeCancelDrop: function beforeCancelDrop(sortableData) {
    return sortableData.returnData;
  },
  handleUpdate: function handleUpdate(sortableData) {
    return sortableData.returnData;
  },
  afterCancelDrop: function afterCancelDrop() {},
  containerCss: "",
  containerData: null,
  containerStyle: null
});

_defineProperty(Sortable, "propTypes", {
  /**
     * The function to execute on element drop
   <<example>>beforeCancelDrop={self.handleOrderChange}
     */
  beforeCancelDrop: PropTypes.func.isRequired,
  handleUpdate: PropTypes.func,

  /**
     * The function to execute after element drop
   <<example>>afterCancelDrop={self.handleOrderChangeAfter}
     */
  afterCancelDrop: PropTypes.func,

  /**
     * The options object that is used when building the component. For more information visit <a href="http://api.jqueryui.com/sortable/" target="_blank">jQuery Sortable</a>.
   <<example>>options={
   	{
  		scroll: true,
  		zIndex: 1
  	}
   }
     */
  options: PropTypes.object,

  /**
     * The container CSS classes
   <<example>>containerCss="string"
     */
  containerCss: PropTypes.string,

  /**
     * The string that is passed to the <code>data-sortable-data</code> attribute
   <<example>>containerData="string"
     */
  containerData: PropTypes.string,

  /**
     * The inline style object that is passed to the container wrapper div
   <<example>> containerStyle={
   	{
  		paddingTop: "20px",
  		color: "#000"
  	}
   }
     */
  containerStyle: PropTypes.object,

  /**
     * The contents of each row in the sortable
   <<example>><uifw.Sortable>
   *  <Row>...</Row>
   *  <Row>...</Row>
   *  <Row>...</Row>
   *</uifw.Sortable>
     */
  children: PropTypes.oneOfType([PropTypes.object, PropTypes.array])
});

var _default = Sortable;
exports["default"] = _default;