"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StarRating =
/*#__PURE__*/
function (_Component) {
  _inherits(StarRating, _Component);

  function StarRating() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, StarRating);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(StarRating)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onStarClick", function (i) {
      if (i === _this.props.value) {
        _this.props.onClick(0);
      } else {
        _this.props.onClick(i);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderStars", function () {
      var stars = [];

      var _loop = function _loop(i) {
        var starClass = "uifw-icon uifw-icon-star uifw-star-rating-star ".concat(i <= _this.props.value ? 'uifw-star-rating-star--selected' : '');
        stars.push(_react["default"].createElement("i", {
          id: "Star".concat(_this.props.rating - i + 1),
          key: "star".concat(i),
          className: starClass,
          onClick: function onClick() {
            _this.onStarClick(i);
          }
        }));
      };

      for (var i = _this.props.rating; i >= 1; i -= 1) {
        _loop(i);
      }

      return stars;
    });

    return _this;
  }

  _createClass(StarRating, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        id: this.props.wrapperId,
        className: (0, _classnames["default"])('uifw-star-rating', this.props.additionalWrapperCssClasses)
      }, this.renderStars());
    }
  }]);

  return StarRating;
}(_react.Component);

StarRating.propTypes = {
  wrapperId: _propTypes["default"].string,
  rating: _propTypes["default"].number,
  value: _propTypes["default"].number,
  onClick: _propTypes["default"].func.isRequired,
  additionalWrapperCssClasses: _propTypes["default"].string
};
StarRating.defaultProps = {
  rating: 5,
  value: 0,
  additionalWrapperCssClasses: null,
  wrapperId: null
};
var _default = StarRating;
exports["default"] = _default;