"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var classNames = require("classnames");
/**
 * <p>The Status Section Component is a react wrapper for the uifw status section.
 * See <a href="http://internal-uifw/elements.html#message-status-section" target="_blank">Status Sections</a> for more information.<p>
 */


var StatusSection =
/*#__PURE__*/
function (_React$Component) {
  _inherits(StatusSection, _React$Component);

  function StatusSection() {
    _classCallCheck(this, StatusSection);

    return _possibleConstructorReturn(this, _getPrototypeOf(StatusSection).apply(this, arguments));
  }

  _createClass(StatusSection, [{
    key: "render",
    value: function render() {
      var icon = this.props.icon;

      if (icon.indexOf("uifw-status-section-icon") < 0) {
        icon = classNames(icon, "uifw-status-section-icon");
      }

      return React.createElement("div", {
        className: "uifw-status-section"
      }, React.createElement("i", {
        className: icon
      }), React.createElement("div", {
        className: "uifw-status-section-content"
      }, this.props.children));
    }
  }]);

  return StatusSection;
}(React.Component);

_defineProperty(StatusSection, "propTypes", {
  /**
   * The icon class name that will be prepended to the section
   <<example>> icon="uifw-icon-standard uifw-icon-standard-check-circle small uifw-status-section-icon"
   */
  icon: PropTypes.string.isRequired
});

var _default = StatusSection;
exports["default"] = _default;