"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TableRow = _interopRequireDefault(require("../TableRow"));

var _TableCell = _interopRequireDefault(require("../TableCell"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * <p>The Table component is used with the '<b>TableRow.js</b>' and the '<b>TableCell.js</b>' to create a uifw div markup table.
 * See <a href="http://internal-uifw/elements.html#tables-data-table-divs" target="_blank">Table</a> for more information.<p>
 */
var Table =
/*#__PURE__*/
function (_Component) {
  _inherits(Table, _Component);

  function Table() {
    _classCallCheck(this, Table);

    return _possibleConstructorReturn(this, _getPrototypeOf(Table).apply(this, arguments));
  }

  _createClass(Table, [{
    key: "generateLoadingTable",
    value: function generateLoadingTable() {
      var headerRow = [];

      for (var i = this.props.loadingTable.columns - 1; i >= 0; i -= 1) {
        headerRow.push(_react["default"].createElement(_TableCell["default"], {
          key: "fakeHeader".concat(i)
        }, 'Error Loading Header'));
      }

      var bodyRows = [];

      for (var _i = this.props.loadingTable.rows - 1; _i >= 0; _i -= 1) {
        var bodyCells = [];

        for (var j = this.props.loadingTable.columns - 1; j >= 0; j -= 1) {
          bodyCells.push(_react["default"].createElement(_TableCell["default"], {
            key: "cell".concat(j)
          }, "Error Loading Data"));
        }

        bodyRows.push(_react["default"].createElement(_TableRow["default"], {
          key: "fakeRow".concat(_i)
        }, bodyCells));
      }

      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-table', this.props.additionalClasses)
      }, _react["default"].createElement(_TableRow["default"], {
        isHeader: true
      }, headerRow), bodyRows);
    }
  }, {
    key: "render",
    value: function render() {
      if (this.props.useLoadingTable && _react["default"].Children.count(this.props.children) <= 1) {
        return this.generateLoadingTable();
      }

      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('uifw-table', this.props.additionalClasses)
      }, this.props.children);
    }
  }]);

  return Table;
}(_react.Component);

Table.propTypes = {
  /**
   * The CSS classes that are applied to the table div
   <<example>>additionalClasses="string"
   */
  additionalClasses: _propTypes["default"].string,

  /**
   * The fake loading table data (to be used to display a table when the nbui is in place)
   <<example>>loadingTable={
     {
      columns={3}, // default is {5}
      rows="20" // default is {10}
    }
   }
   */
  loadingTable: _propTypes["default"].shape({
    columns: _propTypes["default"].number,
    rows: _propTypes["default"].number
  }),

  /**
   * Sets whether or not you want the loading table to be used
   <<example>>useLoadingTable={true}
   */
  useLoadingTable: _propTypes["default"].bool,

  /**
   * The form table row and table cell DOM elements to render
   <<example>><uifw.Table>
   *  <uifw.TableRow>
   *    <uifw.TableCell>...</uifw.TableCell>
   *    <uifw.TableCell>...</uifw.TableCell>
   *    <uifw.TableCell>...</uifw.TableCell>
   *  <uifw.TableRow>
   *</uifw.Table>
   */
  children: _propTypes["default"].node
};
Table.defaultProps = {
  additionalClasses: null,
  loadingTable: {
    columns: 5,
    rows: 10
  },
  useLoadingTable: true,
  children: null
};
var _default = Table;
exports["default"] = _default;