"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var classNames = require("classnames");

var $ = require("jquery");
/**
 * <p>The Tabs Component is a react wrapper for the uifw Tabs. The first element in the header array must correspond with first child, the second with the second etc.
 */


var Tabs =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Tabs, _React$Component);

  function Tabs() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Tabs);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Tabs)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      selectedIndex: 0
    });

    _defineProperty(_assertThisInitialized(_this), "_tabClick", function (tabIndex) {
      return function (e) {
        e.preventDefault();
        this.setState({
          selectedIndex: tabIndex
        });
      }.bind(_assertThisInitialized(_this));
    });

    _defineProperty(_assertThisInitialized(_this), "generateChildren", function () {
      var children = _this.props.children;

      if (!Array.isArray(children)) {
        children = [children];
      }

      return children.map(function (child, i) {
        return React.createElement("div", {
          className: classNames("tab", {
            "selected": i === this.state.selectedIndex
          }),
          key: i
        }, child);
      }.bind(_assertThisInitialized(_this)));
    });

    _defineProperty(_assertThisInitialized(_this), "generateHeadings", function () {
      return _this.props.headings.map(function (heading, i) {
        return React.createElement("li", {
          key: i,
          className: classNames({
            "selected": i === this.state.selectedIndex
          })
        }, React.createElement("a", {
          href: "#",
          onClick: this._tabClick(i)
        }, heading));
      }.bind(_assertThisInitialized(_this)));
    });

    return _this;
  }

  _createClass(Tabs, [{
    key: "render",
    value: function render() {
      if (!this.props.headings) return;
      return React.createElement("div", {
        className: "uifw-tabbed-layout"
      }, React.createElement("div", {
        className: "tabs"
      }, React.createElement("ul", null, this.generateHeadings())), React.createElement("div", {
        className: "tab-content"
      }, this.generateChildren()));
    }
  }]);

  return Tabs;
}(React.Component);

_defineProperty(Tabs, "propTypes", {
  /**
   * The array of tab headers
  <<example>>headings={
    [
      "Tab 1",
      "Tab 2",
      "Tab 3"
    ]
   }
   */
  headings: PropTypes.array.isRequired,

  /**
   * The corresponding children for each heading
   <<example>><uifw.Tabs>
   *  <p>Content 1</p>
   *  <p>Content 2</p>
   *  <p>Content 3</p>
   *</uifw.Tabs>
   */
  children: PropTypes.any
});

var _default = Tabs;
exports["default"] = _default;