"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = require('react');

var TextModifiers = {
  LinkTextGenerator: function LinkTextGenerator(inputString) {
    var textArray = [];
    var anchorStart = inputString.indexOf('<a');
    var anchorEnd = inputString.indexOf('</a>') + 4;
    var fullTag = inputString.substring(anchorStart, anchorEnd);
    var anchorTag = {
      href: fullTag.substring(fullTag.indexOf("href='") + 6, fullTag.lastIndexOf("'")),
      text: fullTag.substring(fullTag.indexOf(">") + 1, fullTag.indexOf("</"))
    };
    textArray.push(inputString.substring(0, anchorStart));
    textArray.push(React.createElement("a", {
      key: "link1",
      href: anchorTag.href,
      target: "_blank"
    }, anchorTag.text));
    textArray.push(inputString.substring(anchorEnd, inputString.length));
    return textArray;
  },
  generateProductFormHtml: function generateProductFormHtml(site, product) {
    var formHtml = '<form name="product" action="http://' + site + '/index.asp?function=CART&mode=ADD&productid=' + product.Id + '" method="post"> \n';

    if (Object.keys(product).length > 0) {
      var variantsCount = 0;
      var optionsCount = 0;

      for (var i = 0; i < product.ProductOptions.length; i++) {
        var option = product.ProductOptions[i];
        optionsCount++;

        if (option.Type !== 3) {
          formHtml += ' <table border="0">\n' + '  <tr>\n' + '   <td width="100" style="font-size:14px;">\n' + '    <b>' + option.Name + '</b>\n' + '   </td>\n\n';

          switch (option.Type) {
            // DROPDOWN 0
            case 0:
              if (option.OptionType === "OPTION") {
                formHtml += '   <td>\n' + '    <input type="hidden" name="optiontype_' + optionsCount + '" value="dropdown">\n' + '    <select name="options_' + optionsCount + '" maxlength="5">\n';
                option.Items.map(function (item) {
                  formHtml += '     <option value="' + item.Id + '">' + item.Name + '</option>\n';
                });
                formHtml += '    </select>\n' + '   </td>\n';
              } else if (option.OptionType === "VARIANT") {
                variantsCount++;
                optionsCount--;
                formHtml += '   <td>\n' + '    <select name="variant_' + option.Name.replace(/ /g, "_") + '" value="dropdown" maxlength="5" >\n';
                option.Items.map(function (item) {
                  formHtml += '     <option value="' + item.Name + '">' + item.Name + '</option>\n';
                });
                formHtml += '    </select>\n' + '   </td>\n';
              }

              break;
            // TEXT 1

            case 1:
              formHtml += '   <td>\n' + '    <input type="hidden" name="optiontype_' + optionsCount + '" value="text">\n' + '    <input type="text" size="25" name="options_' + optionsCount + '">\n' + '    <input type="hidden" size="25" name="options_' + optionsCount + '_TEXTBOX" value="' + option.Name + '">\n' + '   </td>\n';
              break;
            // TEXTAREA 2

            case 2:
              formHtml += '   <td>\n' + '    <input type="hidden" name="optiontype_' + optionsCount + '" value="textarea">\n' + '    <textarea name="options_' + optionsCount + '" rows="' + option.Size + '"></textarea>\n' + '    <input type="hidden" size="25" name="options_' + optionsCount + '_TEXTAREA" value="' + option.Name + '">\n' + '   </td>\n';
              break;
          }

          formHtml += '  </tr>\n' + ' </table>\n\n';
        }

        formHtml += '<input type="hidden" name="numberofoptions" value="' + (product.ProductOptions.length - variantsCount) + '">\n\n';
      }

      formHtml += '<input type="Submit" value="Add to Cart"> \n\n';
    }

    formHtml += '</form>';
    var escapedStr = escape(formHtml);
    var unescapedStr = unescape(escapedStr);
    return unescapedStr;
  }
};
var _default = TextModifiers;
exports["default"] = _default;