"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _jquery = _interopRequireDefault(require("jquery"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Validation = _interopRequireDefault(require("../../Utils/Validation"));

var _ValidationMessage = _interopRequireDefault(require("../../Utils/Validation/ValidationMessage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Entities = require('html-entities').XmlEntities;

var htmlDecode = new Entities().decode;
/**
 * <p>The Text Component is a react wrapper for the uifw Text Field.
 * The type can be set for a textbox but if you are wanting a password input then
 * please use the '<b>Password.js</b>' Component.
 * See <a href="http://internal-uifw/elements.html#form-els-text-fields" target="_blank">Text Fields</a> for more information.<p>
 */

var Text =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Text, _React$Component);

  function Text(props) {
    var _this;

    _classCallCheck(this, Text);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Text).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "changeValue", function (event) {
      if (_this.state.cssClass.indexOf('error') > -1 && _this.props.validation) _this.validate(event.target.value);
      if (_this.props.changeCallback) _this.props.changeCallback(event);
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeystroke", function (event) {
      if (!_this.props.validation) return;

      if (event.keyCode === 13) {
        var inputValue = (0, _jquery["default"])(_this.node).find('input')[0].value;

        var isValid = _this.validate(inputValue);

        if (!isValid.valid) {
          event.preventDefault();
        }
      }

      _this.node.getElementsByTagName('input')[0].setAttribute('data-formvalidationmessage', '');

      _this.setState({
        formValidationMessage: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function (event) {
      if (_this.props.validation) {
        _this.validate(event.target.value, true);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_clearValidation", function () {
      _this.clearValidation();
    });

    _defineProperty(_assertThisInitialized(_this), "clearValidation", function () {
      (0, _jquery["default"])(_this.node).find('input').removeAttr('data-formvalidationmessage');
      (0, _jquery["default"])(_this.node).find('input').removeData('validation');

      _this.setState({
        cssClass: _this.state.cssClass.replace('error', ''),
        validationObject: {
          valid: true
        },
        formValidationMessage: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "generateIconClasses", function (isPrefixIcon, isSuffixIcon) {
      var prefixClasses = {};
      prefixClasses['uifw-icon'] = true;
      prefixClasses['uifw-icon-text'] = !isPrefixIcon;

      if (_this.props.prefix) {
        prefixClasses[_this.props.prefix.substr(1, _this.props.prefix.length)] = isPrefixIcon;
      }

      prefixClasses['left-icon'] = true;
      var suffixClasses = {};
      suffixClasses['uifw-icon'] = true;
      suffixClasses['uifw-icon-text'] = !isSuffixIcon;
      suffixClasses['right-icon'] = true;
      return {
        prefix: prefixClasses,
        suffix: suffixClasses
      };
    });

    var cssClass = _this.props.additionalClasses || '';
    var isPrice = false;

    if (_this.props.validation) {
      isPrice = props.validation.map(function (v) {
        return v.action;
      }).indexOf('price') > -1;
    }

    _this.state = {
      cssClass: cssClass,
      inlineStyle: _this.props.styleOverride,
      validationObject: {
        valid: true
      },
      validationMsgInlineStyle: _this.props.validationStyleOverride,
      isPriceInput: isPrice,
      isInitialLoad: true,
      formValidationMessage: ''
    };
    return _this;
  }

  _createClass(Text, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      (0, _jquery["default"])(this.node).find('input').data('validation', this.props.validation);
      var component = this;
      (0, _jquery["default"])(this.node).find('input').on('updateValidationAttribute', function () {
        component.forceUpdate();
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.props.value !== '' && this.state.isInitialLoad && this.state.isPriceInput) {
        this.handleBlur({
          target: {
            value: this.props.value
          }
        });
        this.setState({
          isInitialLoad: false
        });
      }

      var formValidationMessage = this.node.getElementsByTagName('input')[0].getAttribute('data-formvalidationmessage');

      if (formValidationMessage !== this.state.formValidationMessage) {
        this.setState({
          formValidationMessage: formValidationMessage
        });
      }

      (0, _jquery["default"])(this.node).find('input').data('validation', this.props.validation);
    }
  }, {
    key: "validate",
    value: function validate(value) {
      var result = _Validation["default"].validateText(value, this.props.validation);

      var newClass = this.state.cssClass.replace(' error', '');

      if (!result.valid) {
        newClass = "".concat(newClass.trim(), " error");
      }

      this.setState({
        cssClass: newClass,
        validationObject: result
      });

      if (result.valid && this.state.isPriceInput) {
        var price = parseFloat(this.props.value).toFixed(2);

        if (isNaN(price)) {
          price = parseFloat(0).toFixed(2);
        }

        this.props.changeCallback({
          target: {
            value: price
          }
        });
      }

      return result;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var validationBottomMsg;
      var validationTopMsg;

      if (this.props.validation && !this.state.validationObject.valid || this.state.formValidationMessage && this.state.formValidationMessage !== '') {
        if (this.state.formValidationMessage && this.state.formValidationMessage !== '') {
          this.state.validationObject.errorMsg = this.state.formValidationMessage;

          if (this.state.cssClass.indexOf('error') < 0) {
            this.state.cssClass += ' error';
          }
        }

        var validationComponent = _react["default"].createElement(_ValidationMessage["default"], {
          message: this.state.validationObject.errorMsg,
          additionalClasses: this.props.validationCssClasses,
          styleOverride: this.state.validationMsgInlineStyle
        });

        if (this.props.validationCssClasses && this.props.validationCssClasses.indexOf('top') > -1) {
          validationTopMsg = validationComponent;
        } else {
          validationBottomMsg = validationComponent;
        }
      }

      var additionalClasses = this.props.additionalClasses ? this.props.additionalClasses.split(' ') : [];
      var newCss = this.state.cssClass.replace('readonly', '').replace('disabled', '');
      var disabled = additionalClasses && (additionalClasses.indexOf('disabled') > -1 || additionalClasses.indexOf('readonly') > -1);
      var hasBoth = this.props.prefix && this.props.suffix;
      var isPrefixIcon = this.props.prefix && this.props.prefix.indexOf('.uifw-icon-') > -1;
      var isSuffixIcon = this.props.suffix && this.props.suffix.indexOf('.uifw-icon-') > -1;
      var iconClasses = this.generateIconClasses(isPrefixIcon, isSuffixIcon);
      var standardValidationWrapper = this.props.disableValidationWrapper ? '' : 'uifw-validation-message-wrapper';
      var validationWrapper = (0, _classnames["default"])(standardValidationWrapper, {
        fw: additionalClasses.indexOf('fw') > -1
      }, this.props.validationWrapperCssClasses);
      var prefixImage = this.props.children === undefined && this.props.prefix ? _react["default"].createElement("i", {
        className: (0, _classnames["default"])(iconClasses.prefix)
      }, this.props.prefix && !isPrefixIcon ? htmlDecode(this.props.prefix) : null) : null;
      var suffixImage = this.props.children === undefined && this.props.suffix ? _react["default"].createElement("i", {
        className: (0, _classnames["default"])(iconClasses.suffix)
      }, this.props.suffix && isSuffixIcon ? _react["default"].createElement("i", {
        className: this.props.suffix.substr(1, this.props.suffix.length)
      }) : null, this.props.suffix && !isSuffixIcon ? htmlDecode(this.props.suffix) : null) : null;
      var uifwTextFieldWithIconCss = (0, _classnames["default"])({
        'uifw-text-field-with-icon': this.props.children === undefined && this.props.fieldEnd == null,
        'uifw-text-field-group': this.props.children !== undefined || this.props.fieldEnd != null,
        'icon-left': this.props.prefix && !hasBoth,
        'icon-right': this.props.suffix && !hasBoth,
        'icon-both': hasBoth,
        fw: additionalClasses.indexOf('fw') > -1
      });
      return _react["default"].createElement("div", {
        className: validationWrapper,
        ref: function ref(node) {
          _this2.node = node;
        }
      }, validationTopMsg, _react["default"].createElement("span", {
        className: uifwTextFieldWithIconCss,
        style: {
          visibility: this.props.visibility || 'visible'
        }
      }, this.props.fieldEnd !== null ? _react["default"].createElement("span", {
        className: "uifw-field-end"
      }, this.props.fieldEnd) : null, prefixImage, suffixImage, _react["default"].createElement("input", {
        id: this.props.inputId,
        className: (0, _classnames["default"])('uifw-text-field', newCss).trim(),
        onKeyDown: this.handleKeystroke,
        onChange: this.changeValue,
        onBlur: this.handleBlur,
        placeholder: this.props.placeholder,
        type: this.props.type,
        value: this.props.value,
        disabled: disabled,
        style: this.state.inlineStyle,
        maxLength: this.props.maxLength,
        readOnly: this.props.isReadOnly === true ? 'readonly' : null,
        min: this.props.min,
        max: this.props.max
      }), this.props.children), _react["default"].createElement("div", null, validationBottomMsg));
    }
  }]);

  return Text;
}(_react["default"].Component);

Text.propTypes = {
  /**
   * The type of the text input
     <<example>>type="text"
     *type="number"
     *type="email"
   */
  type: _propTypes["default"].string.isRequired,

  /**
   * The value of the input
     <<example>>value="string"
     *value={200}
     *value={false}
   */
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].bool]).isRequired,

  /**
   * The id that is to be passed to the input within the component
   <<example>>inputId="string"
   */
  inputId: _propTypes["default"].string,

  /**
   * The function to execute on text box value change
     <<example>>changeCallback={self.handleTextboxValueChange}
   */
  changeCallback: _propTypes["default"].func,

  /**
   * The additional CSS classes to be added to the input element
     <<example>>additionalClasses="string"
   */
  additionalClasses: _propTypes["default"].string,

  /**
   * The maximum length of the input
     <<example>>maxLength={50}
   */
  maxLength: _propTypes["default"].number,

  /**
   * The placeholder value of the input
     <<example>>placeholder="string"
   */
  placeholder: _propTypes["default"].string,

  /**
   * The prefix of the textbox. This can either be a character such as '£' or
   a uifw icon class such as 'uifw-icon-search'
     <<example>>prefix="£"
     *prefix="uifw-icon-search"
   */
  prefix: _propTypes["default"].string,

  /**
   * The suffix of the textbox. This can either be a character such as '%' or
    a uifw icon class such as 'uifw-icon-search'
     <<example>>suffix="%"
     *suffix="uifw-icon-search"
   */
  suffix: _propTypes["default"].string,

  /**
   * The inline style that is passed to the input element
     <<example>> styleOverride={
       {
        paddingTop: "20px",
        color: "#000"
      }
     }
   */
  styleOverride: _propTypes["default"].object,

  /**
   * An array of validation rules
     <<example>> validation={
       [
        {
          action: "required",
          errorMsg: "File is required."
        }
      ]
     }
   */
  validation: _propTypes["default"].array,

  /**
   * The additional CSS classes that are passed to the validation message div
     <<example>> validationCssClasses="string"
   */
  validationCssClasses: _propTypes["default"].string,

  /**
   * The inline style that is passed to the validation message div
     <<example>> validationStyleOverride={
       {
        paddingTop: "20px",
        color: "#000"
      }
     }
   */
  disableValidationWrapper: _propTypes["default"].bool,
  validationStyleOverride: _propTypes["default"].object,
  groupMember: _propTypes["default"].bool,
  visibility: _propTypes["default"].oneOf(['visible', 'hidden']),
  isReadOnly: _propTypes["default"].bool,
  validationWrapperCssClasses: _propTypes["default"].string,
  fieldEnd: _propTypes["default"].string
};
Text.defaultProps = {
  inputId: '',
  changeCallback: null,
  additionalClasses: '',
  placeholder: '',
  prefix: '',
  suffix: '',
  styleOverride: null,
  validationCssClasses: '',
  disableValidationWrapper: false,
  groupMember: false,
  visibility: 'visible',
  isReadOnly: false,
  validationWrapperCssClasses: '',
  fieldEnd: null
};
var _default = Text;
exports["default"] = _default;