"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ValidationMessage = _interopRequireDefault(require("../../Utils/Validation/ValidationMessage.js"));

var _Validation = _interopRequireDefault(require("../../Utils/Validation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var ReactDOM = require('react-dom');

var classNames = require('classnames');

var $ = require('jquery');
/**
 * <p>The TextArea Component is a react wrapper for the uifw TextArea Field.
 * See <a href="http://internal-uifw/elements.html#form-els-text-areas" target="_blank">Text Areas</a> for more information.<p>
 */


var TextArea =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TextArea, _React$Component);

  function TextArea() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TextArea);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TextArea)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      validationErrorMessage: ""
    });

    _defineProperty(_assertThisInitialized(_this), "_clearValidation", function () {
      $(ReactDOM.findDOMNode(_assertThisInitialized(_this))).find("textarea").removeAttr("data-formvalidationmessage");
      $(ReactDOM.findDOMNode(_assertThisInitialized(_this))).find("textarea").removeData("validation");

      _this.setState({
        validationErrorMessage: ""
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_handleBlur", function (event) {
      if (_this.props.validation) {
        _this._validate(event.target.value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_handleKeystroke", function (event) {
      if (_this.state.validationErrorMessage && _this.state.validationErrorMessage !== "") {
        _this._validate(event.target.value);
      }

      if (_this.props.callback) {
        _this.props.callback(event);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_validate", function (value) {
      console.log(_Validation["default"]);

      var result = _Validation["default"].validateText(value, _this.props.validation);

      var validationMessage = result.errorMsg ? result.errorMsg : "";
      ReactDOM.findDOMNode(_assertThisInitialized(_this)).getElementsByTagName('textarea')[0].setAttribute("data-formvalidationmessage", validationMessage);

      _this.setState({
        validationErrorMessage: validationMessage
      });

      return result;
    });

    return _this;
  }

  _createClass(TextArea, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var component = this;
      $(ReactDOM.findDOMNode(this)).find('textarea').data('validation', this.props.validation);
      $(ReactDOM.findDOMNode(this)).find('textarea').on("updateValidationAttribute", function (validationMessage) {
        component.forceUpdate();
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var formValidationMessage = ReactDOM.findDOMNode(this).getElementsByTagName('textarea')[0].getAttribute("data-formvalidationmessage");

      if (formValidationMessage && formValidationMessage !== this.state.validationErrorMessage) {
        this.setState({
          validationErrorMessage: formValidationMessage
        });
      }

      $(ReactDOM.findDOMNode(this)).find('textarea').data('validation', this.props.validation);
    }
  }, {
    key: "render",
    value: function render() {
      var validationMessage = this.state.validationErrorMessage && this.state.validationErrorMessage !== "" ? React.createElement(_ValidationMessage["default"], {
        message: this.state.validationErrorMessage,
        additionalClasses: classNames(this.props.validationCssClasses, "pull-right"),
        styleOverride: this.state.validationMsgInlineStyle
      }) : null;
      var placeholder = this.props.placeholder == null ? "" : this.props.placeholder;
      return React.createElement("div", null, React.createElement("div", {
        className: classNames("uifw-validation-message-wrapper", this.props.validationWrapperCssClasses)
      }, React.createElement("textarea", {
        id: this.props.inputId,
        className: classNames("uifw-text-area", this.props.startingHeightClass, this.props.additionalClasses, {
          "invalid": this.state.validationErrorMessage !== ""
        }),
        value: this.props.value,
        onChange: this._handleKeystroke,
        onBlur: this._handleBlur,
        placeholder: placeholder
      }), validationMessage));
    }
  }]);

  return TextArea;
}(React.Component);

_defineProperty(TextArea, "propTypes", {
  /**
     * The function to execute on text area value change
   <<example>>callback={self.handleTextareaValueChange}
     */
  callback: PropTypes.func.isRequired,

  /**
     * The value of the input
   <<example>>value="string"
     */
  value: PropTypes.string,

  /**
     * An array of validation rules
   <<example>> validation={
   	[
  		{
  			action: "required",
  			errorMsg: "File is required."
  		}
  	]
   }
     */
  validation: PropTypes.array,

  /**
     * The starting height class passed to the input
   <<example>>startingHeightClass="h-50" // Height of 50px
   *startingHeightClass="h-100" // Height of 100px
   *startingHeightClass="h-150" // Height of 150px
   *startingHeightClass="h-200" // Height of 200px
   *startingHeightClass="h-250" // Height of 250px
     */
  startingHeightClass: PropTypes.string,

  /**
     * The additional CSS classes to be added to the input element
   <<example>>additionalClasses="string"
     */
  additionalClasses: PropTypes.string,

  /**
     * The placeholder value of the input
   <<example>>placeholder="string"
     */
  placeholder: PropTypes.string,

  /**
     * The id of the textarea input control
   <<example>>inputId="string"
     */
  inputId: PropTypes.string,
  validationWrapperCssClasses: PropTypes.string
});

var _default = TextArea;
exports["default"] = _default;