"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");
/**
 * <p>The Text Field Group Component is a react wrapper for the uifw text field group.
 * See <a href="http://internal-uifw/elements.html#form-els-text-fields-groups" target="_blank">Text Field Group</a> for more information.<p>
 */


var TextFieldGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TextFieldGroup, _React$Component);

  function TextFieldGroup() {
    _classCallCheck(this, TextFieldGroup);

    return _possibleConstructorReturn(this, _getPrototypeOf(TextFieldGroup).apply(this, arguments));
  }

  _createClass(TextFieldGroup, [{
    key: "render",
    value: function render() {
      var content;
      var endField = React.createElement("span", {
        className: "uifw-field-end"
      }, this.props.endFieldText);

      if (this.props.endFieldText && this.props.endFieldText.length > 0) {
        if (!this.props.endFieldPosition || this.props.endFieldPosition.toLowerCase() === "left") {
          content = React.createElement("span", {
            className: "uifw-text-field-group"
          }, endField, this.props.children);
        } else {
          content = React.createElement("span", {
            className: "uifw-text-field-group"
          }, this.props.children, endField);
        }
      } else {
        content = React.createElement("span", {
          className: "uifw-text-field-group"
        }, this.props.children);
      }

      return content;
    }
  }]);

  return TextFieldGroup;
}(React.Component);

_defineProperty(TextFieldGroup, "propTypes", {
  /**
   * The value to fill the end text box. Leave blank if not using.
   <<example>> endFieldText="%"
   */
  endFieldText: PropTypes.string,

  /**
   * The location of the end text box
   <<example>> endFieldPosition="right"
   */
  endFieldPosition: PropTypes.string
});

var _default = TextFieldGroup;
exports["default"] = _default;