"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Text = _interopRequireDefault(require("../Text"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The TextWithEnableCheckbox Component is a react wrapper for the uifw Text Field with a related checkbox (usually controlling the visibility of the textbox or if it is enabled.
 * The type can be set for a textbox but if you are wanting a password input then please use the '<b>Password.js</b>' Component.
 * See <a href="http://internal-uifw/elements.html#form-els-text-fields" target="_blank">Text Fields</a> for more information on text fields and
 * see <a href="http://internal-uifw/elements.html#form-els-checkboxes" target="_blank">Checkbox Fields</a> for more information on checkboxes.<p>
 */
var TextWithCheckbox =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TextWithCheckbox, _React$Component);

  function TextWithCheckbox() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TextWithCheckbox);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TextWithCheckbox)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_clearValidation", function () {
      _this.clearValidation();
    });

    _defineProperty(_assertThisInitialized(_this), "clearValidation", function () {
      _this.refs.textInput.clearValidation();
    });

    return _this;
  }

  _createClass(TextWithCheckbox, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", null, _react["default"].createElement(_Text["default"], {
        ref: "textInput",
        inputId: this.props.inputId,
        type: this.props.type,
        value: this.props.value,
        changeCallback: this.props.textCallback,
        additionalClasses: this.props.additionalClasses,
        maxLength: this.props.maxLength,
        placeholder: this.props.placeholder,
        prefix: this.props.prefix,
        suffix: this.props.suffix,
        styleOverride: this.props.styleOverride,
        visibility: this.props.visibility === false ? 'hidden' : 'visible',
        validation: this.props.visibility === false ? [] : this.props.validation,
        validationCssClasses: this.props.validationCssClasses,
        validationStyleOverride: this.props.validationStyleOverride,
        groupMember: this.props.groupMember,
        disableValidationWrapper: true,
        fieldEnd: this.props.fieldEnd
      }), _react["default"].createElement(_Checkbox["default"], {
        id: this.props.checkboxId,
        callback: this.props.checkboxCallback,
        checked: this.props.checked,
        labelText: this.props.checkboxLabel,
        containerClass: "u-mt- u-fs-"
      }));
    }
  }]);

  return TextWithCheckbox;
}(_react["default"].Component);

_defineProperty(TextWithCheckbox, "propTypes", {
  /**
   * The type of the text input
     <<example>>type="text"
     *type="number"
     *type="email"
   */
  type: _propTypes["default"].string.isRequired,

  /**
   * The value of the input
     <<example>>value="string"
     *value={200}
     *value={false}
   */
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].bool]).isRequired,

  /**
     * The function to execute on text box value change
     <<example>>textCallback={self.handleTextboxValueChange}
     */
  textCallback: _propTypes["default"].func.isRequired,

  /**
    * The callback function to execute on checkbox click
    <<example>> checkboxCallback={self.handleCheckboxClick}
    */
  checkboxCallback: _propTypes["default"].func.isRequired,

  /**
    * The ID of the checkbox
    <<example>> checkboxId="string"
    */
  checkboxId: _propTypes["default"].string.isRequired,
  // Optional

  /**
   * The id that is to be passed to the input within the component
   <<example>>inputId="string"
   */
  inputId: _propTypes["default"].string,

  /**
     * The additional CSS classes to be added to the input element
     <<example>>additionalClasses="string"
     */
  additionalClasses: _propTypes["default"].string,

  /**
     * The maximum length of the input
     <<example>>maxLength={50}
     */
  maxLength: _propTypes["default"].number,

  /**
     * The placeholder value of the input
     <<example>>placeholder="string"
     */
  placeholder: _propTypes["default"].string,

  /**
     * The prefix of the textbox. This can either be a character such as '£' or a uifw icon class such as 'uifw-icon-search'
     <<example>>prefix="£"
     *prefix="uifw-icon-search"
     */
  prefix: _propTypes["default"].string,

  /**
     * The suffix of the textbox. This can either be a character such as '%' or a uifw icon class such as 'uifw-icon-search'
     <<example>>suffix="%"
     *suffix="uifw-icon-search"
     */
  suffix: _propTypes["default"].string,

  /**
     * The inline style that is passed to the input element
     <<example>> styleOverride={
       {
        paddingTop: "20px",
        color: "#000"
      }
     }
     */
  styleOverride: _propTypes["default"].object,

  /**
     * The visibility of the input. When set to false, textbox will be invisible. Any other value, textbox will be visible.
     <<example>>visibility={true}
     */
  visibility: _propTypes["default"].bool,

  /**
     * An array of validation rules. Validation rules will not be applied to an invisible textbox.
     <<example>> validation={
       [
        {
          action: "required",
          errorMsg: "File is required."
        }
      ]
     }
     */
  validation: _propTypes["default"].array,

  /**
     * The additional CSS classes that are passed to the validation message div
     <<example>> validationCssClasses="string"
     */
  validationCssClasses: _propTypes["default"].string,

  /**
     * The inline style that is passed to the validation message div
     <<example>> validationStyleOverride={
       {
        paddingTop: "20px",
        color: "#000"
      }
     }
     */
  validationStyleOverride: _propTypes["default"].object,
  groupMember: _propTypes["default"].bool,

  /**
     * The value of the checkbox
     <<example>> checked={true}
     */
  checked: _propTypes["default"].bool,

  /**
     * The text in the label of the checkbox
     <<example>> checkboxLabel={'string'}
     */
  checkboxLabel: _propTypes["default"].string,

  /**
     * The text of the field end
     <<example>> checkboxLabel={'string'}
     */
  fieldEnd: _propTypes["default"].string
});

var _default = TextWithCheckbox;
exports["default"] = _default;