"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require("react");

var classnames = require("classnames");
/**
 * A selectable thumbnail component to match the uifw.
 * <a href="http://internal-uifw/elements.html#images-thumbnail">Internal Documentation</a>
 <example><uifw.SelectableThumbnail
 	src="http://someuri/file1.png"
	selectable={true}
	selected={this.state.isSelected}
	description="file1.png" />
 */


var SelectableThumbnail =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SelectableThumbnail, _React$Component);

  function SelectableThumbnail() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SelectableThumbnail);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SelectableThumbnail)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_onClick", function (e) {
      e.preventDefault();

      if (_this.props.onClick != null) {
        _this.props.onClick(_this.props.src);
      }
    });

    return _this;
  }

  _createClass(SelectableThumbnail, [{
    key: "render",
    value: function render() {
      /* NOTE: Using "display: inline-block" on the image rather than ib class
      because it is more specific than the "uifw-thumbnail > img" class, which
      sets "display: block" */
      return React.createElement("div", {
        className: "u-ta-c"
      }, React.createElement("div", {
        className: classnames("uifw-thumbnail", {
          "selectable": this.props.selectable,
          "selected": this.props.selected
        }),
        onClick: this._onClick
      }, React.createElement("a", {
        href: "#",
        className: "fw",
        style: {
          height: "100%"
        }
      }, React.createElement("img", {
        src: this.props.src,
        className: "u-img-fh",
        style: {
          "display": "inline-block"
        }
      }))), React.createElement("div", {
        className: "u-fs-- u-tc-base fw cf"
      }, this.props.description));
    }
  }]);

  return SelectableThumbnail;
}(React.Component);

_defineProperty(SelectableThumbnail, "propTypes", {
  // Required

  /**
   * The uri to the image to be displayed.
   */
  src: PropTypes.string.isRequired,
  // Optional

  /**
   * Called when the image is clicked.
   */
  onClick: PropTypes.func,

  /**
   * If set to false, just displays the thumbnail with no selection border.
   */
  selectable: PropTypes.bool,

  /**
   * Changes the selection border based on its value.
   */
  selected: PropTypes.bool,

  /**
   * A short string to describe the thumbnail. For example, file name.
   */
  description: PropTypes.string
});

var _default = SelectableThumbnail;
exports["default"] = _default;