"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var ReactDOM = require('react-dom');

var $ = require('jquery');

var classNames = require('classnames');
/**
 * <p>The ToggleSwitch Component is a react wrapper for the uifw Toggle Switch Field.
 * <<warning>>This should no longer be used when developing any application.
 * See <a href="http://internal-uifw/elements.html#form-els-toggle-switches" target="_blank">Toggle Switches</a> for more information.<p>
 */


var ToggleSwitch =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ToggleSwitch, _React$Component);

  function ToggleSwitch() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ToggleSwitch);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ToggleSwitch)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "getInputNode", function (domNode) {
      return $($(domNode)[0]).children()[0];
    });

    _defineProperty(_assertThisInitialized(_this), "getToggleSwitchDiv", function (domNode) {
      return $($(domNode)[0]).children()[1];
    });

    _defineProperty(_assertThisInitialized(_this), "setCheckedValue", function (domNode, checked) {
      if (checked || parseInt(checked)) {
        _this.getInputNode(domNode).setAttribute("checked", "checked");

        $(_this.getToggleSwitchDiv(domNode)).addClass('checked');
      } else {
        _this.getInputNode(domNode).removeAttribute("checked");

        $(_this.getToggleSwitchDiv(domNode)).removeClass('checked');
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_isDocumentReadyComplete", function () {
      return document.readyState === "complete";
    });

    _defineProperty(_assertThisInitialized(_this), "_onChange", function (event) {
      _this.props.callback(event);
    });

    return _this;
  }

  _createClass(ToggleSwitch, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.checked !== undefined) {
        $(this.getInputNode(ReactDOM.findDOMNode(this))).uifwFrmSwitch();
        $(this.getInputNode(ReactDOM.findDOMNode(this))).change(this._onChange);
        this.setCheckedValue(ReactDOM.findDOMNode(this), this.props.checked);

        if (this.props.checked === true) {
          $(this.getInputNode(ReactDOM.findDOMNode(this))).uifwFrmSwitch('doOn');
        }

        if (this.props.inputId) {
          this.getInputNode(ReactDOM.findDOMNode(this)).id = this.props.inputId + "Input";
          var toggleSwitchDiv = $('div.uifw-toggle-switch', ReactDOM.findDOMNode(this).parentNode)[0];
          toggleSwitchDiv.id = this.props.inputId + "Div";
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.setCheckedValue(ReactDOM.findDOMNode(this), this.props.checked);
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: classNames(this.props.containerCssClass)
      }, React.createElement("input", {
        id: this.props.id,
        type: "checkbox",
        value: this.props.value,
        className: this.props.type
      }));
    }
  }]);

  return ToggleSwitch;
}(React.Component);

_defineProperty(ToggleSwitch, "defaultProps", {
  checked: false,
  value: false,
  containerCssClass: ""
});

_defineProperty(ToggleSwitch, "propTypes", {
  /**
   * The function to execute on toggle switch click
   <<example>>callback={self.handleToggleSwitchClick}
   */
  callback: PropTypes.func.isRequired,

  /**
   * The checkstate of the toggle switch
  	 <<example>> checked={true}
   */
  checked: PropTypes.bool,

  /**
   * The value of the toggle switch
   <<example>>value={false}
   */
  value: PropTypes.bool,

  /**
   * The type of toggle switch to display
   <<example>>type="on-off"
   *type="show-hide"
   *type="generic"
   *type="generic small"
   */
  type: PropTypes.string,

  /**
   * The CSS Class of the wrapping DIV element
  	 <<example>> containerCssClass="testClass"
   */
  containerCssClass: PropTypes.string,

  /**
   * The id of the div that is displayed on screen
  	 <<example>> inputId="string"
   */
  inputId: PropTypes.string
});

var _default = ToggleSwitch;
exports["default"] = _default;