"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _jquery = _interopRequireDefault(require("jquery"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * <p>The TreeView Component is a react wrapper for the uifw JSTree control.
 * See <a href="http://internal-uifw/elements.html#navigation-jstree" target="_blank">JSTree</a> for more information.
 * View the original JSTree documentation <a href="https://www.jstree.com/">here</a>.<p>
 */
var TreeView =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TreeView, _React$Component);

  function TreeView() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TreeView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TreeView)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "initialiseTreeView", function () {
      (0, _jquery["default"])(_reactDom["default"].findDOMNode(_assertThisInitialized(_this))).uifwJSTree({
        "core": {
          "themes": _this.props.themes,
          "data": _this.props.data,
          "multiple": _this.props.multiple
        }
      }).on("changed.jstree", function BindTreeViewChangeHandler(e, data) {
        if (this.props.onChange) this.props.onChange(e, data);
      }.bind(_assertThisInitialized(_this))).on("ready.jstree", function SetComponentStateToReady(e, data) {
        if (this.props.onReady) this.props.onReady(e, data);
      }.bind(_assertThisInitialized(_this)));
    });

    return _this;
  }

  _createClass(TreeView, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initialiseTreeView();
    }
  }, {
    key: "UNSAFE_componentWillUpdate",
    value: function UNSAFE_componentWillUpdate(nextProps) {
      if (this.props.dataComparer(this.props.data, nextProps.data)) {
        (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).jstree(true).settings.core.data = nextProps.data;
        (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).jstree('refresh', true);
      } else {
        if (nextProps.selectChildren) {
          var nodes = (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).jstree("get_top_selected", true);

          if (nodes.length > 0) {
            nodes.forEach(function NodeLoop(node, i) {
              (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).jstree("select_node", node.children_d, true, true);
            }.bind(this));
          }
        }

        if (nextProps.selectAll) {
          if ((0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).jstree("get_selected").length === nextProps.data.length) {
            (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).jstree("deselect_all");
          } else {
            (0, _jquery["default"])(_reactDom["default"].findDOMNode(this)).jstree("select_all");
          }
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])("uifw-jstree", this.props.wrapperCssClass)
      });
    }
  }]);

  return TreeView;
}(_react["default"].Component);

_defineProperty(TreeView, "defaultProps", {
  dataComparer: function DefaultDataComparer(thisData, nextData) {
    return thisData != nextData;
  },
  multiple: true
});

_defineProperty(TreeView, "propTypes", {
  /**
   * The data to populate the js tree with
   <<example>>data={
     [
      { "id" : "ajson1", "parent" : "#", "text" : "Simple root node" },
      { "id" : "ajson2", "parent" : "#", "text" : "Root node 2" },
      { "id" : "ajson3", "parent" : "ajson2", "text" : "Child 1" },
      { "id" : "ajson4", "parent" : "ajson2", "text" : "Child 2" }
    ]
   }
   */
  data: _propTypes["default"].array.isRequired,

  /**
   * The function that is executed when the 'changed.jstree' event is run
   <<example>>onChange={self.handleTreeViewChanged}
   */
  onChange: _propTypes["default"].func,

  /**
   * The function that is executed when the 'ready.jstree' event is run
   <<example>>onChange={self.handleTreeViewReady}
   */
  onReady: _propTypes["default"].func,

  /**
   * The CSS class added to the js tree wrapper
   <<example>>wrapperCssClass="string"
   */
  wrapperCssClass: _propTypes["default"].string,

  /**
   * The theme object that is passed to the jstree, see <a href="https://www.jstree.com/api/#/?q=theme">theme docs</a>
   <<example>>themes={
     {
      name: "string",
      dots: false
    }
   }
   */
  themes: _propTypes["default"].object,

  /**
  * The boolean value the user can set. If true, when the user clicks a tree node, all of it's children are also selected.
  <<example>>selectChildren={false}
  */
  selectChildren: _propTypes["default"].bool,

  /**
  * The boolean value that if set to true, will select every node in the tree. Although this can be achieved by selecting the very top parent, it allows the developer to programmatically select all tree nodes.
  <<example>>selectChildren={false}
  */
  selectAll: _propTypes["default"].bool,

  /**
  *<p>The function the programmer uses to compare new data to old data. It either provides a default "!=" object compare (enough for stax settings) or the developer can add their own if that isn't good enough.
  *<<example>>dataComparer={self.compareJsTreeData}
  */
  dataComparer: _propTypes["default"].func,
  multiple: _propTypes["default"].bool
});

var _default = TreeView;
exports["default"] = _default;