"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * <p>The UnorderedList Component creates an unordered list with the provided children. The children should be '<b>ListItem.js</b>' components. Supports lists with icons.
 * See <a href="http://internal-uifw/elements.html#misc-icon-list" target="_blank">Icon List</a> for more information.<p>
 */
var UnorderedList =
/*#__PURE__*/
function (_Component) {
  _inherits(UnorderedList, _Component);

  function UnorderedList(props) {
    _classCallCheck(this, UnorderedList);

    return _possibleConstructorReturn(this, _getPrototypeOf(UnorderedList).call(this, props));
  }

  _createClass(UnorderedList, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement("ul", {
        ref: this.props.refCallback,
        style: this.props.style,
        className: (0, _classnames["default"])({
          'uifw-icon-ul': this.props.isIconList
        }, this.props.additionalClasses)
      }, this.props.children);
    }
  }]);

  return UnorderedList;
}(_react.Component);

UnorderedList.propTypes = {
  /**
   * Display a list with icons inplace of the standard circle icons
  	<<example>>isIconList={true}
   */
  isIconList: _propTypes["default"].bool,

  /**
   * The additional CSS classes that are passed to the table row
  	<<example>>additionalClasses={'u-mb-'}
   */
  additionalClasses: _propTypes["default"].string,

  /**
   * If provided, this function will be called with the UnorderedList's reference
  	<<example>>refCallback={(ref) => {this.referencedComponent = ref;}}
   */
  refCallback: _propTypes["default"].func,

  /**
   * The style object for when you need to add style directly to the unordered list
  	<<example>>style={{listStyleType: 'none', padding: '0px', margin: '0px'}}
   */
  style: _propTypes["default"].object
};
var _default = UnorderedList;
exports["default"] = _default;