"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PropTypes = require('prop-types');

var React = require('react');

var classNames = require('classnames');
/**
 * <p>The Validation Message Component is a react component that displays a validation message on screen and is usually included with a control.
 * The control and validation message must be wrapped in a div with the class '<b>.uifw-validation-message-wrapper</b>' in order to get the floating version of the message to work correctly.
 * See <a href="http://internal-uifw/elements.html#form-els-validation" target="_blank">Validation Messages</a> for more information.
 */


var ValidationMessage =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ValidationMessage, _React$Component);

  function ValidationMessage() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ValidationMessage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ValidationMessage)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      styleOverride: _this.props.styleOverride
    });

    return _this;
  }

  _createClass(ValidationMessage, [{
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: classNames("uifw-validation-message", this.props.additionalClasses),
        style: this.state.styleOverride
      }, this.props.message);
    }
  }]);

  return ValidationMessage;
}(React.Component);

_defineProperty(ValidationMessage, "propTypes", {
  /**
   * The additional CSS classes to be added to the wrapping div
   <<example>>additionalClasses="string"
   */
  additionalClasses: PropTypes.string,

  /**
   * The validation message to be displayed
   <<example>>message="string"
   */
  message: PropTypes.string,

  /**
     * The inline style that is passed to the wrapping div
   <<example>> style={
   	{
  		paddingTop: "20px",
  		color: "#000"
  	}
   }
     */
  styleOverride: PropTypes.object
});

var _default = ValidationMessage;
exports["default"] = _default;